cseg segment para public code
   assume cs:cseg,ds:dseg,es:dseg
      dd  -1                       ;0
      dw  8000h                    ;4
D6    dw  strategey                ;6
d8    dw  0c1h                     ;8
      db  'PFAILSYS',0,0,0,0       ;a
d12   dw  0
d14   dw  0
      db  9h dup (0)              ;16
      dw  0b4h                     ;28
      db  13 dup(0)                ;2a
D37   db  ' Power Failure     Detected     ',0   ; 37h
D58   db  'Power Fail shut-down in '  ;58h
      DB  'progress',02,65,73,73-00,50,6F,77,65,72,20,46
d78   DB  'Power Fail shut-down Complete  ',0,0,0,0,0
workarea proc  far
strategey:
        MOV     cs:d12,BX
        MOV     cs:d14,ES
        RET
interrupt:
        PUSHF
        PUSH    BX
        PUSH    ES
        CS:
        LES     BX,dword ptr cs:d12
        ES:
        OR      WORD PTR [BX+03],8003h
        ES:
        OR      WORD PTR [BX+03],0100h
        POP     ES
        POP     BX
        POPF
        RET
N01C1:
; this is the initialization routine
        PUSHF
        DB      60     ; not an 88 instruction?
        PUSH    DS
        PUSH    ES
        PUSH    CS
        POP     DS
        LES     BX,cs:d12
        MOV     AL,es:[BX+02]
        CMP     AL,00
        JZ      N01E4
        CMP     AL,08
        JZ      N01E9
        CMP     AL,09
        JZ      N01E9
        ES:
        OR      WORD PTR [BX+03],8003h
        JMP     N01EC

N01E4:
        CALL    N052D

        JMP     short N01EC

N01E9:
        CALL    N01F7

N01EC:
        OR      WORD PTR es:[BX+03],0100h
        POP     ES
        POP     DS
        DB      61    ; non 88 instruction
        POPF
        RETF

N01F7:
; called routine
        PUSH    ES
        PUSH    BX
        LES     BX,es:[BX+0Eh]
        CMP     WORD PTR es:[BX],+04
        MOV     WORD PTR es:[BX],0003
        JNZ     0219
        LEA     AX,[011Ch]
        MOV     es:[BX+02],AX
        MOV     es:[BX+04],CS
        MOV     WORD PTR es:[BX],0000
N0219:  POP     BX            
        POP     ES
        RET         ; near return

N021C:  PUSH    BX     
        PUSH    DS     
        PUSH    BP     
        PUSH    CS     
        POP     DS      
        MOV     BP,es:[BX]
        SHL     BP,1
        MOV     AX,0003
        CMP     BP,0010
        JA      n0234
        CALL    cs:[BP+0138h]
n0234:  POP     BP
        POP     DS
        POP     BX
        RETF
workarea  endp
utils  proc  near
N0238:  DEC     AX     
N0239:  ADD     [BX+DI+01],SP        
N023C:  NOP     
N023D:  ADD     [BX+0D801h],DI
N0241:  ADD     DX,DI         
N0243:  ADD     [3B02h],SP
N0247:  ADD     AH,[BX+DI+0026h]
N024C:  MOV     es:[BX+02],AX
N024F:  MOV     AX,[001Ah]
N0253:  MOV     es:[BX+04],AX
N0256:  MOV     AX,[0020h]
N025A:  MOV     es:[BX+06],AX
N025D:  MOV     AX,0000       
N0260:  RET     
;
N0261:  PUSH    DX     
        MOV     AX,[0016h]
        MOV     DX,es:[BX+04]
        MOV     [0016],DX
        MOV     es:[BX+04],AX
        MOV     AX,[0018h]
        MOV     DX,es:[BX+06]
        MOV     [0018h],DX
        MOV     es:[BX+06],AX
        INC     WORD PTR [001Ah]
        MOV     AX,[0026h]
        MOV     es:[BX+02],AX
        MOV     AX,0000
        POP     DX
        RET
;
N0290:  PUSH    DX     
        MOV     AX,[001Ch]
        MOV     DX,es:[BX+04]
        MOV     [001Ch],DX
        MOV     es:[BX+04],AX
        MOV     AX,[001Eh]
        MOV     DX,es:[BX+06]
        MOV     [001Eh],DX
        MOV     es:[BX+06],AX
        INC     WORD PTR [0020h]
        MOV     AX,[0026h]
        MOV     es:[BX+02],AX
        MOV     AX,0000
        POP     DX
        RET
;
N02BF:  MOV     AX,es:[BX+04]
        MOV     [0022h],AX
        MOV     AX,es:[BX+06]
        MOV     [0024h],AX
        MOV     AX,[0026h]
        MOV     es:[BX+02],AX
        MOV     AX,0000
        RET

N02D8:  DEC     WORD PTR [001Ah]
        JG      02E1
        JMP     043B
N02E1:  MOV     AX,[0026h]
N02E4:  ES:     
N02E5:  MOV     [BX+02],AX    
N02E8:  MOV     AX,[001Ah]
N02EB:  ES:     
N02EC:  MOV     [BX+04],AX    
N02EF:  MOV     AX,[0020h]
N02F2:  ES:     
N02F3:  MOV     [BX+06],AX    
N02F6:  MOV     AX,0000       
N02F9:  RET     
N02FA:  DEC     WORD PTR [0020h]
N02FE:  JG      030D          
N0300:  CMP     WORD PTR [001Ah],+00
N0305:  JG      030Ah         
N0307:  JMP     043B          
N030A:  CALL    040F          
N030D:  MOV     AX,[0026h]
N0310:  ES:     
N0311:  MOV     [BX+02],AX    
N0314:  MOV     AX,[001Ah]
N0317:  ES:     
N0318:  MOV     [BX+04],AX    
N031B:  MOV     AX,[0020h]
N031E:  ES:     
N031F:  MOV     [BX+06],AX    
N0322:  MOV     AX,0000       
N0325:  RET     
N0326:  ES:     
N0327:  MOV     AX,[BX+02]    
N032A:  MOV     [0026h],AX
N032D:  CALL    040F          
N0330:  MOV     AX,[0026h]
N0333:  ES:     
N0334:  MOV     [BX+02],AX    
N0337:  MOV     AX,0000       
N033A:  RET     
N033B:  ES:     
N033C:  MOV     AX,[BX+02]    
N033F:  MOV     [0026],AX     
N0342:  CALL    03EAh         
N0345:  MOV     AX,[0026h]
N0348:  ES:     
N0349:  MOV     [BX+02],AX    
N034C:  MOV     AX,0000       
N034F:  RET     
N0350:  MOV     DX,0320h
N0353:  IN      AX,DX         
N0354:  AND     AX,0EFFFh
N0357:  OUT     DX,AX         
N0358:  CS:     
N0359:  CALL    FAR [0022h]
N035D:  RET     
N035E:  PUSH    AX     
N035F:  PUSH    DX     
N0360:  CS:     
N0361:  MOV     AX,[0028h]
N0364:  CMP     AX,0000       
N0367:  JNZ     036E          
N0369:  CALL    03A0          
N036C:  JMP     038B          
N036E:  PUSH    SI     
N036F:  LEA     SI,[0037h]
N0373:  CALL    038E          
N0376:  POP     SI     
N0377:  MOV     DX,0012h
N037A:  MUL     DX     
N037C:  CS:     
N037D:  MOV     [002Ah],AX
N0380:  CS:     
N0381:  MOV     [002Ch],DX
N0385:  MOV     AL,0FFh
N0387:  CS:     
N0388:  MOV     [002Eh],AL
N038B:  POP     DX     
N038C:  POP     AX     
N038D:  RETF           
N038E:  PUSH    AX     
N038F:  PUSH    DS     
N0390:  PUSH    CS     
N0391:  POP     DS     
N0392:  MOV     AH,04         
N0394:  INT     7Ch
N0396:  POP     DS     
N0397:  POP     AX     
N0398:  RET     
N0399:  PUSH    AX     
N039A:  MOV     AH,01         
N039C:  INT     7Ch
N039E:  POP     AX     
N039F:  RET     
N03A0:  PUSH    AX     
N03A1:  PUSH    DS     
N03A2:  PUSH    CS     
N03A3:  POP     DS     
N03A4:  MOV     DX,0320h
N03A7:  IN      AX,DX         
N03A8:  AND     AX,0020h
N03AB:  CMP     AX,0000       
N03AE:  JZ      n03BD
N03B0:  CALL    n0399
N03B3:  CLI     
N03B4:  IN      AL,A1         
N03B6:  AND     AL,0DFh
N03B8:  OUT     A1,AL         
N03BA:  STI     
N03BB:  JMP     n03E7
N03BD:  PUSH    SI     
N03BE:  LEA     SI,[0058h]
N03C2:  CALL    n038E
N03C5:  POP     SI     
N03C6:  MOV     WORD PTR [0026h],0001
N03CC:  CMP     WORD PTR [0020h],+00
N03D1:  JLE     n03D8
N03D3:  CALL    n03EA
N03D6:  JMP     n03E7
N03D8:  CMP     WORD PTR [001Ah],+00
N03DD:  JLE     n03E4
N03DF:  CALL    n040F
N03E2:  JMP     n03E7
N03E4:  JMP     n043B
N03E6:  NOP     
N03E7:  POP     DS     
N03E8:  POP     AX     
N03E9:  RET     
N03EA:  PUSH    AX     
N03EB:  CS:     
N03EC:  MOV     [009Ah],SS
N03F0:  CS:     
N03F1:  MOV     [009Ch],SP
N03F5:  MOV     AX,CS         
N03F7:  MOV     SS,AX         
N03F9:  MOV     SP,0413h
N03FC:  PUSH    BX     
N03FD:  PUSH    ES     
N03FE:  CS:     
N03FF:  JMP     FAR [001Ch]
N0403:  POP     ES     
N0404:  POP     BX     
N0405:  MOV     SS,[009Ah]
N0409:  MOV     SP,[009Ch]
N040D:  POP     AX     
N040E:  RET     
N040F:  PUSH    AX     
N0410:  CS:     
N0411:  MOV     [009Ah],SS
N0415:  CS:     
N0416:  MOV     [009Ch],SP
N041A:  MOV     AX,CS         
N041C:  MOV     SS,AX         
N041E:  MOV     SP,0413h
N0421:  PUSH    BX     
N0422:  PUSH    ES     
N0423:  PUSH    CS     
N0424:  POP     ES     
N0425:  ES:     
N0426:  INC     WORD PTR [0026h]
N042A:  CS:     
N042B:  JMP     FAR [0016h]
N042F:  POP     ES     
N0430:  POP     BX     
N0431:  MOV     SS,[009Ah]
N0435:  MOV     SP,[009Ch]
N0439:  POP     AX     
N043A:  RET     
N043B:  CLI     
N043C:  PUSH    CS     
N043D:  POP     DS     
N043E:  CS:     
N043F:  INC     WORD PTR [0026h]
N0443:  LEA     SI,[0079h]
N0447:  CALL    n038E
N044A:  MOV     CX,0020h
N044D:  MOV     AL,[SI]       
N044F:  MOV     BL,00         
N0451:  MOV     AH,0E         
N0453:  INT     10     
N0455:  INC     SI     
N0456:  LOOP    n044D
N0458:  MOV     DX,0320h
N045B:  IN      AX,DX         
N045C:  AND     AX,0020h
N045F:  CMP     AX,0000       
N0462:  JZ      n0469
N0464:  CS:     
N0465:  JMP     FAR [0373h]
N0469:  MOV     DX,0320h
N046C:  IN      AX,DX         
N046D:  OR      AX,1000h
N0470:  OUT     DX,AX         
N0471:  JMP     n0471
N0473:  LOCK           
N0474:  INC     WORD PTR [BX+SI]     
N0476:  LOCK           
N0477:  PUSH    AX     
N0478:  PUSH    DX     
N0479:  MOV     DX,0320h
N047C:  IN      AX,DX         
N047D:  AND     AX,0020h
N0480:  CMP     AX,0000       
N0483:  JNZ     n0496
N0485:  IN      AL,A1         
N0487:  OR      AL,20         
N0489:  OUT     A1,AL         
N048B:  MOV     AL,20         
N048D:  OUT     A0,AL         
N048F:  OUT     20,AL         
N0491:  CALL    n0350
N0494:  JMP     n049C
N0496:  MOV     AL,20         
N0498:  OUT     A0,AL         
N049A:  OUT     20,AL         
N049C:  POP     DX     
N049D:  POP     AX     
N049E:  IRET           
N049F:  CS:     
N04A0:  CMP     BYTE PTR [002En],0FFh
N04A5:  JNZ     n04CE
N04A7:  CS:     
N04A8:  SUB     WORD PTR [002Ah],+01
N04AD:  CS:     
N04AE:  SBB     WORD PTR [002Ch],+00
N04B3:  CS:     
N04B4:  CMP     WORD PTR [002Ch],+00
N04B9:  JNZ     04CE          
N04BB:  CS:     
N04BC:  CMP     WORD PTR [002Ah],+00
N04C1:  JNZ     n04CE
N04C3:  CALL    n03A0
N04C6:  PUSH    AX     
N04C7:  MOV     AL,00         
N04C9:  CS:     
N04CA:  MOV     [002Eh],AL
N04CD:  POP     AX     
N04CE:  CS:     
N04CF:  JMP     FAR [002Fh]
utils  endp
 dw  32  dup(0)
N0513:  PUSH    AX     
N0514:  PUSH    DX     
N0515:  MOV     DX,0320h
N0518:  IN      AX,DX         
N0519:  TEST    AX,0002h
N051C:  POP     DX     
N051D:  POP     AX     
N051E:  JZ      n0524
N0520:  CALL    n0350
N0523:  IRET           
N0524:  CS:     
N0525:  JMP     FAR [0429h]
N0529:  ADD     [BX+SI],AL    
N052B:  ADD     [BX+SI],AL    
N052D:  PUSH    DS     
N052E:  CALL    n0745
N0531:  CALL    n07D5
N0534:  CMP     AX,0FFFFh
N0537:  JZ      n053C
N0539:  JMP     n062D
N053C:  MOV     AX,CS         
N053E:  MOV     [0018h],AX
N0541:  MOV     [001Eh],AX
N0544:  MOV     [0024h],AX
N0547:  LEA     AX,[032Fh]
N054B:  MOV     [0016h],AX
N054E:  LEA     AX,[0303h]
N0552:  MOV     [001Ch],AX
N0555:  LEA     AX,[025Eh]
N0559:  MOV     [0022h],AX
N055C:  XOR     AX,AX         
N055E:  MOV     [001Ah],AX
N0561:  MOV     [0020h],AX
N0564:  MOV     WORD PTR [0026h],0000
N056A:  XOR     AX,AX         
N056C:  MOV     DS,AX         
N056E:  MOV     AX,[01D4h]
N0571:  CS:     
N0572:  MOV     [0033h],AX
N0575:  MOV     AX,[01D6h]
N0578:  CS:     
N0579:  MOV     [0035h],AX
N057C:  LEA     AX,[0377h]
N0580:  CLI     
N0581:  MOV     [01D4h],AX
N0584:  MOV     AX,CS         
N0586:  MOV     [01D6h],AX
N0589:  IN      AL,A1         
N058B:  AND     AL,0DFh
N058D:  OUT     A1,AL         
N058F:  STI     
N0590:  CS:     
N0591:  CMP     WORD PTR [0028h],+00
N0596:  JZ      n05B4
N0598:  MOV     AX,[0070h]
N059B:  CS:     
N059C:  MOV     [002Fh],AX
N059F:  MOV     AX,[0072h]
N05A2:  CS:     
N05A3:  MOV     [0031h],AX
N05A6:  LEA     AX,[039Fh]
N05AA:  CLI     
N05AB:  MOV     [0070h],AX
N05AE:  MOV     AX,CS         
N05B0:  MOV     [0072h],AX
N05B3:  STI     
N05B4:  LEA     AX,[0413h]
N05B8:  LEA     DX,[0565h]
N05BC:  CALL    n0800
N05BF:  LEA     DX,[0588h]
N05C3:  CALL    n0800
N05C6:  LEA     SI,[0548h]
N05CA:  CALL    n038E
N05CD:  CS:     
N05CE:  CMP     BYTE PTR [06FBh],0FFh
N05D3:  JNZ     n0602
N05D5:  MOV     AL,80h
N05D7:  OUT     h70,AL
N05D9:  MOV     AX,[0008]     
N05DC:  CS:     
N05DD:  MOV     [0429h],AX
N05E0:  MOV     AX,[000Ah]
N05E3:  CS:     
N05E4:  MOV     [042Bh],AX
N05E7:  LEA     AX,[0413h]
N05EB:  MOV     [0008],AX     
N05EE:  MOV     AX,CS         
N05F0:  MOV     [000Ah],AX
N05F3:  MOV     AL,00         
N05F5:  OUT     70h,AL
N05F7:  LEA     DX,[05C4h]
N05FB:  CALL    n0800
N05FE:  LEA     AX,[042Dh]
N0602:  PUSH    AX     
N0603:  MOV     DX,0320h
N0606:  IN      AX,DX         
N0607:  AND     AX,0020h
N060A:  CMP     AX,0000       
N060D:  JNZ     n061A
N060F:  CLI     
N0610:  IN      AL,A1         
N0612:  OR      AL,20h
N0614:  OUT     0A1h,AL
N0616:  STI     
N0617:  CALL    n0350
N061A:  POP     AX     
N061B:  ES:     
N061C:  MOV     [BX+0Eh],AX
N061F:  MOV     AX,CS         
N0621:  ES:     
N0622:  MOV     [BX+10h],AX
N0625:  XOR     AL,AL         
N0627:  ES:     
N0628:  MOV     [BX+0Dh],AL
N062B:  POP     DS     
N062C:  RET     
N062D:  LEA     AX,[00A9h]
N0631:  CS:     
N0632:  MOV     [0008],AX     
N0635:  LEA     AX,[00C1h]
N0639:  MOV     AL,58h
N063B:  CS:     
N063C:  MOV     [000Ah],AL
N063F:  LEA     DX,[0601h]
N0643:  CALL    n0800
N0646:  JMP     n061B
  ; data here
d0640   db  '   Pfail.sys       ver 1.3',0
d0643   db  'a',0,'Power Fail Driver.  Version 1.3$a$',13,10
        db  'Copyright (c) 3Com Corporation 1987'
        db  'All rights reserved',13,10,$
        db  "Debug Mode. Push 'ATTN' button to simulate a"
        db  ' Power Fail...',13,10,'$'
        db  13,10,'ERROR! Power Fail Driver could not load. '
        db  'Machine not suported.',13,10,'$'
;
N0745:  DB      60    ; odd opcode
N0746:  PUSH    DS     
N0747:  MOV     CX,0050       
N074A:  ES:     
N074B:  LDS     SI,[BX+12]    
N074E:  CALL    07C1          
N0751:  JB      07AE          
N0753:  CMP     AL,20         
N0755:  JNZ     074E          
N0757:  CALL    07C1          
N075A:  JB      07AE          
N075C:  CMP     AL,20         
N075E:  JZ      0757          
N0760:  CMP     AL,2F         
N0762:  JNZ     0777          
N0764:  CALL    07C1          
N0767:  JB      07AE          
N0769:  AND     AL,DF         
N076B:  CMP     AL,44         
N076D:  JNZ     074E          
N076F:  MOV     AL,FF         
N0771:  CS:     
N0772:  MOV     [06FB],AL     
N0775:  JMP     074E          
N0777:  XOR     BX,BX         
N0779:  SUB     AL,30         
N077B:  CMP     AL,09         
N077D:  JA      074E          
N077F:  XOR     AH,AH         
N0781:  CS:     
N0782:  MOV     [0028],AX     
N0785:  CALL    07C1          
N0788:  JB      07AE          
N078A:  CMP     AL,20         
N078C:  JZ      0757          
N078E:  SUB     AL,30         
N0790:  CMP     AL,09         
N0792:  JA      07A7          
N0794:  MOV     BL,AL         
N0796:  CS:     
N0797:  MOV     AX,[0028]     
N079A:  MOV     DX,000Ah      
N079D:  MUL     DX     
N079F:  ADD     AX,BX         
N07A1:  CS:     
N07A2:  MOV     [0028],AX     
N07A5:  JMP     0785          
N07A7:  MOV     AX,00B4       
N07AA:  CS:     
N07AB:  MOV     [0028],AX     
N07AE:  CS:     
N07AF:  CMP     WORD PTR [0028],0DD4        
N07B5:  JB      07BE          
N07B7:  MOV     AX,0DD4       
N07BA:  CS:     
N07BB:  MOV     [0028],AX     
N07BE:  POP     DS     
N07BF:  DB      61     
N07C0:  RET     
N07C1:  LODSB          
N07C2:  CMP     AL,0D         
N07C4:  JZ      07D3          
N07C6:  CMP     AL,0Ah        
N07C8:  JZ      07D3          
N07CA:  DEC     CX     
N07CB:  CMP     CX,+00        
N07CE:  JB      07D3          
N07D0:  CLC     
N07D1:  JMP     07D4          
N07D3:  STC     
N07D4:  RET     
N07D5:  PUSH    CX     
N07D6:  PUSH    SI     
N07D7:  PUSH    DI     
N07D8:  PUSH    ES     
N07D9:  PUSH    DS     
N07DA:  MOV     AX,F000       
N07DD:  MOV     DS,AX         
N07DF:  MOV     SI,ED00       
N07E2:  PUSH    CS     
N07E3:  POP     ES     
N07E4:  MOV     DI,06FC       
N07E7:  MOV     CX,0004       
N07EA:  NOP     
N07EB:  REPZ           
N07EC:  CMPSB          
N07ED:  MOV     AX,FFFF       
N07F0:  JCXZ    07F5          
N07F2:  MOV     AX,0000       
N07F5:  POP     DS     
N07F6:  POP     ES     
N07F7:  POP     DI     
N07F8:  POP     SI     
N07F9:  POP     CX     
N07FA:  RET     
N07FB:  ADD     [BP+DI],DH    
N07FD:  INC     BX     
N07FE:  DEC     DI     
N07FF:  DEC     BP     
N0800:  PUSH    AX     
N0801:  PUSH    DS     
N0802:  PUSH    CS     
N0803:  POP     DS     
N0804:  MOV     AH,09         
N0806:  INT     21     
N0808:  POP     DS     
N0809:  POP     AX     
N080A:  RET     
N080B:  PUSH    AX     
N080C:  PUSH    BX     
N080D:  PUSH    CX     
N080E:  PUSH    DX     
N080F:  MOV     BX,AX         
N0811:  MOV     CX,2710       
N0814:  CALL    0834          
N0817:  MOV     CX,03E8       
N081A:  CALL    0834          
N081D:  MOV     CX,0064       
N0820:  CALL    0834          
N0823:  MOV     CX,000Ah       
N0826:  CALL    n0834          
N0829:  MOV     CX,0001       
N082C:  CALL    n0834          
N082F:  POP     DX     
N0830:  POP     CX     
N0831:  POP     BX     
N0832:  POP     AX     
N0833:  RET     
N0834:  MOV     AX,BX         
N0836:  XOR     DX,DX         
N0838:  DIV     CX     
N083A:  AND     AX,000Fh       
N083D:  PUSH    AX     
N083E:  ADD     AL,30h         
N0840:  MOV     DL,AL         
N0842:  MOV     AH,02         
N0844:  INT     21     
N0846:  POP     AX     
N0847:  MUL     CX     
N0849:  SUB     BX,AX         
N084B:  RET     
N084C:  SUB     [7400h],AL   
cseg   ends
       end  
