setstar  macro x,row,star
         mov dh,windy&x
         mov dl,windx&x
         mov bx,row
         mov al,star
         mov ah,color&x
         call clstar
         endm
extrn unres:near
extrn inepson:byte,force_gra:near
public sound,print1,print2,prtsc
public intcs,intip,keyboard
extrn  pscreen:near
public baud,databits,parity,comport
public printswap,int5,int5cs,int5ip
public psemaphore,semaphore
public imbed_mode
extrn printint:near,epsone1:byte,epsone2:byte
extrn setres:near
extrn clstar:near
extrn p_gotac:near,
public int17,int17ip,int17cs,int17sip,int17scs
extrn getwind:near,retwind:near,getcurs:near,retcurs:near
extrn putprint:near,getop:near,blop:near,blip:near
extrn printerc:word
public window2
public rows,windy,windx,cols,bhpage,color,hidey,hidex,cursor,printer
public sound,cursmode,opt12,gra_mode,epsonem1
extrn f8:near,wsaveh:byte,psresol:byte
if1
    include C:cmacros.asm
endif
cSEG        SEGMENT PARA PUBLIC 'CODE'
        assume cs:cseg,ds:cseg,es:cseg
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        setres                       ;COM FILE ENTRY ALWAYS AT 100H
; data areas
         db 'Copyright 1987 by',13,10
Signature db 'Keith P. Graham',13,10,'238 Germonds Rd.',13,10
         db 'W. Nyack, NY 10994',13,10
         db '(914) 623-4161',13,10
;
;
; begin the font window
;
;
rows2    equ 19
cols2    equ 29
windx2   equ  5
windy2   equ 00
color2   equ 47h
hidex2   equ windx2+(cols2/2)+1
hidey2   equ windy2+rows2
window2  db  '͵ Cartridge B ͻ' ;  201 ,205,187
         db  '                           ' ; 186
         db  ' F1 Courier 12p Medium     ' ; 186
         db  ' F2 Helv 14.4p Bold        ' ; 186
         db  ' F3 Tms Rmn 10p Medium     ' ; 186
         db  ' F4 Tms Rmn 10p Bold       ' ; 186
         db  ' F5 Tms Rmn 10p Med Italic ' ; 186
         db  ' F6 Tms Rmn 8p Light       ' ; 186
         db  ' F7 Line Pr. 8.5p Light    ' ; 186
         db  ' F8 Courier 12p Medium     ' ; 186
         db  ' F1-F6 = Portrait Modes    ' ; 186
         db  ' F7,F8 = Landscape Modes   ' ; 186
         db  '                           ' ; 186
         db  '                           ' ; 186
         db  ' Use CLFONT to install     ' ; 186
         db  ' other cartridges          ' ; 186
         db  '      Esc  =  EXIT         ' ; 186
         db  ' *=Most Recently Selected  ' ; 186
         db  'ͼ' ; 200,205,188
optmax   dw  8
opttab   db  3bh,3ch,3dh,3eh,3fh,40h,41h,42h  ; 12 options
         db  0,0,0,0
opt12    db  27,'(8U&l0O(s0p10h12v0s0b3T',6 dup(0)
opt22    db  27,'&l0O(0U(s1p14.4v0s1b4T',7 dup(0)
opt32    db  27,'&l0O(0U(s1p10v0s0b5T',9 dup(0)
opt42    db  27,'&l0O(0U(s1p10v0s1b5T',9 dup(0)
opt52    db  27,'&l0O(0U(s1p10v1s0b5T',9 dup(0)
opt62    db  27,'&l0O(0U(s1p8.0v0s-1b5T',7 dup(0)
opt72    db  27,'(8U&l1O(s0p16.66h8.5v0s-1b0T',0
opt82    db  27,'(8U&l1O(s0p10h12v0s0b3T',6 dup(0)
         db  32 dup(0)
         db  32 dup(0)
         db  32 dup(0)
         db  32 dup(0)
opt13    db  ')8U&l0O)s0p10h12v0s0b3T',6 dup( 0)
opt23    db  '&l0O)0U)s1p14.4v0s1b4T',7 dup(0)
opt33    db  '&l0O)0U)s1p10v0s0b5T',9  dup(0)
opt43    db  '&l0O)0U)s1p10v0s1b5T',9  dup(0)
opt53    db  '&l0O)0U)s1p10v1s0b5T',9  dup(0)
opt63    db  '&l0O)0U)s1p8.0v0s-1b5T',7 dup(0)
opt73    db  ')8U&l1O)s0p16.66h8.5v0s-1b0T',0
opt83    db  ')8U&l1O)s0p10h12v0s0b3T',6 dup(0)
         db  32 dup(0)
         db  32 dup(0)
         db  32 dup(0)
         db  32 dup(0)
;
;
;  end of font window
;
;
; window 1
rows1    equ 15
cols1    equ 28
windx1   equ 45
windy1   equ 2
color1   equ 1fh
hidex1   equ windx1+(cols1/2)
hidey1   equ windy1+rows1
wsave1 dw rows1*cols1 dup(0)
rows     dw 0
cols     dw 0
windx    db 0
windy    db 0
color    db 0
hidex    db 0
hidey    db 0
window1  db  '͵ Main Menu ͻ' ;  201,181,205,198,187
         db  ' Resident Hewlett-Packard ' ; 186
         db  ' LaserJet Control Program ' ; 186
         db  '    by Keith P. Graham    ' ; 186
         db  ' F1 Help                  ' ; 186
         db  ' F2 Select Cartridge Font ' ; 186
         db  ' F3 Set Font Attributes   ' ; 186
         db  ' F4 Reset LaserJet        ' ; 186
         db  ' F5 Set Translation Modes ' ; 186
         db  ' F6 Toggle sound on/off   ' ; 186
         db  ' F7 Graphic PrtSc Modes   ' ; 186
         db  ' F8 Port Assignment       ' ; 186
         db  ' F9 Other Printer Options ' ; 186
         db  ' F10     EXIT             ' ; 186
         db  'ͼ' ; 200,205,188
opt4     db 'E',0
sound    db  0
epsonmode db 1
ocursor   dw 0
printer  dw 0
cursor   dw  0
cursmode dw  0
bhpage   db  0
interrupt dd  0
intip    equ word ptr interrupt
intcs    equ word ptr interrupt + 2
semaphore db  0
psemaphore db  0
int5      dd  0
int5ip   equ word ptr int5
int5cs   equ word ptr int5 + 2
resol     db  '*t75R'
startrast db  '*r0A'
transrast db  '*b80W'
endrast   db  '*rB'
prtsc     db  1
stack     db  'bottom of stack'
          dw  128 dup(0)
          db  'Top of stack'
savess    dw  0
savesp    dw  0
saveax    dw  0
imbed_mode db 0
START        PROC        NEAR
keyboard:
        jmp   short  kbentry  ;2 bytes
kbenter2:
        push bx
        push cx
        push dx
        push si
        push di
        push ds
        push es
        cld
        sti
        jmp  kbenter3
kbentry:
; we are entering here due to a key being struck
; first check the keyboard area to see if the CTRL and ALT are pressed
;
        pushf
 ; let keyboard do its thing
        call cs:[interrupt]
        push ax
        mov  al,1
lock    xchg cs:semaphore,al
        test al,al
        jz  contkb
        pop  ax
        iret
contkb:
        pop  ax
        cmp cs:inepson,0
        je contkb2
        mov cs:semaphore,0
        iret
contkb2:
        mov  cs:saveax,ax
        mov  ah,2
        int  16h
        and  al,0ah
        cmp  al,0ah
        je   gotac
goback:
        mov  ax,cs:saveax
        mov  cs:semaphore,0
;return to wherever
        iret
gotac:
   ; check to see if the next key to come in is L or l
        mov  ah,1
        int  16h
        cmp  ax,2600h
        je   goforit
        cmp  ax,2200h  ; is it a print screen?  G
        je   do_g_screen
        cmp  ax,1900h  ; is it a print screen?  P
        jne  no_key
        mov  ah,0
        int  16h
        mov  ax,cs:saveax
        mov  cs:semaphore,0
        jmp  pscreen
do_g_screen:
        mov  ah,0
        int  16h
        mov  ax,cs:saveax
        mov  cs:semaphore,0
        jmp  force_gra
no_key:
        jmp  goback
goforit:
; save the world
        mov  cs:savess,ss
        mov  cs:savesp,sp
        mov  ax,cs
        cli
        mov  ss,ax
        mov  sp,offset cs:stack+254
        sti
        jmp  kbenter2
kbenter3:
        sti
        mov  ah,0
        int  16h
        push  cs
        pop   ds
        push  cs
        pop   es
;determine if its a graphics screen
        push  si
        push  di
        mov  ah,15
        int  10h
        pop   di
        pop   si
        push  cs
        pop   ds
        push  cs
        pop   es
; ah has mode
; al has coloumns
; bh has page
        cmp  al,4
        jl   p_gotas
        cmp  al,6
        jg   p_gotas
ngscreen:
; we can't do it on a graphics screen
        jmp  get_out
p_gotas:
;
; first get the cursor location
        call getcurs
        mov  ax,cursor
        mov  ocursor,ax
        dowindowm 1
getchar:
        cmp sound,0
        je  gotsound
        setstar 1,10,'*'
        jmp  gc2
gotsound:
        setstar 1,10,' '
        jmp  gc2
jtable1: jmp func1
         jmp func2
         jmp func3
         jmp func4
         jmp func5
         jmp func6
         jmp func7
         jmp func8
         jmp func9
         jmp func10
nochar:
        call blop
gc2:
        call blip
        call getop
        cmp  al,27
        jne no27
goback_1:
        jmp  exit_prog
no27:
        push ax
        setstar 1,8,' '
        pop  ax
        cmp  inepson,0
        jne  goback_1
        cmp  ah,3bh
        jl nochar
        cmp  ah,44h
        jg  nochar
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable1
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func1:
;determine if its a 40 column screen
        push  si
        push  di
        mov  ah,15
        int  10h
        pop  di
        pop  si
        push  cs
        pop   ds
        push  cs
        pop   es
; ah has mode
; al has coloumns
; bh has page
        cmp  al,2
        jl  nof1
        call  f8
        jmp   getchar
nof1:   jmp   nochar
func2:
        call  f2
        jmp   getchar
func3:
        call  f3
        jmp   getchar
func4:
        doprint  4
        setstar 1,8,'*'
        mov   primary,0
        mov   alternate,0
        jmp   getchar
func5:
        call  f4
        jmp   getchar
func6:
        xor   sound,1
        jmp   getchar
func7:
        call  f7
        jmp   getchar
func8:
;determine if its a 40 column screen
        call  f1
        jmp   getchar
func9:
        call  f9
        jmp   getchar
func10:
        jmp  exit_prog
exit_prog:
        unwindm  1
        mov  ax,ocursor
        mov  cursor,ax
        call retcurs
get_out:
        pop  es
        pop  ds
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
; reset ss
        sti
        mov  ss,cs:savess
        mov  sp,cs:savesp
        cli
        mov  ax,cs:saveax
        mov  cs:semaphore,0
        iret
START        ENDP
; callable routines
;
;
;
;window 10 (window 1)
rows10   equ 12
cols10   equ 31
windx10  equ 03
windy10  equ 01
color10  equ 6fh
hidex10  equ windx10+(cols10/2)+1
hidey10  equ windy10+rows10
window10 db  '͵ Port Redirection ͻ' ;  201 ,205,187
         db  ' F1 Reset to Startup Setting ' ; 186
         db  ' F2 LPT1  directed to COM1   ' ; 186
         db  ' F3 LPT2  directed to COM1   ' ; 186
         db  ' F4 LPT1  directed to COM2   ' ; 186
         db  ' F5 LPT2  directed to COM2   ' ; 186
         db  ' F6 Swap LPT1: and LPT2:     ' ; 186
         db  ' F7 Initialize COM1 to 9600b ' ; 186
         db  ' F8 Initialize COM2 to 9600b ' ; 186
         db  ' F9 Print test line to LPT1: ' ; 186
         db  ' F10      Exit               ' ; 186
         db  'ͼ' ; 200,205,188
opttest  db  13,10,10,'This is a test of lpt1: settings',13,10
         db  'line..........................',13,10
         db  'line..........................',13,10
         db  'line..........................',13,10
         db  'line..........................',13,10
         db  'tabs',13,10
         db  '....|....1....|....2....|....3....|....4'
         db  '....|....5....|....6....|....7....|....8'
         db  13,10
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  9,'^'
         db  13,10,12
          db 0
int17     dd  0
int17ip   equ word ptr int17
int17cs   equ word ptr int17 + 2
int17s    dd  0
int17sip   equ word ptr int17s
int17scs   equ word ptr int17s + 2
print1 dw  0000h
print2 dw  0fffh
printswap db 0
comport  db 0
baud      db 11100000b
parity    db 0
databits  db  00000011b
lastcc    db 0
f1           PROC        NEAR
        call getcurs
        dowindow 10
        jmp getchar1
jtable11: jmp func11
         jmp func21
         jmp func31
         jmp func41
         jmp func51
         jmp func61
         jmp func71
         jmp func81
         jmp func91
         jmp func101
getchar1:
        setstar 10,2,' '
        setstar 10,3,' '
        setstar 10,4,' '
        setstar 10,5,' '
        setstar 10,6,' '
        setstar 10,7,' '
        cmp  printswap,0
        je   ns102
        setstar 10,7,'*'
        jmp ns104
ns102:
        cmp  print1,0fffh
        jne  ns104
        cmp  print2,0fffh
        jne  ns106
        cmp  printswap,0
        jne  ns103
        setstar 10,2,'*'
ns103:
        jmp  gc21
ns104:
; check print1 for which port
         cmp  print1,0
         jne  ns105
        setstar 10,3,'*'
         jmp  ns106
ns105:
         cmp  print1,1
         jne  ns106
        setstar 10,5,'*'
ns106:
         cmp  print2,0
         jne  ns107
        setstar 10,4,'*'
         jmp  gc21
ns107:
         cmp  print2,1
         jne  ns108
        setstar 10,6,'*'
ns108:
        jmp  gc21
nochar1:
        call blop
gc21:
        call blip
        call getop
        cmp  al,27
        jne no271
        jmp  exit_1
no271:
        cmp  ah,3bh
        jl nochar1
        cmp  ah,44h
        jg  nochar1
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable11
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func11:
;  we must stop all redirection
;
        mov   print1,0fffh
        mov   print2,0fffh
        mov   printswap,0
; now show star
        jmp   getchar1
func21:
;  we must redirect output from lpt1: to com1:
;
        mov   print1,0
; now show star
        jmp   getchar1
func31:
;  we must redirect output from lpt2: to com1:
;
        mov   print2,0
; now show star
        jmp   getchar1
func41:
;  we must redirect output from lpt1: to com2:
;
        mov   print1,1
; now show star
        jmp   getchar1
func51:
;  we must redirect output from lpt2: to com2:
;
        mov   print2,1
; now show star
        jmp   getchar1
func61:
; swap printers
        cmp   printswap,0
        je    unswap
        mov   printswap,0
        jmp   getchar1
unswap:
        mov   printswap,1
        jmp   getchar1
func71:
        mov  al,parity
        or   al,baud
        or   al,databits
        mov  ah,0
        mov  dl,0
        mov  dh,0
        int  14h
        jmp   getchar1
func81:
        mov  al,parity
        or   al,baud
        or   al,databits
        mov  ah,0
        mov  dl,1 ; comport
        mov  dh,0
        int  14h
        jmp   getchar1
func91:
        lea   si,opttest
        call  putprint
        jmp   getchar1
func101:
        jmp  exit_1
exit_1:
        unwind  10
        call retcurs
       ret
f1     endp
;
; choice 2   window  F
;
rowsf    equ 6
colsf    equ 40
windxf   equ 12
windyf   equ 00
colorf   equ 2fh
hidexf   equ windxf+(colsf/2)+1
hideyf   equ windyf+rowsf
windowf  db  '͵ Select Primary or Alternate Font ͻ' ;  201 ,205,187
         db  ' F1  Selection applies to Primary     ' ; 186
         db  ' F2  Selection applies to Alternate   ' ; 186
         db  ' F10 Exit                             ' ; 186
         db  ' *=Most Recently Selected             ' ; 186
         db  'ͼ' ; 200,205,188
f_sel   db 0
g_sel   db 0
f2     proc  near
        call getcurs
        dowindow f
        setstar f,2,' '
        setstar f,3,' '
        cmp   f_sel,1
        je    pri_star
        setstar f,2,'*'
        jmp  gc2f
pri_star:
        setstar f,3,'*'
        jmp  gc2f
jtable1f: jmp func1f
         jmp func2f
         jmp nocharf
         jmp nocharf
         jmp nocharf
         jmp nocharf
         jmp nocharf
         jmp nocharf
         jmp nocharf
         jmp func10f
nocharf:
        call blop
gc2f:
        call blip
        call getop
        cmp  al,27
        jne no27f
        jmp  exit_f
no27f:
        cmp  ah,3bh
        jl nocharf
        cmp  ah,44h
        jg  nocharf
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable1f
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func1f:
        mov  f_sel,0
        unwind   f
        call retcurs
        call  f2a
        jmp   f2
func2f:
        mov  f_sel,1
        unwind   f
        call retcurs
        call  f2a
        jmp   f2
func10f:
        jmp  exit_f
exit_f:
        unwind  f
        call retcurs
       ret
f2     endp
;
; this procedure decides primary or alternate fonts
;
;window 2
primary  db 0
pri_mode db  '  Primary Character Set    ' ; 186
sec_mode db  '  Alternate Character Set  ' ; 186
alternate db 0
f2a    proc  near
        call getcurs
        mov  cx,cols2
        lea  si,pri_mode
        cmp  f_sel,0
        je   m_mode2
        lea  si,sec_mode
m_mode2:
        lea  di,window2+cols2
        cld
rep     movsb
        dowindow 2
getchar2:
        setstar 2,3,' '
        setstar 2,4,' '
        setstar 2,5,' '
        setstar 2,6,' '
        setstar 2,7,' '
        setstar 2,8,' '
        setstar 2,9,' '
        setstar 2,11,' '
        setstar 2,10,' '
        setstar 2,11,' '
        setstar 2,12,' '
        setstar 2,13,' '
        setstar 2,14,' '
        setstar 2,15,' '
        mov   al,primary
        cmp  f_sel,0
        je   m_primary
        mov   al,alternate
m_primary:
        mov   ah,0
        add   ax,3
        setstar 2,ax,'*'
        jmp  gc22
nochar2:
        call blop
gc22:
        call blip
        call getop
        cmp  al,27
        jne no272
        jmp  exit_2
no272:
; ah has the key struck
        mov  bx,0
        mov  cx,optmax
        cld
        lea  di,opttab
        xchg al,ah
getw2:
        inc  bx
        cmp  byte ptr [di],al
        je   gotw2
        inc  di
        loop getw2
;     not found
        jmp  nochar2
gotw2:
; got the character, bx has it
        dec   bx
        push  bx
; print the line associated with the bx
        lea  si,opt12
        cmp  f_sel,0
        je   gotw21
        lea  si,opt13
gotw21:
        mov  cx,5
        shl  bx,cl
        add  si,bx
        mov  al,epsone1
        push ax
        mov  epsone1,0
        call putprint
        pop  ax
        mov   epsone1,al
        pop  bx
        cmp  f_sel,0
        je   gw2a
        mov  alternate,bl
        jmp  gw3
gw2a:
        mov  primary,bl
gw3:
        jmp  getchar2
exit_2:
        unwind  2
        call retcurs
       ret
f2a    endp
;
;
f3     proc  near
        call getcurs
        dowindow f
        setstar f,2,' '
        setstar f,3,' '
        cmp   g_sel,1
        je    sec_star
        setstar f,2,'*'
        jmp  gc2g
sec_star:
        setstar f,3,'*'
        jmp  gc2g
jtable1g: jmp func1g
         jmp func2g
         jmp nocharg
         jmp nocharg
         jmp nocharg
         jmp nocharg
         jmp nocharg
         jmp nocharg
         jmp nocharg
         jmp func10g
nocharg:
        call blop
gc2g:
        call blip
        call getop
        cmp  al,27
        jne no27g
        jmp  exit_g
no27g:
        cmp  ah,3bh
        jl nocharg
        cmp  ah,44h
        jg  nocharg
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable1g
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func1g:
        mov  g_sel,0
        unwind   f
        call retcurs
        call  f3a
        jmp   f3
func2g:
        mov  g_sel,1
        unwind   f
        call retcurs
        call  f3a
        jmp   f3
func10g:
        jmp  exit_g
exit_g:
        unwind  f
        call retcurs
       ret
f3     endp
;
; this procedure decides primary or alternate font styles
;
;window 3
rows3    equ 15
cols3    equ 29
windx3   equ  5
windy3   equ 00
color3   equ 5fh
hidex3   equ windx3+(cols3/2)+1
hidey3   equ windy3+rows3
cset     db 0
window3  db  '͵ Set Character Fonts ͻ' ;  201 ,205,187
         db  '                           ' ; 186
         db  ' F1 Set Portrait           ' ; 186
         db  ' F2 Set Landscape          ' ; 186
         db  ' F3 Set Symbol Set         ' ; 186
         db  ' F4 Fixed Spacing          ' ; 186
         db  ' F5 Proportional Spacing   ' ; 186
         db  ' F6 Select Pitch           ' ; 186
         db  ' F7 Set Character Height   ' ; 186
         db  ' F8 Set Character Style    ' ; 186
         db  ' F9 Set Stroke Weight      ' ; 186
         db  ' F10 Set Typeface          ' ; 186
         db  ' Esc = EXIT                ' ; 186
         db  ' *=Most Recently Selected  ' ; 186
         db  'ͼ' ; 200,205,188
s_prim db 0
s_alter db 0
opt13a   db '&l0O',0  ;portrait
opt23a   db '&l1O',0  ;landscape
opt33a   db '(s0P',0  ;fixed
opt43a   db '(s1P',0  ;proportional
opt33b   db ')s0P',0  ;fixed
opt43b   db ')s1P',0  ;proportional
f3a    proc  near
        call getcurs
        mov  cx,cols3
        lea  si,pri_mode
        cmp  g_sel,0
        je   m_mode
        lea  si,sec_mode
m_mode:
        lea  di,window3+cols3
        cld
rep     movsb
        dowindow 3
getchar3:
        setstar 3,3,' '
        setstar 3,4,' '
        setstar 3,5,' '
        setstar 3,6,' '
        setstar 3,7,' '
        setstar 3,8,' '
        setstar 3,9,' '
        setstar 3,11,' '
        setstar 3,12,' '
        setstar 3,13,' '
        mov   al,s_prim
        cmp  g_sel,0
        je   m_s_prim
        mov   al,s_alter
m_s_prim:
        mov   ah,0
        add   ax,3
        setstar 3,ax,'*'
        jmp  gc23
jtable13: jmp func13
         jmp func23
         jmp func33
         jmp func43
         jmp func53
         jmp func63
         jmp func73
         jmp func83
         jmp func93
         jmp func103
nochar3:
        call blop
gc23:
        call blip
        call getop
        cmp  al,27
        jne no273
        jmp  exit_3
no273:
        cmp  ah,3bh
        jl nochar3
        cmp  ah,44h
        jg  nochar3
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable13
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func13:
        doprint 13a
        mov   s_alter,0
        mov   s_prim,0
        jmp   getchar3
func23:
        doprint 23a
        mov   s_alter,1
        mov   s_prim,1
        jmp   getchar3
func33:
        unwind  3
        call retcurs
        call  f3s
        cmp   g_sel,0
        je  func33p
        mov   s_alter,2
        jmp   f3a
func33p:
        mov   s_prim,2
        jmp   f3a
func43:
        cmp   g_sel,0
        je   func43p
        doprint 33b
        mov   s_alter,3
        jmp   getchar3
func43p:
        doprint 33a
        mov   s_prim,3
        jmp   getchar3
func53:
        cmp   g_sel,0
        je   func53p
        doprint 43b
        mov   s_alter,4
        jmp   getchar3
func53p:
        doprint 43a
        mov   s_prim,4
        jmp   getchar3
func63:
        unwind  3
        call retcurs
        call  f3p
        cmp   g_sel,0
        je   func63p
        mov   s_alter,5
        jmp   f3a
func63p:
        mov   s_prim,5
        jmp   f3a
func73:
        unwind  3
        call retcurs
        call  f3t
        cmp   g_sel,0
        je   func73p
        mov   s_alter,6
        jmp   f3a
func73p:
        mov   s_prim,6
        jmp   f3a
func83:
        unwind  3
        call retcurs
        call  f3l
        cmp   g_sel,0
        je   func83p
        mov   s_alter,7
        jmp   f3a
func83p:
        mov   s_prim,7
        jmp   f3a
func93:
        unwind  3
        call retcurs
        call  f3w
        cmp   g_sel,0
        je   func93p
        mov   s_alter,8
        jmp   f3a
func93p:
        mov   s_prim,8
        jmp   f3a
func103:
        unwind  3
        call retcurs
        call  f3y
        cmp   g_sel,0
        je   func103p
        mov   s_alter,9
        jmp   f3a
func103p:
        mov   s_prim,9
        jmp   f3a
exit_3:
        unwind  3
        call retcurs
       ret
f3a    endp
;
;
;
; this procedure decides typeface
;
;window y
rowsy    equ 14
colsy    equ 29
windxy   equ 02
windyy   equ 00
colory   equ 6fh
hidexy   equ windxy+(colsw/2)+1
hideyy   equ windyy+rowsy
windowy  db  '͵   Select Typeface   ͻ' ;  201 ,205,187
         db  '                           ' ; 186
         db  ' F1 Line Printer           ' ; 186
         db  ' F2 Pica                   ' ; 186
         db  ' F3 Elite                  ' ; 186
         db  ' F4 Courier                ' ; 186
         db  ' F5 Helv                   ' ; 186
         db  ' F6 Tms Rmn                ' ; 186
         db  ' F7 Gothic                 ' ; 186
         db  ' F8 Script                 ' ; 186
         db  ' F9 Prestige               ' ; 186
         db  ' F10   EXIT                ' ; 186
         db  ' *=Most Recently Selected  ' ; 186
         db  'ͼ' ; 200,205,188
opty1    db '(s0T',0
opty2    db '(s1T',0
opty3    db '(s2T',0
opty4    db '(s3T',0
opty5    db '(s4T',0
opty6    db '(s5T',0
opty7    db '(s6T',0
opty8    db '(s7T',0
opty9    db '(s8T',0
opty1a   db ')s0T',0
opty2a   db ')s1T',0
opty3a   db ')s2T',0
opty4a   db ')s3T',0
opty5a   db ')s4T',0
opty6a   db ')s5T',0
opty7a   db ')s6T',0
opty8a   db ')s7T',0
opty9a   db ')s8T',0
yset     db 0
doprinty macro string
        local jmpto
        mov   yset,string - 1
        cmp   g_sel,0
        je   jmpto
        doprint y&string&a
        jmp   getchary
jmpto:
        doprint y&string
        jmp   getchary
        endm
f3y    proc  near
        call getcurs
        mov  cx,colsy
        lea  si,pri_mode
        cmp  g_sel,0
        je   y_mode
        lea  si,sec_mode
y_mode:
        lea  di,windowy+colsy
        cld
rep     movsb
        dowindow y
getchary:
        setstar y,3,' '
        setstar y,4,' '
        setstar y,5,' '
        setstar y,6,' '
        setstar y,7,' '
        setstar y,8,' '
        setstar y,9,' '
        setstar y,10,' '
        setstar y,11,' '
        mov   al,yset
        mov   ah,0
        add   ax,3
        setstar y,ax,'*'
        jmp  gc2y
jtable1y: jmp func1y
         jmp func2y
         jmp func3y
         jmp func4y
         jmp func5y
         jmp func6y
         jmp func7y
         jmp func8y
         jmp func9y
         jmp exit_y
nochary:
        call blop
gc2y:
        call blip
        call getop
        cmp  al,27
        jne no27y
        jmp  exit_y
no27y:
        cmp  ah,3bh
        jl nochary
        cmp  ah,44h
        jg  nochary
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable1y
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func1y:
        doprinty 1
func2y:
        doprinty 2
func3y:
        doprinty 3
func4y:
        doprinty 4
func5y:
        doprinty 5
func6y:
        doprinty 6
func7y:
        doprinty 7
func8y:
        doprinty 8
func9y:
        doprinty 9
exit_y:
        unwind  y
        call retcurs
       ret
f3y    endp
;
;
;
; this procedure decides weight
;
;window w
rowsw    equ 8
colsw    equ 29
windxw   equ 02
windyw   equ 00
colorw   equ 6fh
hidexw   equ windxw+(colsw/2)+1
hideyw   equ windyw+rowsw
windoww  db  '͵ Set  Stroke  Weight ͻ' ;  201 ,205,187
         db  '                           ' ; 186
         db  ' F1  Light                 ' ; 186
         db  ' F2  Medium                ' ; 186
         db  ' F3  Bold                  ' ; 186
         db  ' F10   EXIT                ' ; 186
         db  ' *=Most Recently Selected  ' ; 186
         db  'ͼ' ; 200,205,188
optw1    db '(s-1B',0
optw2    db '(s0B',0
optw3    db '(s1B',0
optw1a   db ')s-1B',0
optw2a   db ')s0B',0
optw3a   db ')s1B',0
wset     db 0
doprintw macro string
        local jmpto
        mov   wset,string - 1
        cmp   g_sel,0
        je   jmpto
        doprint w&string&a
        jmp   getcharw
jmpto:
        doprint w&string
        jmp   getcharw
        endm
f3w    proc  near
        call getcurs
        mov  cx,colsw
        lea  si,pri_mode
        cmp  g_sel,0
        je   w_mode
        lea  si,sec_mode
w_mode:
        lea  di,windoww+colsw
        cld
rep     movsb
        dowindow w
getcharw:
        setstar w,3,' '
        setstar w,4,' '
        setstar w,5,' '
        mov   al,wset
        mov   ah,0
        add   ax,3
        setstar w,ax,'*'
        jmp  gc2w
jtable1w: jmp func1w
         jmp func2w
         jmp func3w
         jmp nocharw
         jmp nocharw
         jmp nocharw
         jmp nocharw
         jmp nocharw
         jmp nocharw
         jmp exit_w
nocharw:
        call blop
gc2w:
        call blip
        call getop
        cmp  al,27
        jne no27w
        jmp  exit_w
no27w:
        cmp  ah,3bh
        jl nocharw
        cmp  ah,44h
        jg  nocharw
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable1w
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func1w:
        doprintw 1
func2w:
        doprintw 2
func3w:
        doprintw 3
exit_w:
        unwind  w
        call retcurs
       ret
f3w    endp
;
;
;
; this procedure decides style
;
;window l
rowsl    equ 7
colsl    equ 29
windxl   equ 02
windyl   equ 00
colorl   equ 6fh
hidexl   equ windxl+(colsl/2)+1
hideyl   equ windyl+rowsl
windowl  db  '͵ Set Character Style ͻ' ;  201 ,205,187
         db  '                           ' ; 186
         db  ' F1 Set Upright            ' ; 186
         db  ' F2 Set Italic             ' ; 186
         db  ' F10   EXIT                ' ; 186
         db  ' *=Most Recently Selected  ' ; 186
         db  'ͼ' ; 200,205,188
optl1    db '(s0S',0
optl2    db '(s1S',0
optl1a   db ')s0S',0
optl2a   db ')s1S',0
lset     db 0
doprintl macro string
        local jmpto
        mov   lset,string - 1
        cmp   g_sel,0
        je   jmpto
        doprint l&string&a
        jmp   getcharl
jmpto:
        doprint l&string
        jmp   getcharl
        endm
f3l    proc  near
        call getcurs
        mov  cx,colsl
        lea  si,pri_mode
        cmp  g_sel,0
        je   l_mode
        lea  si,sec_mode
l_mode:
        lea  di,windowl+colsl
        cld
rep     movsb
        dowindow l
getcharl:
        setstar l,3,' '
        setstar l,4,' '
        mov   al,lset
        mov   ah,0
        add   ax,3
        setstar l,ax,'*'
        jmp  gc2l
jtable1l: jmp func1l
         jmp func2l
         jmp nocharl
         jmp nocharl
         jmp nocharl
         jmp nocharl
         jmp nocharl
         jmp nocharl
         jmp nocharl
         jmp exit_l
nocharl:
        call blop
gc2l:
        call blip
        call getop
        cmp  al,27
        jne no27l
        jmp  exit_l
no27l:
        cmp  ah,3bh
        jl nocharl
        cmp  ah,44h
        jg  nocharl
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable1l
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func1l:
        doprintl 1
func2l:
        doprintl 2
exit_l:
        unwind  l
        call retcurs
       ret
f3l    endp
;
;
;
;
; this procedure decides height
;
;window t
rowst    equ 13
colst    equ 29
windxt   equ 02
windyt   equ 00
colort   equ 6fh
hidext   equ windxt+(colst/2)+1
hideyt   equ windyt+rowst
windowt  db  '͵ Set Character Heightͻ' ;  201 ,205,187
         db  '                           ' ; 186
         db  ' F1 6 Point                ' ; 186
         db  ' F2 7 Point                ' ; 186
         db  ' F3 8 Point                ' ; 186
         db  ' F4 8.5 Point              ' ; 186
         db  ' F5 10 Point               ' ; 186
         db  ' F6 12 Point               ' ; 186
         db  ' F7 14 Point               ' ; 186
         db  ' F8 14.4 Point             ' ; 186
         db  ' F10   EXIT                ' ; 186
         db  ' *=Most Recently Selected  ' ; 186
         db  'ͼ' ; 200,205,188
optt1    db '(s6V',0
optt2    db '(s7V',0
optt3    db '(s8V',0
optt4    db '(s8.5V',0
optt5    db '(s10V',0
optt6    db '(s12V',0
optt7    db '(s14V',0
optt8    db '(s14.4V',0
optt9    db '(s18V',0
optt1a   db ')s6V',0
optt2a   db ')s7V',0
optt3a   db ')s8V',0
optt4a   db ')s8.5V',0
optt5a   db ')s10V',0
optt6a   db ')s12V',0
optt7a   db ')s14V',0
optt8a   db ')s14.4V',0
optt9a   db ')s18V',0
tset     db 0
doprintt macro string
        local jmpto
        mov   tset,string - 1
        cmp   g_sel,0
        je   jmpto
        doprint t&string&a
        jmp   getchart
jmpto:
        doprint t&string
        jmp   getchart
        endm
f3t    proc  near
        call getcurs
        mov  cx,colst
        lea  si,pri_mode
        cmp  g_sel,0
        je   t_mode
        lea  si,sec_mode
t_mode:
        lea  di,windowt+colst
        cld
rep     movsb
        dowindow t
getchart:
        setstar t,3,' '
        setstar t,4,' '
        setstar t,5,' '
        setstar t,6,' '
        setstar t,7,' '
        setstar t,8,' '
        setstar t,9,' '
        setstar t,10,' '
        mov   al,tset
        mov   ah,0
        add   ax,3
        setstar t,ax,'*'
        jmp  gc2t
jtable1t: jmp func1t
         jmp func2t
         jmp func3t
         jmp func4t
         jmp func5t
         jmp func6t
         jmp func7t
         jmp func8t
         jmp nochart
         jmp exit_t
nochart:
        call blop
gc2t:
        call blip
        call getop
        cmp  al,27
        jne no27t
        jmp  exit_t
no27t:
        cmp  ah,3bh
        jl nochart
        cmp  ah,44h
        jg  nochart
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable1t
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func1t:
        doprintt 1
func2t:
        doprintt 2
func3t:
        doprintt 3
func4t:
        doprintt 4
func5t:
        doprintt 5
func6t:
        doprintt 6
func7t:
        doprintt 7
func8t:
        doprintt 8
func9t:
        doprintt 9
exit_t:
        unwind  t
        call retcurs
       ret
f3t    endp
;
;
;
;
; this procedure decides pitch
;
;window p
rowsp    equ 14
colsp    equ 29
windxp   equ 8
windyp   equ 00
colorp   equ 6fh
hidexp   equ windxp+(colsp/2)+1
hideyp   equ windyp+rowsp
windowp  db  '͵  Select Font Pitch  ͻ' ;  201 ,205,187
         db  '                           ' ; 186
         db  ' F1 4 CPI                  ' ; 186
         db  ' F2 6 CPI                  ' ; 186
         db  ' F3 8 CPI                  ' ; 186
         db  ' F4 10 CPI                 ' ; 186
         db  ' F5 12 CPI                 ' ; 186
         db  ' F6 14 CPI                 ' ; 186
         db  ' F7 16.66 CPI              ' ; 186
         db  ' F8 18 CPI                 ' ; 186
         db  ' F9 20 CPI                 ' ; 186
         db  ' F10   EXIT                ' ; 186
         db  ' *=Most Recently Selected  ' ; 186
         db  'ͼ' ; 200,205,188
optp1    db '(s4H',0
optp2    db '(s6H',0
optp3    db '(s8H',0
optp4    db '(s10H',0
optp5    db '(s12H',0
optp6    db '(s14H',0
optp7    db '(s16.67H',0
optp8    db '(s18H',0
optp9    db '(s20H',0
optp1a   db ')s4H',0
optp2a   db ')s6H',0
optp3a   db ')s8H',0
optp4a   db ')s10H',0
optp5a   db ')s12H',0
optp6a   db ')s14H',0
optp7a   db ')s16.67H',0
optp8a   db ')s18H',0
optp9a   db ')s20H',0
pset     db 0
doprintp macro string
        local jmpto
        mov   pset,string - 1
        cmp   g_sel,0
        je   jmpto
        doprint p&string&a
        jmp   getcharp
jmpto:
        doprint p&string
        jmp   getcharp
        endm
f3p    proc  near
        call getcurs
        mov  cx,colsp
        lea  si,pri_mode
        cmp  g_sel,0
        je   p_mode
        lea  si,sec_mode
p_mode:
        lea  di,windowp+colsp
        cld
rep     movsb
        dowindow p
getcharp:
        setstar p,3,' '
        setstar p,4,' '
        setstar p,5,' '
        setstar p,6,' '
        setstar p,7,' '
        setstar p,8,' '
        setstar p,9,' '
        setstar p,10,' '
        setstar p,11,' '
        mov   al,pset
        mov   ah,0
        add   ax,3
        setstar p,ax,'*'
        jmp  gc2p
jtable1p: jmp func1p
         jmp func2p
         jmp func3p
         jmp func4p
         jmp func5p
         jmp func6p
         jmp func7p
         jmp func8p
         jmp func9p
         jmp exit_p
nocharp:
        call blop
gc2p:
        call blip
        call getop
        cmp  al,27
        jne no27p
        jmp  exit_p
no27p:
        cmp  ah,3bh
        jl nocharp
        cmp  ah,44h
        jg  nocharp
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable1p
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func1p:
        doprintp 1
func2p:
        doprintp 2
func3p:
        doprintp 3
func4p:
        doprintp 4
func5p:
        doprintp 5
func6p:
        doprintp 6
func7p:
        doprintp 7
func8p:
        doprintp 8
func9p:
        doprintp 9
exit_p:
        unwind  s
        call retcurs
       ret
f3p    endp
;
;
;
;
; this procedure decides symbol set
;
;window 3
rowss    equ 10
colss    equ 29
windxs   equ 8
windys   equ 00
colors   equ 6fh
hidexs   equ windxs+(colss/2)+1
hideys   equ windys+rowss
windows  db  '͵  Select Symbol Set  ͻ' ;  201 ,205,187
         db  '                           ' ; 186
         db  ' F1 Roman-8                ' ; 186
         db  ' F2 Kana-8                 ' ; 186
         db  ' F3 USASCII                ' ; 186
         db  ' F4 Line Draw              ' ; 186
         db  ' F5 Math Symbols           ' ; 186
         db  ' F10   EXIT                ' ; 186
         db  ' *=Most Recently Selected  ' ; 186
         db  'ͼ' ; 200,205,188
opts1    db '(8U',0
opts2    db '(8O',0
opts3    db '(0U',0
opts4    db '(0B',0
opts5    db '(0A',0
opts1a   db ')8U',0
opts2a   db ')8O',0
opts3a   db ')0U',0
opts4a   db ')0B',0
opts5a   db ')0A',0
sset     db 0
f3s    proc  near
        call getcurs
        mov  cx,colss
        lea  si,pri_mode
        cmp  g_sel,0
        je   s_mode
        lea  si,sec_mode
s_mode:
        lea  di,windows+colss
        cld
rep     movsb
        dowindow s
getchars:
        setstar s,3,' '
        setstar s,4,' '
        setstar s,5,' '
        setstar s,6,' '
        setstar s,7,' '
        mov   al,sset
        mov   ah,0
        add   ax,3
        setstar s,ax,'*'
        jmp  gc2s
jtable1s: jmp func1s
         jmp func2s
         jmp func3s
         jmp func4s
         jmp func5s
         jmp nochars
         jmp nochars
         jmp nochars
         jmp nochars
         jmp exit_s
nochars:
        call blop
gc2s:
        call blip
        call getop
        cmp  al,27
        jne no27s
        jmp  exit_s
no27s:
        cmp  ah,3bh
        jl nochars
        cmp  ah,44h
        jg  nochars
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable1s
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func1s:
        mov   sset,0
        cmp   g_sel,0
        je   func1sa
        doprint s1a
        jmp   getchars
func1sa:
        doprint s1
        jmp   getchars
func2s:
        mov   sset,1
        cmp   g_sel,0
        je   func2sa
        doprint s2a
        jmp   getchars
func2sa:
        doprint s2
        jmp   getchars
func3s:
        mov   sset,2
        cmp   g_sel,0
        je   func3sa
        doprint s3a
        jmp   getchars
func3sa:
        doprint s3
        jmp   getchars
func4s:
        mov   sset,3
        cmp   g_sel,0
        je   func4sa
        doprint s4a
        jmp   getchars
func4sa:
        doprint s4
        jmp   getchars
func5s:
        mov   sset,4
        cmp   g_sel,0
        je   func5sa
        doprint s5a
        jmp   getchars
func5sa:
        doprint s5
        jmp   getchars
exit_s:
        unwind  s
        call retcurs
       ret
f3s    endp
;
;
;window 7
rows7    equ 9
cols7    equ 28
windx7   equ 41
windy7   equ 10
color7   equ 6Fh
hidex7   equ windx7+(cols7/2)+1
hidey7   equ windy7+rows7
window7  db  '͵ Select Graphic Modes ͻ' ;  201 ,205,187
         db  ' F1 Use Lpt1: for PrtSc   ' ; 186
         db  ' F2 Use Lpt2: for PrtSc   ' ; 186
         db  ' F3 Use 75 dots per inch  ' ; 186
         db  ' F4 Use 100 dots per inch ' ; 186
         db  ' F5 No Graphic Screen dump' ; 186
         db  ' F10     EXIT             ' ; 186
         db  '   (Graphic PrtSc Only)   ' ; 186
         db  'ͼ' ; 200,205,188
f7     proc  near
        call getcurs
        dowindow 7
        jmp getchar7
jtable17: jmp func17
         jmp func27
         jmp func37
         jmp func47
         jmp func57
         jmp nochar7
         jmp nochar7
         jmp nochar7
         jmp nochar7
         jmp func107
getchar7:
        jmp  gc27
nochar7:
        call blop
gc27:
        setstar  7,2,' '
        setstar  7,3,' '
        setstar  7,4,' '
        setstar  7,5,' '
        setstar  7,6,'*'
        cmp  prtsc,0
        je   gc276
        setstar  7,6,' '
        cmp  printerc,1
        je   gc272
        jmp  gc273
gc272:
        setstar  7,3,'*'
        jmp  gc274
gc273:
        setstar  7,2,'*'
gc274:
        cmp      psresol,'0'
        jne     gc275
        setstar  7,4,'*'
        jmp  gc276
gc275:
        setstar  7,5,'*'
gc276:
        call blip
        call getop
        cmp  al,27
        jne no277
        jmp  exit_7
nochar7x:
        jmp nochar7
no277:
        cmp  ah,3bh
        jl nochar7x
        cmp  ah,44h
        jg  nochar7x
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable17
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func17:
        mov   prtsc,1
        mov   printerc,0
        jmp   getchar7
func27:
        mov   prtsc,1
        mov   printerc,1
        jmp   getchar7
func37:
        mov   prtsc,1
        lea   di,psresol
        mov   byte ptr [di],'0'
        mov   byte ptr [di+1],'7'
        mov   byte ptr [di+2],'5'
        jmp   getchar7
func47:
        mov   prtsc,1
        lea   di,psresol
        mov   byte ptr [di],'1'
        mov   byte ptr [di+1],'0'
        mov   byte ptr [di+2],'0'
        jmp   getchar7
func57:
        mov   prtsc,0
        mov   printerc,0ffffh
        jmp   getchar7
func107:
        jmp  exit_7
exit_7:
        unwind  7
        call retcurs
       ret
f7     endp
;
;window 4
rows4    equ 10
cols4    equ 32
windx4   equ 05
windy4   equ 10
color4   equ 3Fh
hidex4   equ windx4+(cols4/2)+1
hidey4   equ windy4+rows4
window4  db  '͵ Set Translation Modesͻ' ;  201 ,205,187
         db  ' F1 Emulate Epson on LPT1:    ' ; 186
         db  ' F2 No Emulation on LPT1:     ' ; 186
         db  ' F3 Enable font changes (~)   ' ; 186
         db  ' F4 Disable font changes      ' ; 186
         db  '    Graphics Resolution       ' ; 186
         db  ' F5 low=75,med=100,high=150   ' ; 186
         db  ' F6 low=100,med=150,high=300  ' ; 186
         db  ' F10     EXIT                 ' ; 186
         db  'ͼ' ; 200,205,188
gra_mode  dw  0
epsonem1   dw  0
f4     proc  near
        call getcurs
        dowindow 4
        jmp  getchar4
jtable14: jmp func14
         jmp func24
         jmp func34
         jmp func44
         jmp func54
         jmp func64
         jmp nochar4
         jmp nochar4
         jmp nochar4
         jmp func104
getchar4:
        setstar 4,2,' '
        setstar 4,3,'*'
        setstar 4,4,' '
        setstar 4,5,'*'
        setstar 4,7,' '
        setstar 4,8,' '
        cmp  epsone1,1
        je   ns41
        jmp  gc24
ns41:
        cmp  epsonem1,1
        jne  ns42
        setstar 4,2,'*'
        setstar 4,3,' '
ns42:
        cmp  imbed_mode,1
        jne  ns43
        setstar 4,4,'*'
        setstar 4,5,' '
ns43:
        cmp  epsonem1,1
        jne  ns44
        setstar 4,7,'*'
        setstar 4,8,' '
        cmp  gra_mode,1
        jne  ns44
        setstar 4,8,'*'
        setstar 4,7,' '
ns44:
        jmp  gc24
nochar4:
        call blop
gc24:
        call blip
        call getop
        cmp  al,27
        jne no274
        jmp  exit_4
no274:
        cmp  ah,3bh
        jl nochar4
        cmp  ah,44h
        jg  nochar4
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable14
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func14:
        mov   epsone1,1
        mov   epsonem1,1
        jmp   func114
func24:
        mov   epsone1,0
        mov   epsonem1,0
        jmp   func114
func34:
        mov   epsone1,1
        mov   imbed_mode,1
        jmp   func114
func44:
        mov   epsone1,0
        mov   imbed_mode,0
        jmp   func114
func54:
        mov   gra_mode,0
        jmp   func114
func64:
        mov   gra_mode,1
        jmp   func114
func104:
        jmp  exit_4
func114:
        cmp   epsonem1,1
        je    func114a
        cmp   imbed_mode,1
        je    func114a
        jmp   getchar4
func114a:
        mov   epsone1,1
        jmp   getchar4
exit_4:
        unwind  4
        call retcurs
       ret
f4     endp
;
;window 9
rows9    equ 13
cols9    equ 29
windx9   equ 41
windy9   equ 10
color9   equ 1fh
hidex9   equ windx9+(cols9/2)+1
hidey9   equ windy9+rows9
window9  db  '͵ Other Printer Options ͻ' ;  201 ,205,187
         db  ' F1 Set 66 lines per page  ' ; 186
         db  ' F2 Set 6 lines per inch   ' ; 186
         db  ' F3 Set 8 lines per inch   ' ; 186
         db  ' F4 Set 12 Lines per inch  ' ; 186
         db  ' F5 Set left margin 0      ' ; 186
         db  ' F6 Set left margin 8      ' ; 186
         db  ' F7 Set left margin 12     ' ; 186
         db  ' F8 Advance 1 line         ' ; 186
         db  ' F9 Page Eject             ' ; 186
         db  ' F10     EXIT              ' ; 186
         db  'Options apply only to LPT1:' ; 186
         db  'ͼ' ; 200,205,188
opt19    db  '&l66P&l2E&l7.6C&l66F',0 ;66 lines per page
opt29    db  '&l6D',0
opt39    db  '&l8D',0
opt49    db  '&l12D',0
opt59    db  '&a0L',0
opt69    db  '&a8L',0
opt79    db  '&a12L',0
opt89    db  13,10,0
opt99    db  12,0
f9     proc  near
        call getcurs
        dowindow 9
getchar9:
gc29:
        call blip
        call getop
        push  ax
        setstar 9,2,' '
        setstar 9,3,' '
        setstar 9,4,' '
        setstar 9,5,' '
        setstar 9,6,' '
        setstar 9,7,' '
        setstar 9,8,' '
        setstar 9,9,' '
        setstar 9,10,' '
        pop ax
        cmp  al,27
        jne no279
        jmp  exit_9
jtable19: jmp func19
         jmp func29
         jmp func39
         jmp func49
         jmp func59
         jmp func69
         jmp func79
         jmp func89
         jmp func99
         jmp func109
nochar9:
        call blop
        jmp  gc29
no279:
        cmp  ah,3bh
        jl nochar9
        cmp  ah,44h
        jg  nochar9
        sub ah,3bh
; ah has 0 to 9 in it
        mov  bl,ah
        mov  bh,0
        lea  di,jtable19
        add  di,bx
        add  di,bx
        add  di,bx
        jmp  di
func19:
        doprint 19
        setstar 9,2,'*'
        jmp   getchar9
func29:
        doprint 29
        setstar 9,3,'*'
        jmp   getchar9
func39:
        doprint 39
        setstar 9,4,'*'
        jmp   getchar9
func49:
        doprint 49
        setstar 9,5,'*'
        jmp   getchar9
func59:
        doprint 59
        setstar 9,6,'*'
        jmp   getchar9
func69:
        doprint 69
        setstar 9,7,'*'
        jmp   getchar9
func79:
        doprint 79
        setstar 9,8,'*'
        jmp   getchar9
func89:
        doprint 89
        setstar 9,9,'*'
        jmp   getchar9
func99:
        doprint 99
        setstar 9,10,'*'
        jmp   getchar9
func109:
        jmp  exit_9
exit_9:
        unwind  9
        call retcurs
       ret
f9     endp
CSEG        ENDS
        END        ENTPT
