cseg   segment  byte public 'CODE'
assume cs:cseg,ds:cseg,es:cseg
public blop,blip,getcurs,getwind,retwind
public retcurs,putprint,getop
extrn rows:word,windy:byte,windx:byte
extrn cols:word,bhpage:byte,color:byte,hidex:byte,hidey:byte
extrn cursor:word,printer:word,sound:byte
extrn cursmode:word
getwindx  proc near
getwind:
          push  cs
          pop   ds
          push  cs
          pop   es
; locate at the line 1 position 10
          mov  cx,rows
          mov  dh,windy
gwloop:
          push cx
          add  dh,1
          mov  dl,windx
          mov  cx,cols
gwloop2:
          push  cx
          inc  dl
          push  dx
          mov  ah,2
          mov  bh,bhpage
          int  10h
; get word at cursor
          mov  ah,8
          mov  bx,0
          push  si
          push  di
          int  10h
          pop  di
          pop   si
          cld
          stosw
; put word at cursor
          pop  dx
          mov  ah,2
          mov  bh,bhpage
          push  si
          push  di
          int  10h
          pop  di
          pop  si
          cld
          lodsb
          mov  cx,1
          mov  ah,9
          mov  bh,bhpage
          mov  bl,color
          push  si
          push  di
          int  10h
          pop  di
          pop  si
          pop  cx
          loop  gwloop2
          pop  cx
          loop gwloop
; then  hide the cursor
          mov  dl,hidex
          mov  dh,hidey
          mov  ah,2
          mov   bh,bhpage
          push  si
          push  di
          int   10h
          pop  di
          pop  si
          push  cs
          pop   ds
          push  cs
          pop   es
          ret
getwindx  endp
retwindx  proc  near
retwind:
          push  cs
          pop   ds
          push  cs
          pop   es
; locate at the line 1 position 10
          mov  cx,rows
          mov  dh,windy
rwloop:
          push cx
          add  dh,1
          mov  dl,windx
          mov  cx,cols
rwloop2:
          push cx
          push  si
          push  di
          inc  dl
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put word at cursor
          pop  di
          pop  si
          cld
          lodsw
          push  si
          push  di
      ;   ah has the  attribute, al, has the character
          mov  cx,1
          mov  bl,ah
          mov  ah,9
          mov  bh,bhpage
          int  10h
          pop  di
          pop  si
          pop  cx
          loop  rwloop2
          pop  cx
          loop rwloop
          ret
retwindx  endp
getcursx  proc  near
getcurs:
          push  cs
          pop   ds
          push  cs
          pop   es
; get video state
          mov ah,15
          int 10h
          push  cs
          pop   ds
          push  cs
          pop   es
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          push  si
          push  di
          int  10h
          pop  di
          pop  si
          push  cs
          pop   ds
          push  cs
          pop   es
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcursx  endp
retcursx  proc  near
retcurs:
          push  cs
          pop   ds
          push  cs
          pop   es
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          push  si
          push  di
          int  10h
          pop  di
          pop  si
          push  cs
          pop   ds
          push  cs
          pop   es
          ret
retcursx  endp
getopx    proc  near
getop:
; get the option
; us bios interrupts as DOS screws you on get character
          mov  ah,0
         int   16h
; al gets character, ah has scan code
          cmp   ax,250bh
          je    got_unres
          ret
got_unres:
extrn  unres:near
          jmp   unres
getopx    endp
putprintx proc  near
putprint:
; put a string to printer, string ends in hex 0
; si has the lea of string
;
;  next read the printer status
;
          mov ah,2
          mov dx,printer
          int  17h
          test ah,25h
          jz  pr1
          jmp  endprint
pr1:
          cld
          lodsb
          cmp  al,0
          je   retprint
          mov ah,0
          mov dx,printer
          int  17h
          test ah,25h
          jz  pr1
endprint:
         call blop
         call blop
         call blop
retprint:
          ret
putprintx endp
blipx   proc  near
blip:
        cmp   sound,1
        jne   okblip
        ret
okblip:
        mov   bx,300  ; starting freq
        mov   cx,750  ; ending frequency
        mov   dx,4    ; tone rate
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    si,16
        cmp    bx,cx
        jle    i1
        neg    si
i1:
        mov    cx,bx
 ; set frequency
        push   dx
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
        pop    dx
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
; mov   cx,dx
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        jg     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        ret
blipx   endp
blopx   proc  near
blop:
        cmp   sound,1
        jne   okblop
        ret
okblop:
        mov   bx,650  ; starting freq
        mov   cx,200  ; ending frequency
        mov   dx,4    ; tone rate
; turn on tone
o0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    si,16
        mov    cx,bx
 ; set frequency
        push   dx
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
        pop    dx
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
; mov   cx,dx
o2:     loop o2
        pop    bx
        pop    cx
        cmp    bx,cx
        jl     op3
        sub    bx,si
        jmp    o0
op3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        ret
blopx   endp
cseg    ends
        end
