print macro string
   lea   dx,string
   mov   ah,9
   int   21h
   endm
cseg segment para public 'CODE'
assume  cs:cseg,ds:cseg,es:cseg
; this is the allocation stuff for DS. Does a shrink etc
extrn  stack_seg:word,hash_seg:word
extrn buffer1:word,buffer2:word,buffer3:word,buffer4:word
last_byte db 16 dup(0)
error2  db 'Error allocating memory',13,10,'$'
shrink:
public shrink
; allocates memory
; shrink
;
     mov  ah,4ah
     lea  bx,last_byte
     shr  bx,1
     shr  bx,1
     shr  bx,1
     shr  bx,1
     inc  bx   ; for safety
     int  21h
     jnc  good_shrink
bad_mem:
     print error2
     stc
     ret
good_shrink:
; stack=64k
     mov  ah,48h
     mov  bx,1000h ; 64k
     int  21h
     jc   bad_mem
     mov  stack_seg,ax
; allocate the hash=32k
     mov  ah,48h
     mov  bx,1000h ; 64k
     int  21h
     jc   bad_mem
     mov  hash_seg,ax
; buffer1=20k
     mov  ah,48h
     mov  bx,800h ; 32k
     int  21h
     jc   bad_mem
     mov  buffer1,ax
; buffer2=20k
     mov  ah,48h
     mov  bx,800h ; 32k
     int  21h
     jc   bad_mem
     mov  buffer2,ax
; buffer3=20k
     mov  ah,48h
     mov  bx,800h ; 32k
     int  21h
     jc   bad_mem
     mov  buffer3,ax
; buffer4=20k
     mov  ah,48h
     mov  bx,800h ; 32k
     int  21h
     jc   bad_mem
     mov  buffer4,ax
     clc
     ret
cseg	ends
     end
