; this is the exe version
;
print macro string
  lea  dx,string
  mov  ah,9
  int  21h
endm
get macro string
  lea  dx,string
  mov  ah,10
  int  21h
endm
cseg      segment para public 'CODE'
cseg ends
dseg      segment para public 'DATA'
dseg  ends
sseg  segment stack 'STACK'
     dw   256  dup(0)
sseg   ends
dseg      segment para public 'DATA'
          assume   cs:cseg,ds:dseg,ss:sseg,es:dseg
savesp  dw  0  ; stack pointer to ret far outa here
psp     dw  0  ; address of PSP
buffer  dw  0  ; address of buffer segment
outbuff dw  0  ; 64k output buffer for pcbout to write
public buffer,outbuff,handle,handlet,handleg
handle    dw  0
handlet   dw  0  ; input text file handle
handleg   dw  0  ; output raw file handle
mess1     db  'T2F.EXE Text to Font soft font utility',13,10
          db  'Copyright 1987 by Keith P. Graham',13,10,'$'
mess2     db  'Enter the name of the HP soft font file: $'
mess3     db  'Unable to open font file',13,10,'$'
mess8     db  'Reading font...',13,10,'$'
mess9     db  'Memory allocation error, Job aborted...',13,10,'$'
mess10    db  'Enter the name of the input text file',13,10,'$'
mess11    db  'Enter the name of the output PC Paintbrush file',13,10,'$'
mess12    db  'Unable to open input file',13,10,'$'
mess13    db  'Unable to open output file',13,10,'$'
mess14    db  'Writing out graphics file',13,10,'$'
err1      db  'Insufficient memory',13,10,'$'
crlf      db   13,10,'$'
buffloc   dw  0
buffcount dw  0
textbuff  db  1000h dup(0)
filename  db  64,0,64 dup(0)
;
;
dseg    ends
;
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:dseg,ss:sseg,es:dseg
start  proc  near
; mainline procedures
; set up return
    push  ds
    xor   ax,ax
    push  ax
    mov   ax,ds
    call  reset_segs
    mov   psp,ax
    mov   savesp,sp
; housekeeping
     call  shrink
     call  get_files
; have the file names  and good open files
;
          print   mess8
;
; get the font will retreive a font based in handle
;
extrn get_a_font:near
          call    get_a_font
; close the font file
         call  reset_segs
         mov   bx,handle
         mov   ah,3eh
         int   21h
; write out the graphics file header
         mov   ax,handleg
         mov   handle,ax
;
extrn pcb_out:near
         call   pcb_out
         call   reset_segs
         mov   ax,handlet
         mov   handle,ax
extrn convert_text:near
         call  convert_text
         mov   bx,handlet
         mov   ah,3eh
         int   21h
         mov   bx,handleg
         mov   ah,3eh
         int   21h
         jmp  int20h
start   endp
shrink:
;
;
; this is the section to shrink down and get some stuff
;
    mov  bx,sseg
    add  bx,32
    sub  bx,psp
    push  es
    mov   es,psp
    mov  ah,4ah
    int  21h
    pop  es
    jc    bad_mem
    jmp   short good_mem
bad_mem:
        print  err1
     jmp  int20h
good_mem:
          print  mess1
; get the 64k memory area for fonts
        mov   bx,1000h  ; 64k
        mov   ah,48h
        int   21h
        jnc   good_mem2
        print mess9
        jmp  int20h
good_mem2:
        mov   buffer,ax
; get 64k for output buffer
        mov   bx,1000h  ; 64k
        mov   ah,48h
        int   21h
        jnc   good_mem3
        print mess9
        jmp  int20h
good_mem3:
        mov   outbuff,ax
        ret
;
get_files:
;
; get then name of the input text file
          print  mess10
          get    filename
          print  crlf
; open the input text file
          cmp    filename+1,1
          jg     open_tfile
errort:
          print  mess12
          jmp  int20h
open_tfile:
; open the input text file
          mov    bl,byte ptr filename+1
          mov    bh,0
          mov    filename[bx+2],0
          lea    dx,filename+2
          mov    al,0
          mov    ah,3dh
          int    21h
          jc     errort
          mov    handlet,ax
; get the name of the output graphics file
          print  mess11
          get    filename
          print  crlf
; open the output graphics file
          cmp    filename+1,1
          jg     open_gfile
errorg:
          print  mess13
          jmp  int20h
open_gfile:
; open the input text file
          mov    bl,byte ptr filename+1
          mov    bh,0
          mov    filename[bx+2],0
          lea    dx,filename+2
          mov    al,0
          mov    cx,0
          mov    ah,3ch
          int    21h
          jc     errorg
          mov    handleg,ax
;
; get the name of the font
          print  mess2
          get    filename
          print  crlf
          cmp    filename+1,1
          jg     open_file
error_exit:
          print  mess3
          jmp  int20h
open_file:
          mov    bl,byte ptr filename+1
          mov    bh,0
          mov    filename[bx+2],0
          lea    dx,filename+2
          mov    al,0
          mov    ah,3dh
          int    21h
          jc     error_exit
          mov    handle,ax
      ret
;
;
reset_segs proc  near
public reset_segs
      push  ax
      mov   ax,dseg
      mov   ds,ax
      mov   es,ax
      pop   ax
      ret
reset_segs  endp
bad_end proc far
;
int20h:
public int20h
; this replaces interrupt 20
     call  reset_segs
     mov   sp,savesp
     mov   ax,4c00h
     int   21h
     ret

bad_end  endp

get_buffer:
public get_buffer
;
; fills up the buffer
         push    dx
         push    cx
         push    bx
          lea    dx,textbuff
          mov    cx,1000h
          mov    ah,3fh
          mov    bx,handle
          int    21h
          jnc    got_buffer
bad_b:
          pop    bx
          pop    cx
          pop    dx
          stc
          ret
got_buffer:
          cmp    ax,0
          je     bad_b
          lea    bx,textbuff
          mov    buffloc,bx
          mov    buffcount,ax
          pop    bx
          pop    cx
          pop    dx
          clc
          ret
get_word:
public get_word
       cmp  buffcount,2
       jge  get_mword
       call get_byte
       jc   bad_word
       mov  ah,al
       call get_byte
       jc   bad_word
       xchg al,ah
       clc
       ret
bad_word:
       stc
       ret
get_mword:
         push   si
         mov    si,buffloc
         cld
         lodsw
         mov    buffloc,si
         pop    si
         dec    buffcount
         dec    buffcount
         cmp    buffcount,0
         jle    get_more
         clc
         ret
get_byte:
public get_byte
   ; pulls in one byte from buffer
         push   si
         mov    si,buffloc
         cld
         lodsb
         mov    buffloc,si
         pop    si
         dec    buffcount
         cmp    buffcount,0
         jle    get_more
         clc
         ret
get_more:
         push   ax
         call   get_buffer
         pop    ax
         ret
; this gets a byte out of the current buffer
cseg      ends
          end      start
;
