dseg     segment para public 'data'
;
extrn errorsave:byte,helpsave:byte,error0:byte
;
;
; windows start here
;  menu structure is:
;    db x loc
;    db y loc
;    db color
;    dw  savearea
;    db lines of data
;    db 0
;
;
wait0   db 22,06,0f1h
        dw  errorsave
        db  'Please wait while file is saved ',10,0
;
help0   db 10,15,07h
     dw  helpsave
 db  ' MacHead will allow for the creation, deletion,',10
 db  ' and editting of Macintosh MacBinary headers. Fill ',10
 db  ' in the blanks. If you need help press the F1 key',10
 db  ' while the cursor is on the field in question.',10
 db  ' Press F2  to Save without a MacBinary Header.',10
 db  ' Press F10 to Save the MacBinary Header.',10
 db  '      Press the ESC key if you wish to quit.',10,0
;
help1   db 20,13,70h
     dw  helpsave
     db  ' Filename is the name that will appear as',10
     db  ' the MacIntosh file name. Filename cannot',10
     db  ' be blank and cannot have imbedded blanks',10
     db  '     press any key to continue',10,0
;
help2   db 20,15,70h
     dw  helpsave
     db  ' File Type is the MacIntosh file type. ',10
     db  ' MacPaint has a file type of PNTG.',10
     db  '     press any key to continue',10,0

help3   db 20,15,70h
     dw  helpsave
     db  ' File Creator is the Code for the Program ',10
     db  ' that created the file. MacPaint is MPNT',10
     db  '     press any key to continue',10,0

help4   db 20,15,70h
     dw  helpsave
     db  ' Resource is the Resource Fork and should ',10
     db  ' always be zero for Macpaint and data files',10
     db  '     press any key to continue',10,0

help5   db 20,15,70h
     dw  helpsave
     db  ' Data is the Data Fork and should be the size',10
     db  ' of the file - 128 for MacPaint and data files',10
     db  '     press any key to continue',10,0

notmac  db 50,3,70h
     dw  helpsave
     db  'No MacBinary Header Found ',10,0
notmacf db 0
imwriting db 20,10,0f4h
     dw  helpsave
     db  'Writing Target File ',10,0
;
;
;	 MAC HEADER
;

   db 0
MACI_VERSION	DB	0
MACI_LEN_FN	DB	6
MACI_FILE_NAME	DB	'OPTIKS'
		DB	57 DUP(0) ;65
MACI_FILE_TYPE	DB	'PNTG'
MACI_FILE_CREAT	DB	'MPNT'
MACI_FLAGS	DB	1
MACI_FILL1	DB	0  ; 75 to here
MACI_VERT	DW	0
MACI_HORIZ	DW	0 ;8001H
MACI_FOLDER	DW	0
MACI_PROT	DB	0
MACI_FILL2	DB	0 ;83 to here
MACI_FORK	DD	0
MACI_R_FORK	DD	0
MACI_CRT_DATE	DB	9BH,41H,8CH,0FAH
MACI_LST_MOD	DB	9BH,41H,8CH,0FEH
MACI_FILL3	DB	27 DUP(0) ; 126
MACI_OS		DW	0         ; 128 to here

dfork    db '000000000',0,0
rfork    db '000000000',0,0

db 0,0,0
MACO_VERSION	DB	0
MACO_LEN_FN	DB	6
MACO_FILE_NAME	DB	'OPTIKS'
		DB	57 DUP(0)
MACO_FILE_TYPE	DB	'PNTG'
MACO_FILE_CREAT	DB	'MPNT'
MACO_FLAGS	DB	1
MACO_FILL1	DB	0
MACO_VERT	DW	0
MACO_HORIZ	DW	0 ;8001H
MACO_FOLDER	DW	0
MACO_PROT	DB	0
MACO_FILL2	DB	0
MACO_FORK	DD	0
MACO_R_FORK	DD	0
MACO_CRT_DATE	DB	9BH,41H,8CH,0FAH
MACO_LST_MOD	DB	9BH,41H,8CH,0FEH
MACO_FILL3	DB	27 DUP(0)
MACO_OS		DW	0
;
;
;
;
; fl types
fl1    db "D",44,0,16,1,071h,017h,' '
     dw  head1
head1     db '         MacHead Macbinary Header Editor         '
fl2    db "D",44,0,17,2,071h,017h,' '
     dw  head2
head2     db "Vers 1.00 Copyright 1989 by Keith P. Graham   "
fl3    db "D",10,0,05,06,041h,017h,' '
     dw  title1
title1    db "FileName: "
fl4    db "C",63,0,18,06,70h,07h,' '
     dw  maco_file_name
fl5    db "D",10,0,05,08,41h,17h,' '
     dw  title2
title2    db "Type:     "
fl6    db "C",4,0,18,08,70h,07h,' '
     dw  maco_file_type
fl7    db "D",10,0,05,10,41h,17h,' '
     dw  title3
title3    db "Creator:  "
fl8    db "C",4,0,18,10,70h,07h,' '
     dw  maco_file_creat
fl9    db "D",10,0,05,12,41h,17h,' '
     dw  title4
title4    db "Resource: "
fl10    db "C",8,0,18,12,70h,07h,' '
     dw  rfork
fl11    db "D",10,0,05,14,41h,17h,' '
     dw  title5
title5    db "Data:     "
fl12   db "C",8,0,18,14,70h,07h,' '
     dw  dfork
;
; structure for fl stuff
;
enterline  dw  (end_tst-$-2)/2
     dw  fl1,fl2,fl3,fl4,fl5,fl6,fl7,fl8,fl9,fl10,fl11,fl12
end_tst equ this byte
clearscreen dw 1,cls
cls    db "D",1,0,16,1,070h,007h,' '
     dw  cls1
cls1      db ' '
;
;
eflag  db  0
;
;
;
buffer db 1024 dup(0)
;
extrn exit_phase:word
extrn handlei:word,handleo:word
dseg ends
cseg     segment para public 'CODE'
     assume   cs:cseg,ds:dseg,es:dseg
extrn forms:near,reset_segs:near
main     proc     near
hex2bin:
; si points to a field, cx has the length
;
     mov   bp,0  ; high word
     mov   bx,0  ; low word
     cld
hb1:
     push  cx
     lodsb
     cmp   al,30h
     jl    hb1a
     cmp   al,39h
     jg    hb1a
     jmp   hb3
hb1a:
     pop   cx
     loop  hb1
     jmp   hb5
hb2:
     push  cx
     lodsb
hb3:
     cmp   al,30h
     jl    hb4
     cmp   al,39h
     jg    hb4
     mov   ah,0
     and   al,15
     xchg  ax,bx
     mov   cx,10
     mul   cx
     add   bx,ax
     adc   bp,dx
     pop   cx
     loop  hb2
     jmp   hb5
hb4:
     pop  cx
hb5:
     mov   ax,bx
     mov   dx,bp
     ret
write_head:
; first fix up the mac name
     lea   si,maco_file_name
     add   si,61
     mov   al,20h
     mov   cx,61
     std
wh0:
     lodsb
     cmp  al,0
     je  wh1
     cmp  al,20h
     je  wh1
     jmp  wh2
wh1:
     loop  wh0
wh2:
     cld
     inc   cx
     mov   byte ptr maco_file_name - 1,cl
; clear up the trailing blanks
     inc    si
     inc    si
     mov    di,si
     sub    cx,63
     neg    cx
     mov    al,0
rep  stosb
; convert the fork info back into binary to put in place
     lea   si,rfork  ; resource fork
     mov   cx,8
     call  hex2bin
     xchg  al,ah
     xchg  dl,dh
     mov   word ptr maco_r_fork,dx
     mov   word ptr maco_r_fork+2,ax
     lea   si,dfork  ; data fork
     mov   cx,8
     call  hex2bin
     xchg  al,ah
     xchg  dl,dh
     mov   word ptr maco_fork,dx
     mov   word ptr maco_fork+2,ax
; writes out output head
     lea   dx,maco_version
     mov   cx,128
     mov   ah,40h
     mov   bx,handleo
     int   21h
     ret
leave_cycle:
     ret
write_cycle:
; this does the write
     mov   bx,handlei
     mov   cx,1024
     mov   ah,3fh
     lea   dx,buffer
     int   21h
     jc    leave_cycle
     cmp   ax,0
     je    leave_cycle
     mov   cx,ax
     mov   bx,handleo
     mov   ah,40h
     lea   dx,buffer
     int   21h
     jc    leave_cycle
     cmp   ax,cx
     jne   leave_cycle
     jmp   write_cycle
writing:
; issue writing message
     lea   si,imwriting
     lea   di,helpsave
     call  do_window
     ret
head:
public head
;
; read in the header, check and see if it is amcbinary header
;
;
     call   reset_segs
     lea     si,enterline
     mov     ax,1700h
     mov     bx,0
     call     forms
     call   reset_segs
     call   mac_in
     jc     not_mac
     lea    si,maci_version
     lea    di,maco_version
     mov    cx,128
     cld
     rep    movsb
     jmp    is_mac
not_mac:
     mov    notmacf,1
     lea   si,notmac
     lea   di,helpsave
     call  do_window
is_mac:
; fix up the resource and data forks
     lea   si,maco_fork
     lea   di,dfork
     call  convertf
     lea   si,maco_r_fork
     lea   di,rfork
     call  convertf
     lea   si,help0
     lea   di,helpsave
     call  do_window
     mov     bx,3   ; start with field 4
enter_loop:
     lea     si,enterline
     mov     ax,0ffh
     call     forms
     cmp     al,3bh     ; F1
     je     help_fields
     cmp     al,3ch     ; F2
     je     jwrite_nh
     cmp     al,44h     ; F10
     je     jwrite
     cmp     ah,27
     je     exit_prog
     lea     si,enterline
     mov     ax,0ffh
     mov     bx,exit_phase
     jmp     enter_loop
seeker:
    call  writing
    cmp    notmacf,0
    je     no_seek
; seek to 0
    mov   ax,4200h
    mov   dx,0
    mov   cx,0
    mov   bx,handlei
    int   21h
no_seek:
    ret
jwrite_nh:
; this is bypass the header
    call  seeker
    jmp   no_write_head
;
jwrite:
    call  seeker
    call    write_head
no_write_head:
     call    write_cycle
exit_prog:
; clear the screen
     jmp   go_home
check_fields:
    jmp  check_fields0
help_fields:
extrn  do_window:near,undo_window:near
     mov     bx,exit_phase
     sub   bx,3
     jmp   cs:helps[bx]
helps dw do_help1,do_help2,do_help3,do_help4,do_help5
set_window:
     cmp   eflag,1
     jne   no_error_check
     push  si
     push  di
     mov   bx,exit_phase
     inc   bx
     shl   bx,1
     mov   si,word ptr enterline[bx]
     mov   al,byte ptr ds:[si]+4
     inc   al
     mov   error0+1,al
     mov   al,byte ptr ds:[si]+3
     mov   error0+0,al
     lea   si,error0
     lea   di,errorsave
     call  do_window
     pop   di
     pop   si
no_error_check:
     push  si
     push  di
     call  do_window
     mov   ah,0
     int   16h
     pop   di
     pop   si
     call  undo_window
     cmp   eflag,1
     jne   exit_help
     mov   eflag,0
     lea   si,error0
     lea   di,errorsave
     call  undo_window
exit_help:
     mov     bx,exit_phase
     jmp     enter_loop
do_help1:
     lea   si,help1
     lea   di,helpsave
     jmp   set_window
do_help2:
     lea   si,help2
     lea   di,helpsave
     jmp   set_window
do_help3:
     lea   si,help3
     lea   di,helpsave
     jmp   set_window
do_help4:
     lea   si,help4
     lea   di,helpsave
     jmp   set_window
do_help5:
     lea   si,help5
     lea   di,helpsave
     jmp   set_window
check_fields0:
; check each field
; check field 3, density first
     cmp    maco_file_name,' '
     je     bad_c1
     jmp    good_field1
bad_c1:
     mov    eflag,1
     mov    exit_phase,3
     jmp    do_help1
good_field1:
     cmp    maco_file_type,' '
     je     bad_c2
     jmp    good_field2
bad_c2:
     mov    eflag,1
     mov    exit_phase,5
     jmp    do_help2
good_field2:
     cmp    maco_file_type,' '
     je     bad_c3
     jmp    good_field3
bad_c3:
     mov    eflag,1
     mov    exit_phase,7
     jmp    do_help3
good_field3:
;
go_home:
     call   reset_segs
     mov    bx,handlei
     mov    ah,3eh
     int    21h
     mov    handlei,0
     mov    bx,handleo
     mov    ah,3eh
     int    21h
     mov    handleo,0
     lea     si,clearscreen
     mov     ax,0700h
     mov     bx,0
     call    forms
     ret
;
mac_in:
; this determines if the header is a macbinary header
     mov   bx,handlei
     lea   dx,maci_version
     mov   ah,3fh
     mov   cx,128
     int   21h
     jc    bad_head
     cmp   ax,cx
     jne   bad_head
     jmp   good_head
bad_head:
     stc
     ret
good_head:
; have to check and see what kind of thingy we got, we read in 128
; bytes, but we may have to read in either 384 more or 512 mode
;
; check to see if we have a binary zero header guy
     lea  di,maci_version+2
     mov  cx,64
     mov  al,0
     cld
repe  scasb
     jne  mac_check_more
     jmp  zero_head
mac_check_more:
; check for macbinary header
;
     cmp   maci_version,1
     jg    check_mp
     cmp   maci_file_name,'A'
     jl    check_mp
     cmp   maci_file_name,'z'
     jg    check_mp
     cmp   maci_file_type,'z'
     jg    check_mp
     cmp   maci_file_type,'A'
     jl    check_mp
; have a macbinary head, now lets fix it up a little
     lea   di,maci_file_name
     cld
     mov    cx,63
     mov   al,0
repne scasb
     jne   bad_head
     dec   di
     mov   al,20h
rep  stosb
     clc
     ret
zero_head:
check_mp:
bad_mac:
; seek to end of file
    mov   ax,4202h
    mov   dx,0
    mov   cx,0
    mov   bx,handlei
    int   21h
    push  ax
    push  dx
    mov   ax,4202h
    mov   dx,128
    mov   cx,0
    mov   bx,handlei
    int   21h
    pop   dx
    pop   ax
    xchg al,ah
    xchg dl,dh
    mov  word ptr maco_fork,dx
    mov  word ptr maco_fork+2,ax
no_f_set:
     stc
     ret
convertf:
; converts a fork to decimal, di is target, si is source
     push  di
     lodsw
     xchg al,ah
     mov  dx,ax
     lodsw
     xchg al,ah
;
     mov  cx,10000
     div  cx
     push  dx
     mov   dx,0
     mov   cx,100
     div   cx
     mov   cl,10
     div   cl
     or    ax,3030h
     stosw
     mov   ax,dx
     mov   cl,10
     div   cl
     or    ax,3030h
     stosw
     pop   ax
     mov   dx,0
     mov   cx,100
     div   cx
     mov   cl,10
     div   cl
     or    ax,3030h
     stosw
     mov   ax,dx
     mov   cl,10
     div   cl
     or    ax,3030h
     stosw
     pop   di
     mov   cx,7
cf1:
     cmp   byte ptr es:[di],30h
     jne   cf2
     mov   byte ptr es:[di],20h
     inc   di
     loop  cf1
cf2:
     ret
main  endp
cseg     ends
     end

