cSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG ;ALREADY SET BY DOS LOADER
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        setres                       ;COM FILE ENTRY ALWAYS AT 100H
; data areas
semaphore  db  0
int21      dd  0
int21ip   equ word ptr int21
int21cs   equ word ptr int21 + 2
handle    dw  0
arccheck  db  0
oldpsp    dw  0
savess    dw  0
savesp    dw  0
workss    dw  0
dtadx     dw  0
dtads     dw  0
dtacx     dw  0
filesi    dw  0
filecount dw  0
archive   db 80 dup(0)
findfile  db  15 dup (0)
fcb       db  0
pfile     db  8   dup(0)
pext      db  3   dup(0)
          db  40  dup(0)
;
; next 43 bytes gets put into dta
dta       equ this byte
disk      db  0   ; 1=a etc
filename  db  8   dup(' ')
fileext   db  3   dup(' ')
dirflag   db  0
dircount  dw  0
dirclust  dw  3  dup(0)
attrib    db  0
dtatime   dw  0
dtadate   dw  0
dtasize   dd  0
dtaname   db  13  dup(0)
          db  20  dup(0)  ; fill for fake FCB which is created
;
; arc
; length of archead is  29
archead db  26
arcvers db  8
arcname db 13 dup(0)
arcsize dd  0
arcdate dw  0
arctime dw  0
arccrc  dw  0
arclen  dd  0
;
stack   dw  256  dup(0)
;
MAIN         PROC        NEAR
arcer:
;
; check to see if its 4e or 4f
        cmp  cs:semaphore,0
        je   check_more
        jmp  cs:int21
check_more:
        mov  cs:semaphore,1
; get_first
        cmp  ah,4eh
        je   got_4e
; get_next
        cmp  ah,4fh
        je   got_4f
; open
        cmp  ah,3dh
        je   got_3d
; get attribute
        cmp  ah,43h
        jne  no_43
        cmp  al,0
        jne  no_43
        jmp  got_43
no_43:
; any other guys needed to check out
exit_4:
        mov  cs:semaphore,0
        jmp  cs:int21
got_3d:
; opens on our guys must fail (for now)
        call  check_spec
        jc    exit_4
        mov   al,5
exitd_check:
         push  ax
        stc
         jmp    ret_far_2
        jc    check_exit
got_4e:
        cmp  cs:handle,0
        je   check_first
        call close_old
check_first:
        call  check_spec
        jc    check_exit
        jmp  its_an_arc ;!
check_exit:
        cmp    cs:arccheck,1
        jne    exit_4
        pushf
        call   cs:int21
; here we have returned and must alter the attribute
        jc     exitd_check
; have to fix the guy on the dta somehow ; get dta
          push  ax
          push  bx
          push  es
          mov   ah,2fh
          int  21h
          mov  byte ptr es:[bx+21],10h
          pop  es
          pop  bx
          clc
          jmp   ret_far_2
;
got_4f:
        cmp  cs:handle,0
        jne  check_second
        jmp  exit_4
check_second:
         push   ax
         call   set_stack
         call   set_psp
         jmp    get_more_files
got_43:
; this has to check if the guy in ds:dx is an arc
         push   ax
         push   cx
         push   di
         push   es
         mov   di,dx
         push   ds
         pop   es
         cld
         mov   al,0
         mov   cx,80
repne   scasb
        jne    exit_43
        dec    di
        dec    di
        cmp    byte ptr es:[di],'C'
        je     got_c1
        cmp    byte ptr es:[di],'c'
        je     got_c1
        jmp    exit_43
got_c1:
        dec    di
        cmp    byte ptr es:[di],'r'
        je     got_r1
        cmp    byte ptr es:[di],'R'
        je     got_r1
        jmp    exit_43
got_r1:
        dec    di
        cmp    byte ptr es:[di],'a'
        je     got_a1
        cmp    byte ptr es:[di],'A'
        je     got_a1
        jmp    exit_43
got_a1:
        dec    di
        cmp    byte ptr es:[di],'.'
        je     got_p1
        jmp    exit_43
got_p1:
        pop    es
        pop    di
        pop    cx
        pop    ax
        clc
        mov    cx,10h
         jmp    ret_far_2
exit_43:
        pop    es
        pop    di
        pop    cx
        pop    ax
        jmp  exit_4
its_an_arc: ;!
; have our baby, now we have to set things up
         push   ax
         mov    cs:dtadx,dx
         mov    cs:dtads,ds
         mov    cs:dtacx,cx
         call   set_stack
         call   setup_first
         jnc    good_setup
         jmp    file_not_found
good_setup:
         call   set_psp
         call   open_arc
         jnc    open_good
         jmp    file_not_found
open_good:
         call   get_next
         jnc    good_first_get
         jmp    file_not_found
good_first_get:
         call   check_match
         jnc    good_match
         jmp    open_good     ; look for match
good_match:
         call   setup_dta
file_found:
         call   reset_psp
         call   reset_stack
         pop    ax
         mov    al,0
         push   ax
         clc
         jmp    ret_far_2
get_more_files:
         call   get_next
         jnc    good_first_get
no_more_files:
         call   reset_psp
         call   close_old
         call   reset_stack
         pop    ax
         mov    al,18
         push   ax
         stc
         jmp    ret_far_2
file_not_found:
; this returns with errors and flags set for not found
         call   reset_psp
         call   close_old
         call   reset_stack
         pop    ax
         mov    al,2
         push   ax
         stc
ret_far_2:
         pop    ax
         mov    cs:semaphore,0
;        ret    far  2
        db    0cah,2,0
;
;   SERVICE ROUTINES
;
setup_dta:
; this moves the stuff from the arc header into the dta
; that has to be returned to the calling program
;
; disk has to be 0 so we must get a disk
          cmp  archive+1,":"  ; does the arc filespec have a disk
          jne  get_cur_disk
          mov  al,archive
          and  al,0fh
          inc  al
          mov  disk,al
          jmp  got_cur_disk
get_cur_disk:
          mov  ah,19h
          mov  al,0
          int  21h
          inc  al
          mov  disk,al
got_cur_disk:
; move the dtatime, date,size and name from arc
         mov    ax,filecount
         mov    dircount,ax
         mov    dirflag,0
         mov    dirclust,29
          mov  attrib,0
          mov  ax,arctime
          mov  dtatime,ax
          mov  ax,arcdate
          mov  dtadate,ax
          mov  ax,word ptr arcsize
          mov  word ptr dtasize,ax
          mov  ax,word ptr arcsize+2
          mov  word ptr dtasize+2,ax
          lea  si,arcname
          lea  di,dtaname
          mov  cx,13
          cld
rep       movsb
; now I have to move the dta to the real dta
          push  es
          mov   ah,2fh
          int  21h
          mov  di,bx
          lea  si,dta
          mov   cx,43
          cld
rep       movsb
          pop   es
          clc
          ret
check_match:
; have a filespec from the archive file and a fcb from the
; dta have to parse the archive file guy and compare him to
; the dta guy
         lea    si,arcname
         lea    di,fcb
         mov    ah,29h
         mov    al,1
         int    21h
         cmp    al,0ffh
         jne    good_parse2
         stc
         ret
good_parse2:
; now a step by step compare of the file names
         lea   si,filename
         lea   di,pfile
         mov   cx,8
fn_loop:
         cmp   byte ptr ds:[si],'?'
         je    check_ext
         cld
         cmpsb
         jne   no_match
         loop  fn_loop
check_ext:
         lea   si,fileext
         lea   di,pext
         mov   cx,3
fn_loop1:
         cmp   byte ptr ds:[si],'?'
         je    check_ex1
         cmpsb
         jne   no_match
         loop  fn_loop1
check_ex1:
; got a match
         clc
         ret
no_match:
         stc
         ret
open_arc:
; this opens the arc up for reading
; the arc file is to the left of the filesi
     mov   cx,filesi
     dec   cx
     sub   cx,dtadx
; cx has the length of the achive file
     push  ds
     mov   si,dtadx
     mov   ds,dtads
     lea   di,archive
     cld
rep  movsb
     pop   ds
     mov   al,0
     stosb
;
; now we can open
;
     mov   ah,3dh
     mov   al,0
     lea   dx,archive
     int   21h
     jnc   good_open
     ret
good_open:
     mov   handle,ax
     clc
     ret
;
;
setup_first:
; cleans up the dta area for first find
;
; move the filepattern into findfile
         push   ds
         mov    si,filesi
         mov    ds,dtads
         lea    di,findfile
         mov    cx,15
         cld
rep      movsb
         pop    ds
; now parse it into the 21 bytes of the dta area
         lea    si,findfile
         lea    di,disk
         mov    ah,29h
         mov    al,1
         int    21h
         cmp    al,0ffh
         jne    good_parse
         stc
         ret
good_parse:
         mov    attrib,0
         mov    filecount,-1
         mov    dirflag,0
         clc
         ret
set_stack:
         pop    ax
         mov    cs:savess,ss
         mov    cs:savesp,sp
         mov    cs:workss,cs
         mov    ss,cs:workss
         lea    sp,stack+510
         push   bx
         push   cx
         push   dx
         push   si
         push   di
         push   bp
         push   ds
         push   es
         push   cs
         pop    ds
         push   cs
         pop    es
         push   ax
         ret
reset_stack:
         pop    ax
         pop    es
         pop    ds
         pop    bp
         pop    di
         pop    si
         pop    dx
         pop    cx
         pop    bx
         mov    ss,cs:savess
         mov    sp,cs:savesp
         push   ax
         ret
set_psp:
; this gets the old psp and saves it and sets the psp to current
          push     ax
          push     bx
          mov      ax,5100h
          mov      bx,0
          int      21h
          mov      cs:oldpsp,bx
          mov      ax,5000h
          mov      bx,cs
          int      21h
          pop      bx
          pop      ax
      ret
reset_psp:
; restores the old psp
          push     ax
          push     bx
          mov      ax,5000h
          mov      bx,cs:oldpsp
          int      21h
          pop      bx
          pop      ax
      ret
close_old:
; this closes an old arc
        push  ax
        push  bx
        push  cx
        push  si
        push  di
        push  ds
        push  es
        mov   ax,cs
        mov   ds,ax
        mov   es,ax
; set the psp to us
        call  set_psp
        mov   bx,handle
        mov   handle,0
        mov   ah,3eh
        int   21h
        call  reset_psp
        pop   es
        pop   ds
        pop   di
        pop   si
        pop   cx
        pop   bx
        pop   ax
        clc
        ret
check_spec:
; this routine checks to see if the filespec in ds:dx is an arc
; have to inspect the dx guy to see if its for us
        push  ax
        push  bx
        push  cx
        push  si
        push  di
        push  ds
        push  es
; need to find the .ARC\ in the file
        mov   si,dx
        mov   cs:arccheck,0
        cld
cf_loop:
        lodsb
        cmp  al,0
        je   exit_check_spec
        cmp  al,'.'
        jne  cf_loop
        lodsb
        cmp  al,0
        je   exit_check_spec
        cmp  al,'A'
        je   got_a
        cmp  al,'a'
        je   got_a
        jmp  cf_loop
exit_check_spec:
        pop   es
        pop   ds
        pop   di
        pop   si
        pop   cx
        pop   bx
        pop   ax
        stc
        ret
got_a:
        lodsb
        cmp  al,0
        je   exit_check_spec
        cmp  al,'R'
        je   got_r
        cmp  al,'r'
        je   got_r
        jmp  cf_loop
got_r:
        lodsb
        cmp  al,0
        je   exit_check_spec
        cmp  al,'C'
        je   got_c
        cmp  al,'c'
        je   got_c
        jmp  cf_loop
got_c:
        lodsb
        cmp  al,0
        je   got_arc_check
        cmp  al,'\'
        je   got_slash0
        jmp  cf_loop
got_arc_check:
        mov  cs:arccheck,1
        jmp  exit_check_spec
got_slash0:
        mov   cs:filesi,si
got_slash:
; si is pointing to last space beyond backslash
; have to make sure there are no other backslashses
        lodsb
        cmp  al,0
        je   found_check_spec
        cmp  al,'\'
        jne  got_slash
        jmp  exit_check_spec
found_check_spec:
        pop   es
        pop   ds
        pop   di
        pop   si
        pop   cx
        pop   bx
        pop   ax
        clc
        ret
get_next:
; read next directory entry from arc file
          inc  filecount
          mov  bx,handle
          lea  dx,archead
          mov  cx,29
          mov  ah,3fh
          int  21h
          jc   not_good_read
          cmp  ax,cx
          je   good_read
not_good_read:
          stc
          ret
good_read:
          cmp  arcvers,0
          je   not_good_read
; seek to next head
; the read/write pointer would have been saved here if the
; program was going to read the fool file
          mov   cx,word ptr arcsize+2
          mov   dx,word ptr arcsize
          mov   ah,42h
          mov   al,1
          mov   bx,handle
          int   21h
; carry may be set if we read past the end of the file
; which is good which means an invalid arc and we must exit now
          ret
;
; we have run out of directory so close the directory
main         ENDP
setres  proc  near
startres:
        mov   ax,3521h
        int   21h
        mov   int21cs,es
        mov   int21ip,bx
        mov   ah,25h
        mov   al,21h
        lea   dx,arcer
        int   21h
        lea   dx,mess1
        mov   ah,9
        int   21h
        lea   dx,startres
        int 27h
mess1   db   13,10,'Here we go!',13,10,'$'
setres  endp
CSEG        ENDS
        END        ENTPT
