dseg     segment para public 'data'
;
;
;
; windows start here
;  menu structure is:
;    db height
;    db width
;    db x loc
;    db y loc
;    db color
;    db lines of data
;    db 0
;
error0  db 03,22,30,06,0f1h
        db  ' Field is in error',0
;
;
wait0   db 03,38,22,06,0f1h
        db  'Please wait while file is created  ',0
;
errorsave dw 5*42 dup(0)
;
helpsave  dw 20*42 dup(0) ; for all helps

help0   db 08,55,10,15,07h
 db  ' To Compile a Text file into a COM file, enter the',13,10
 db  ' name of the TEXT file to be compiled, the name of',13,10
 db  ' the COM file to be created. You must choose which',13,10
 db  ' kind of COM file to create and enter a heading if',13,10
 db  ' you need one.',13,10
 db  '      Press the F10 when you are finished.',13,10
 db  '      Press the ESC key if you wish to quit.',0
help1   db 05,40,20,13,70h
     db  ' TEXT file is the name of a file that',13,10
     db  ' will be processed into a COM file.',13,10
     db  '     press any key to continue',0
;
help2   db 07,40,20,15,70h
     db  ' COM file is the name of the DOS .COM',13,10
     db  ' file that will be created from the',13,10
     db  ' TEXT file. The file should end with',13,10
     db  ' the extension .COM.',13,10
     db  '     press any key to continue',0
;
;
help3   db 06,40,20,15,70h
     db  ' HEADING is a line of text that will',13,10
     db  ' appear at the top of every page of',13,10
     db  ' displayed text.',13,10
     db  '     press any key to continue',0
;
help4   db 08,40,20,15,70h
     db  ' FILE TYPE is the type of file that',13,10
     db  ' will be created by TXT2COM.',13,10
     db  ' 1 - is a normal COM file.',13,10
     db  ' 2 - is a TSR or Resident program.',13,10
     db  ' 3 - is a temporary TSR (PASSTHRU). ',13,10
     db  '     press any key to continue',0
;
;
;
;
; fl types
fl1    db "D",46,0,16,1,071h,017h,' '
     dw  head1
head1     db '     TXT2COM Text file compiler                      '
fl2    db "D",44,0,17,2,071h,017h,' '
     dw  head2
head2     db "Vers 3.00 Copyright 1989 by Keith P. Graham   "
fl3    db "D",14,0,05,04,041h,017h,' '
     dw  title1
title1    db "TEXT file:      "
fl4    db "C",48,0,21,04,70h,07h,' '
     dw  tfile
tfile   db 50 dup(20h)
fl5    db "D",14,0,05,06,41h,17h,' '
     dw  title2
title2    db "COM File:       "
fl6    db "C",48,0,21,06,70h,07h,' '
     dw  cfile
cfile     db 50 dup(20h)
fl7    db "D",14,0,05,08,41h,17h,' '
     dw  title3
title3    db "HEADING:        "
fl8    db "C",80,0,0,09,70h,07h,' '
     dw  hline
hline     db 81 dup(' ')
f19    db "D",14,0,05,11,41h,17h,' '
     dw  title4
title4    db "FILE TYPE:      "
f20    db "N",1,0,21,11,70h,07h,' '
     dw  ftype
ftype     db 2 dup(' ')
;
; structure for fl stuff
;
enterline  dw  (end_tst-$-2)/2
     dw  fl1,fl2,fl3,fl4,fl5,fl6,fl7,fl8,f19,f20
;    dw  fl8,fl9,fl10,fl9a,fl10a,fl11,fl12,fl13,fl14
end_tst equ this byte
clearscreen dw 1,cls
cls    db "D",1,0,16,1,070h,007h,' '
     dw  cls1
cls1      db ' '
;
;
eflag  db  0
ihandle dw 0
ohandle dw 0
public ohandle,ihandle,cfile,hline,tfile,ftype
;
;
serialno  dw  0
tname   db  44 dup(20h)
;
;
extrn exit_phase:word,buffer:word
dseg ends
cseg     segment para public 'CODE'
     assume   cs:cseg,ds:dseg,es:dseg
extrn forms:near,reset_segs:near
mainl    proc     near
main:
public main
;
;  ah has the attribute if we clear screen
;  al has the fl to get if we want to get just 1 fl
;  al has a 0ffh if we want to get all fls
;  al is 0 if we just want to display
;  bx has the fl to start phase cronology from
     lea     si,enterline
     mov     ax,1700h
     mov     bx,0
     call     forms
     lea   si,help0
     lea   di,helpsave
     call  do_window
     mov     bx,3   ; start with field 4
enter_loop:
     lea     si,enterline
     mov     ax,0ffh
     call     forms
     cmp     al,3bh     ; F1
     je     help_fields
     cmp     al,44h     ; F10
     je     check_fields
     cmp     ah,27
     je     exit_prog
     lea     si,enterline
     mov     ax,0ffh
     mov     bx,exit_phase
     jmp     enter_loop
exit_prog:
; clear the screen
     jmp   go_home
check_fields:
    jmp  check_fields0
help_fields:
extrn  do_window:near,undo_window:near

     mov     bx,exit_phase
     sub   bx,3
     jmp   cs:helps[bx]
helps dw do_help1,do_help2,do_help3,do_help4
set_window:
     cmp   eflag,1
     jne   no_error_check
     push  si
     push  di
     mov   bx,exit_phase
     inc   bx
     shl   bx,1
     mov   si,word ptr enterline[bx]
     mov   al,byte ptr ds:[si]+4
     inc   al
     mov   error0+3,al
     mov   al,byte ptr ds:[si]+3
     mov   error0+2,al
     lea   si,error0
     lea   di,errorsave
     call  do_window
     pop   di
     pop   si
no_error_check:
     push  si
     push  di
     call  do_window
     mov   ah,0
     int   16h
     pop   di
     pop   si
     call  undo_window
     cmp   eflag,1
     jne   exit_help
     mov   eflag,0
     lea   si,error0
     lea   di,errorsave
     call  undo_window
exit_help:
     mov     bx,exit_phase
     jmp     enter_loop
do_help1:
     lea   si,help1
     lea   di,helpsave
     jmp   set_window
do_help2:
     lea   si,help2
     lea   di,helpsave
     jmp   set_window
do_help3:
     lea   si,help3
     lea   di,helpsave
     jmp   set_window
do_help4:
     lea   si,help4
     lea   di,helpsave
     jmp   set_window
check_fields0:
; check each field
; check field 3, density first
     cmp    tfile,' '
     je     bad_c1
     jmp    good_field1
bad_c1:
     mov    eflag,1
     mov    exit_phase,3
     jmp    do_help1
good_field1:
     cmp    cfile,' '
     je     bad_c2
     jmp    good_field2
bad_c2:
     mov    eflag,1
     mov    exit_phase,5
     jmp    do_help2
good_field2:
     cmp    ftype,'1'
     jl     bad_c4
     cmp    ftype,'3'
     jg     bad_c4
     jmp    good_field2a
bad_c4:
     mov    eflag,1
     mov    exit_phase,9
     jmp    do_help4
good_field2a:
; here we have to open the input file
     lea   di,tfile
     cld
     mov   al,20h
     mov   cx,54
repne  scasb
    jne   bad_c1
     dec  di
     mov  al,0
     stosb
; have the end of the guy
    lea   dx,tfile
    call  open_input
    jnc   good_field3
    jmp   bad_c1
good_field3:
; same thing with the output file
;
     lea   di,cfile
     cld
     mov   al,20h
     mov   cx,54
repne  scasb
    jne   bad_c2
     dec  di
     mov  al,0
     stosb
; have the end of the guy
    lea   dx,cfile
    call  open_output
    jnc   good_field4
    jmp   bad_c2
good_field4:
;
;
go_home:
     lea     si,clearscreen
     mov     ax,0700h
     mov     bx,0
     call    forms
     ret
;
open_output:
    mov   cx,0
    mov   ax,3c00h  ;create
    int   21h
    jnc   good_open_out
    ret
good_open_out:
     mov   ohandle,ax
     clc
     ret
;
open_input:
; open a file for i/o
     mov   cx,0
     mov   ax,3d00h
     int   21h
     jnc   good_open_in
     stc
     ret
good_open_in:
     mov   ihandle,ax
     clc
     ret
;
mainl endp
cseg     ends
     end
