vwid equ 256
cseg   segment para public 'CODE'
   assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
   org   100h
start: jmp  main
;
; data goes here
;
filename  db 63 dup(0)
buffer   db vwid dup(0)
handle   dw 0
xloc   dw 0
yloc   dw 0
colors db 00000000b
       db 00111000b ; lght black ?
       db 00000100b ;dk red
       db 00111100b ;l  red
       db 00000110b ;dark yellow
       db 00111110b ; yellow
       db 00000111b ; white
       db 00111111b ; br white
       db 00000011b ; cyan
       db 00111011b ; light cyan
       db 00000010b ; green
       db 00111010b ; light green
       db 00000001b ; blue
       db 00111001b ; bright blue
       db 00000101b ; magenta
       db 00111101b ; light magenta
       db 00000001b
       db 0
main   proc   near
; code goes here
   call   parse
   jc     error
   call   open
   jc     error
   jmp    cont
error:
   int   20h
cont:
   mov   ax,10h
   int   10h
   mov   ax,1002h
   lea   dx,colors
   int   10h
;
; set the write mode
   mov   al,5
   mov   ah,2
   mov   dx,3ceh
   out   dx,ax

   mov   bx,0
;
show_loop:
   push  bx
   lea   dx,buffer
   mov   bx,handle
   mov   ah,3fh
   mov   cx,vwid
   int   21h
   pop   bx
   cmp   ax,cx
   jne   done
   mov   xloc,0
   lea   si,buffer
   mov   cx,vwid
   mov   ax,0a000h
   mov   es,ax
   mov   bp,0
lloop:
   push  cx
   mov   ah,0
   lodsb
   push  si
   shl   ax,1
   shl   ax,1
   shl   ax,1
   add   bp,ax   ; add to accumulator what we read
   mov   ax,bp
   shr   ax,1
   shr   ax,1
   shr   ax,1
   shr   ax,1
   mov   dx,ax
   shl   dx,1
   shl   dx,1
   shl   dx,1
   shl   dx,1
   sub   bp,dx
   call  do_ega_dot
   pop   si
   pop   cx
   loop   lloop
   inc   bx
   jmp   show_loop
done:
   mov  ax,0ff08h
   mov   dx,3ceh
   out   dx,ax
   mov   ax,0f02h
   mov   dx,3c4h
   out   dx,ax
   mov   ah,0
   int   16h
backout:
   mov   ax,3
   int   10h
   int  20h   ; return to dos
eighty  dw 80
do_ega_dot:
; al has the color to do
; cx has the column, bx has the row
   push  bx
   push  ax
   mov   ax,bx
   mul   eighty
   mov   bx,ax
   mov   ax,vwid
   sub   ax,cx
   mov   cx,8
   mov   dx,0
   div   cx
   add   bx,ax
   mov   cx,dx
   mov   ah,80h
   shr   ah,cl
;  ax has the bit mask
   mov   al,8  ; bit mask index
   mov   dx,3ceh
   out   dx,ax
   mov   al,es:[bx]
   pop   ax
   mov   es:[bx],al
   pop   bx
   ret
parse:
   lea   di,filename
   mov   si,81h
p1:
   lodsb
   cmp  al,20h
   je   p1
   cmp  al,13
   je   bad_p
p2:
   stosb
   lodsb
   cmp  al,20h
   je   p3
   cmp  al,13
   je   p3
   jmp  p2
p3:
   clc
   ret
bad_p:
   stc
   ret
open:
   lea   dx,filename
   mov   ax,3d00h
   mov   cx,0
   int   21h
   jnc   good_open
   stc
   ret
good_open:
   mov   handle,ax
   clc
   ret
main   endp
cseg   ends
   end   start
