; appends a path to the PATH variable
;
print macro string
mov ah,9
mov dx,offset string
int  21h
endm
cseg segment para public 'CODE'
assume cs:cseg,ds:cseg,es:cseg
   org 100h
entry:
      jmp   start
;
; DATA
;
hello db 13,10,'BIGPATH Version 1.0 copyright 1992 by Keith P. Graham',13,10
      db 'For latest release call Keith Graham Support BBS at',13,10
      db '(914) 623-0039',13,10,'$'

bad   db 'Usage:',13,10
      db 'BIGPATH path',13,10
      db 'appends path to current path beyond 128 bytes',13,10,'$'
envseg	DW	0		; environment seg
path  db 'PATH='
      db 12 dup(0)



start:
        print hello
        cmp   byte ptr ds:[80h],1
        jg    start2
        print bad
        int   20h
start2:
	;===============================:
	; first, test for MS-DOS or 4DOS:
	;===============================:
	mov	ax, 0D44Dh	; 4DOS swap area
	mov	bx, 0
	int	2Fh		; and interrupt it
	;===============================:
	;IF ax = 44DD, 4DOS is used.	:
	;===============================:
	cmp	ax, 44DDh	; compare the deal
	je	IS_4DOS	; and if equal, its 4DOS
	mov	ax, 352Eh	; find the master env
	int	21h
	mov	ax, es:2Ch	; es = environment segment
	jmp	short	dos_checked	; jump past 4dos stuff
is_4dos:
	mov	es, cx		; es = 4dos environment segment
	mov	ax, es:2Ch
dos_checked:
	mov	envseg, ax
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
; copy environment to buffer
        mov     bx,0
        mov     di,offset buffer
        xor     si,si
        mov     al,-1
        push    ds
        mov     ds,envseg
copy_loop:
        mov     bl,al
        cld
        lodsb
        stosb
        cmp    al,0
        jne    copy_loop
        cmp    al,bl
        jne    copy_loop
; now copy the environment back
        pop    ds
        mov    es,envseg
        mov    si,offset buffer
        xor    di,di
back_loop:
; looking for PATH=
        call  check_path
        jnc   next_0
        call  append_path
        jmp   finish_env
next_0:
        lodsb
        stosb
        cmp   al,0
        jne   next_0
        jmp   back_loop
finish_env:
        mov   al,0
f_loop:
        mov   dl,al
        lodsb
        stosb
        cmp   al,0
        jne   f_loop
        cmp   al,dl
        jne   f_loop
        int 20h
append_path:
; add existing path
        lodsb
        cmp   al,0
        je    do_append
        push  ax
        mov   ah,14
        int   10h
        pop   ax
        stosb
        jmp   append_path
do_append:
        push  si
        mov   si,81h
        mov   cl,byte ptr ds:[80h]
        mov   ch,0
        cmp   cx,1
        jg    a_1
        jmp   done_append
a_1:
        lodsb
        cmp   al,20h
        je    a_2
        cmp   al,9
        je    a_2
        cmp   al,';'
        je    a_4
        cmp   al,13
        je    done_append
        jmp   a_3
a_2:
     loop   a_1
     jmp   done_append
a_3:
     push  ax
     mov   al,';'
     stosb
        push  ax
        mov   ah,14
        int   10h
        pop   ax
     pop   ax
a_4:
     jmp   a_6
a_5:
     lodsb
a_6:
        cmp   al,20h
        je    done_append
        cmp   al,9
        je    done_append
        cmp   al,13
        je    done_append
     cmp   al,'a'
     jl    a_7
     cmp   al,'z'
     jg    a_7
     sub   al,20h
a_7:
     stosb
        push  ax
        mov   ah,14
        int   10h
        pop   ax
     loop  a_5
done_append:
       pop   si
       mov   ah,14
       mov   al,13
       int   10h
       mov   ah,14
       mov   al,10
       int   10h
       mov   al,0
       stosb
       clc
       ret
check_path:
        mov   cx,17
        mov   bx,offset path
        int 3
a_loop:
        cmp byte ptr ds:[si],0
        je  not_path
        cmp byte ptr ds:[bx],0
        je  is_path
        lodsb
        stosb
        cmp   al,byte ptr ds:[bx]
        jne   not_path
        inc   bx
        loop  a_loop
is_path:
        stc
        ret
not_path:
        clc
        ret

buffer	DB	0	; temp storage buffer
cseg ends
end entry
