; this is a program to display the calendar information on the screen
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org   100h
start: jmp  main
stack   dw   256  dup(0)
upleft  equ  201
upright equ  187
loleft  equ  200
loright equ  188
horiz   equ  205
vert    equ  186
color   equ  17h
mode  dw 0b800h
cursor dw 0
cursmode dw 0
bhpage db 0
;
buffer1 db  4000 dup(0)
buffer2 db  4000 dup(0)
main      proc     near
        lea  sp,stack+510
          lea  di,buffer1
          call  pushb
        call frame1
          lea  si,buffer1
          call popb2
          int  20h
frame1:
; this draws the frame for the calendars
; draw the box
; top line
   mov  dh,2
   mov  dl,10
   mov  ah,2
   mov  bx,0
   int  10h
; draw upper left
   mov  ah,9
   mov  cx,1
   mov  al,upleft
   mov  bl,color
   int  10h
; mov line of horiz
   mov  dh,2
   mov  dl,11
   mov  ah,2
   mov  bx,0
   int  10h
   mov  ah,9
   mov  cx,58
   mov  al,horiz
   mov  bl,color
   int  10h
; upper right
   mov  dh,2
   mov  dl,69
   mov  ah,2
   mov  bx,0
   int  10h
; draw upper right
   mov  ah,9
   mov  cx,1
   mov  al,upright
   mov  bl,color
   int  10h
; loop the box
   mov  cx,20
bloop1:
   push  cx
   inc  dh
   mov  dl,10
   mov  ah,2
   mov  bx,0
   int  10h
; draw upper left
   mov  ah,9
   mov  cx,1
   mov  al,vert
   mov  bl,color
   int  10h
; mov line of horiz
   mov  dl,11
   mov  ah,2
   mov  bx,0
   int  10h
   mov  ah,9
   mov  cx,58
   mov  al,32
   mov  bl,color
   int  10h
; upper right
   mov  dl,69
   mov  ah,2
   mov  bx,0
   int  10h
; draw upper right
   mov  ah,9
   mov  cx,1
   mov  al,vert
   mov  bl,color
   int  10h
   pop   cx
   loop   bloop1
;
;
;
;
   mov  ah,0
   int  16h
   ret
popb3:
   call  set_pop
   call  method3
   ret
popb2:
   call  set_pop
   call  method2
   ret
popb1:
   call  set_pop
   call  method1
   ret
set_pop:
   mov   ax,cs
   mov   ds,ax
   mov   ax,mode
   mov   es,ax
   mov   di,0
   ret
method3:
; this moves the screen down
  add    si,3840  ; bottom line
  mov    cx,25  ; count of lines
m3loop:
  call   waitx
  push   cx
; scroll the screen down one
  push   si
  mov  ax,0701h
  mov  dx,184fh
  mov  cx,0
  mov  bx,0700h
  int  10h
  pop   si
; mov a line into place
  push  si
  mov   di,0
  mov   cx,80
  cld
rep movsw
  pop   si
  sub   si,160
   pop   cx
   loop  m3loop
   call  retcurs
   ret
method2:
; this method scatters the words to the screen
   mov   cx,50
   mov   bx,94
   mov   bp,0
m2loop:
  push  cx
  mov   cx,40
m2loop1:
  push  cx
  call   addx
  pop   cx
  loop m2loop1
  call waitx
   pop   cx
   loop  m2loop
   call  retcurs
   ret
waitx:
    push  cx
w1:
   mov   ax,0
   int   1ah
   cmp   dx,bp
   je    w1
   mov   bp,dx
   pop   cx
   ret
addx:
   add   bx,374
   cmp   bx,4000
   jl    okm2
   sub   bx,4000
okm2:
   call  movx
   ret
movx:
   mov   ax,word ptr ds:[si+bx]
   mov   word ptr es:[di+bx],ax
   ret
method1:
   mov   cx,25*80
   cld
rep  movsw
   call  retcurs
   ret
pushb:
; this saves the screen
        call  getcurs
        mov   bx,0b800h
        cmp   al,4
        jle   got_mode
        mov   bx,0b000h
        cmp   al,7
        je    got_mode
        int   20h
got_mode:
        mov   mode,bx
        mov   si,0
        push  ds
        mov   cx,25*80
        cld
        mov  ds,bx
rep     movsw
        pop   ds
        ret
main      endp
getcurs   proc  near
; get video state
          mov ah,15
          int 10h
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcurs   endp
retcurs   proc  near
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcurs   endp
; the tone routines produce glisandos based on the value of si
blip    proc  near
        push  si
        mov   si,30
        call  tone
        pop   si
        ret
blip    endp
blop    proc  near
        push  si
        mov   si,-30
        call  tone
        pop   si
        ret
blop    endp
tone    proc  near
        push  ax
        push  bx
        push  cx
        push  dx
        mov   dx,3    ; tone rate
        mov   bx,240  ; starting freq
        mov   cx,750  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,630  ; starting freq
        mov   cx,150  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
tone    endp
cseg      ends
          end      start
