Print macro string
      lea  dx,string
      mov  ah,9
      int  21h
      endm
savecurs  macro wnum
          lea   di,wnum
          call  getcurs
          endm
restcurs  macro wnum
          lea   si,wnum
          call  retcurs
          endm
dowindow  macro x
        lea  ax,wsave&x
        mov  wsave,ax
        mov  rows,rows&x
        mov  cols,cols&x
        mov  windx,windx&x
        mov  windy,windy&x
        mov  color,color&x
        call setwind
        endm
unwindow  macro x
        lea  ax,wsave&x
        mov  wsave,ax
        mov  rows,rows&x
        mov  cols,cols&x
        mov  windx,windx&x
        mov  windy,windy&x
        mov  color,color&x
        call retwind
        endm
pwindow macro x
        lea  si,x
        call putwind
        endm
cSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG ;ALREADY SET BY DOS LOADER
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        setres                       ;COM FILE ENTRY ALWAYS AT 100H
; data areas
; the window is  32 columns by 23 lines
copyw  db 'CDISK Disk Access Monitor.'
       db 'Copyright 1984, 1991 by Keith P. Graham'
  db ' 238 Germonds Road, West Nyack, NY 10994'
      db  'Next 4 bytes are scan1,shift1,scan2,shift2:'
hscan1   db 20h     ; these are the hot key combinations
hshift1  db 10      ; scan being the scan code and shift being
hscan2   db 83h     ; the shift state.
hshift2  db 12      ;
 db 1ah


;===================================================;
rows1    equ 13                                     ;
cols1    equ 31                                     ;
windx1   equ 24                                     ;
windy1   equ 4                                      ;
color1   equ 07h                                    ;
window1  db  '   CDISK Disk Access Monitor',10       ;
         db  '  Registered to Edison State',10
         db  '      Community College',10
         db  ' Esc Exit',10                         ; window1
         db  ' F1 Help Menu',10                     ;
         db  ' F2 Write Protect Disk Drive',10      ;
         db  ' F3 Write Enable Disk Drive',10      ;
         db  ' F4 Open Disk Drive Door',10          ;
         db  ' F5 Close Disk Drive Door',10           ;
         db  ' F6 Display Disk Status',10           ;
         db  ' F7 Display Disk Statistics',10,0     ;
wsave1  dw rows1*cols1 dup(0)                       ;
cursor1  equ this byte                              ;
bhpage1   db  0                                     ;
cursor1x  dw  0                                     ;
cursmode1 dw  0                                     ;
;===================================================;
rows2    equ 5                                      ;
cols2    equ 24                                     ;
windx2   equ 32                                     ;
windy2   equ 10                                     ;
color2   equ 70h                                    ;
window2  db  ' Write Protect a Disk',10       ;
         db  '  Enter Drive Letter',10            ;
         db  '   Esc=Exit F1=Help',0
window3  db  '  Write Enable a Disk',10       ;
         db  '  Enter Drive Letter',10            ;
         db  '   Esc=Exit F1=Help',0
window4  db  ' Open Disk Drive Door',10       ;
         db  '  Enter Drive Letter',10            ;
         db  '   Esc=Exit F1=Help',0
window5  db  ' Close Disk Drive Door',10       ;
         db  '  Enter Drive Letter',10            ;
         db  '   Esc=Exit F1=Help',0
wsave2  dw rows1*cols2 dup(0)                       ;
cursor2  equ this byte                              ;
bhpage2   db  0                                     ;
cursor2x  dw  0                                     ;
cursmode2 dw  0                                     ;
;===================================================;
rows7    equ 17                                     ;
cols7    equ 34                                     ;
windx7   equ 31                                     ;
windy7   equ 5                                      ;
color7   equ 0Fh                                    ;
window7 db '  CDISK Disk Access Monitor',10       ;
        db '    Disk Status settings',10            ;
        db ' Disk   Write      Door',10
        DB ' Drive  Protect    Status',10
statusarea equ this byte + 8
   db '  A:    Normal     Normal   ',10
   db '  B:    Normal     Normal   ',10
   db '  HD0   Normal     Normal   ',10
   db '  HD1   Normal     Normal   ',10
   db '  HD2   Normal     Normal   ',10
   db '  HD3   Normal     Normal   ',10
   db '  HD4   Normal     Normal   ',10
   db '  HD5   Normal     Normal   ',10
   db '  HD6   Normal     Normal   ',10
   db '  HD7   Normal     Normal   ',10
   db ' Esc=Exit F1=Help F10=Reset',0
wsave7  dw rows7*cols7 dup(0)                       ;
cursor7  equ this byte                              ;
bhpage7   db  0                                     ;
cursor7x  dw  0                                     ;
cursmode7 dw  0                                     ;
status1   db  'Protected'
status2   db  'Open     '
status3   db  'Normal   '
;===================================================;
writep_tab db 10 dup(0)  ; these 2 belong
open_tab db 10 dup(0)    ; together
;===================================================;
dispfill  proc  near
; fills up screen 7
          mov  cx,10  ; number of lines
          lea  di,statusarea
          mov  bx,0
d_fill0:
          push cx
          push di
          lea  si,status3
          cmp  writep_tab[bx],1
          jne  d_fill1
          lea  si,status1
d_fill1:
          mov  cx,9
          cld
rep       movsb
          inc  di
          inc  di
          lea  si,status3
          cmp  open_tab[bx],1
          jne  d_fill2
          lea  si,status2
d_fill2:
          mov  cx,9
          cld
rep       movsb
          pop  di
          pop  cx
          add  di,29
          inc  bx
          loop d_fill0
          ret
dispfill  endp
;===================================================;
rows6    equ 17                                     ;
cols6    equ 62                                     ;
windx6   equ 10                                     ;
windy6   equ 2                                      ;
color6   equ 0Fh                                    ;
window6 db  '              CDISK Disk Access Monitor',10       ;
        db '          Disk Statistics - Counts of Sectors',10            ;
   db ' (Speed is average access time per sector in milliseconds)',10
   db ' Disk  Reads  Writes Verifies Formats Errors  Avg. Speed',10
   firstdec equ this byte+6   ; THEY ARE 55 BYTES LONG
   db '  A:  ______  ______  ______  ______  ______  ______   ',10
   db '  B:  ______  ______  ______  ______  ______  ______   ',10
   db '  HD0 ______  ______  ______  ______  ______  ______   ',10
   db '  HD1 ______  ______  ______  ______  ______  ______   ',10
   db '  HD2 ______  ______  ______  ______  ______  ______   ',10
   db '  HD3 ______  ______  ______  ______  ______  ______   ',10
   db '  HD4 ______  ______  ______  ______  ______  ______   ',10
   db '  HD5 ______  ______  ______  ______  ______  ______   ',10
   db '  HD6 ______  ______  ______  ______  ______  ______   ',10
   db '  HD7 ______  ______  ______  ______  ______  ______   ',10
   db '  Esc=Exit  F1=Help  F10=Reset totals to zero',0
wsave6  dw rows6*cols6 dup(0)                       ;
cursor6  equ this byte                              ;
bhpage6   db  0                                     ;
cursor6x  dw  0                                     ;
cursmode6 dw  0                                     ;
drive1  dw 120 dup(0)  ; 6 double words of counts for 10 disks
drives  dw  drive1
        dw  drive1 + 24
        dw  drive1 + 48
        dw  drive1 + 72
        dw  drive1 + 96
        dw  drive1 + 120
        dw  drive1 + 144
        dw  drive1 + 168
        dw  drive1 + 192
        dw  drive1 + 216
;===================================================;
rowsh1   equ 15                                     ;
colsh1   equ 50                                     ;
windxh1  equ 4                                      ;
windyh1  equ 4                                      ;
colorh1  equ 0Fh                                    ;
help1    db  '     CDISK Disk Access Monitor',10       ;
         db  '          Help Index',10                ;
         db  '  Esc = return to previous menu',10    ; windowh1
         db  '  F1 This menu',10               ;  help 1
         db  '  F2 How to use help',10               ;  help 1
         db  '  F3 Write Protecting Drives',10      ;
         db  '  F4 Opening Drive Doors',10          ;
         db  '  F5 Display Disk Status',10           ;
         db  '  F6 Display Disk Statistics',10       ;
         db  '  F7 Starting Up CDISK',10,0           ;
wsaveh1   dw rowsh1*colsh1 dup(0)                   ;
cursorh1  equ this byte                             ;
bhpageh1   db  0                                    ;
cursorh1x  dw  0                                    ;
cursmodeh1 dw  0                                    ;
help2    db  '       CDISK Disk Access Monitor',10       ;
         db  '         How to use CDISK help',10         ;
         db  ' Every screen In CDISK has a corresponding',10 ;
         db  ' HELP screen associated with it. The F1',10   ;
         db  ' function key always gives you a HELP',10
         db  ' screen with information about the current',10
         db  ' menu screen. When the HELP screen pops up',10
         db  ' you can get the HELP index by pressing the',10
         db  ' Home key. PgUp and PgDn keys will move you',10
         db  ' from one HELP screen to the next. Esc',10
         db  ' will always allow you to move to the ',10
         db  ' previous menu.'
         db  0                                      ;
;===================================================;
help3    db  '    Help 3 - Write Protecting Drives',10
         db  ' CDISK can intercept any attempt to write',10
         db  ' to a PHYSICAL floppy or hard disk drive',10
         db  ' and fake the operating system into act-',10
         db  ' ing as though the diskette has a write',10
         db  ' protect tab on it. This works equally as',10
         db  " well for hard disks. CDISK can't protect",10
         db  ' device drivers disks or RAM disks.',10
         db  ' CDISK acts at a very low (BIOS) level so',10
         db  ' it does not even try to look at device',10
         db  ' drivers or virtual hard disk volumes. If',10
         db  ' you write protect a hard disk, you do it',10
         db  ' to the whole disk, not just a volume.',0
;===================================================;
help4    db  '   Help 4 - Opening Drive Doors',10
         db  " Of course, you can't open the drive door",10
         db  ' through software, but what you can do is',10
         db  ' make the disk read procedures think that',10
         db  ' the door is open by intercepting reads',10
         db  ' and writes to the disk drives. In this',10
         db  ' way it possible to make it look like the',10
         db  ' hard disk has a door that can be opened.',10
         db  ' This could protect your hard disk from',10
         db  ' uncontrolled programs which may damage',10
         db  ' diskette data. F4 and F5 open and close',10
         db  ' the disk drive door, and F6 will tell the',10
         db  ' current status of disk drives.',0
;===================================================;
help5    db  ' Help 5 - Displaying Drive Status',10
         db  ' Pressing F6 from the Main Menu displays',10
         db  ' a drive status screen showing each drive',10
         db  ' as either being Normal, Protected or',10
         db  ' Open. The screen does not indicate that',10
         db  ' it can tell when a drive door is open or',10
         db  ' if a disk is write protected, rather it',10
         db  ' is showing that you have opened the door',10
         db  ' or protected a disk through CDISK.',10
         db  ' It is possible to reset all of the',10
         db  ' options set by CDISK by pressing the',10
         db  ' F10 key while at this screen',0
;===================================================;
help6    db  '  Help 6 - Drive Statistics',10
         db  ' CDISK not only imitates an open drive door',10
         db  ' or a write protect tab, but also keeps a',10
         db  ' tally of drive activity by the type of disk',10
         db  ' access. CDISK also keeps a count of disk',10
         db  ' errors and the time it takes to access the',10
         db  " disks. Time is displayed in 1/1000's of a",10
         db  " second. Since the PC keeps track of time in",10
         db  ' in units of about .05 seconds, the timing',10
         db  ' is a little crude. The more accesses,',10
         db  ' however, the more accurate the timing will be.',10
         db  ' If timeouts occur, the timing may overflow',10
         db  ' and show a zero for speed.',0
;===================================================;
help7    db  ' Help 7 - Starting up CDISK',10
         db  ' CDISK is started from the DOS command line',10
         db  ' by typing CDISK. CDISK will check to see',10
         db  ' if it is already resident and inform you',10
         db  ' so. Command line switches can be added to',10
         db  ' write protect drives by placing the drive',10
         db  ' letters on the command line. ',10
         db  '   CDISK  C: D: E: would write protect the',10
         db  ' C: D: and E: disks.',10
         db  ' ',10
         db  ' ',0
;===================================================;
help8    db  'help screen 8',0
;===================================================;
help9    db  'help screen 9',0
;===================================================;
help10   db  'help screen 10',0
;===================================================;
helpnum   dw  1
int9      dd  0
int9ip   equ word ptr int9
int9cs   equ word ptr int9 + 2
int13     dd  0
int13ip   equ word ptr int13
int13cs   equ word ptr int13 + 2
int25     dd  0
int25ip   equ word ptr int25
int25cs   equ word ptr int25 + 2
savesp    dw  0
savess    dw  0
semaphore db  0
istack     db  256 dup(0)
;==============
rows  dw  0
window dw 0
wsave dw  0
windy db  0    ;   window temp storage areas
windx db  0
cols  dw  0
hidecurs  dw 0
color db  0
bhpage db 0
;==============
closed   proc near
        savecurs cursor2
        dowindow 2
        pwindow  window5
getchar5:
        jmp  gc5
nochar5:
        call blop
gc5:
        call blip
        mov  ah,0
        int  16h
        cmp  al,27
        jne no275
        jmp  exit_closed
no275:
        cmp  ah,3bh
        jne  no_3bh5
; help
        mov  helpnum,4  ; helps are not one for one
        call help
        jmp  getchar5
no_3bh5:
; not help or escape must be drive letter
        cmp  al,'A'
        jl   nochar5
        cmp  al,'j'
        jg   nochar5
        cmp  al,'J'
        jle  gd_5
        cmp  al,'a'
        jl   nochar5
        sub  al,32
gd_5:
  ; got a good drive
        sub  al,'A'
        mov  ah,0
        mov  bx,ax
        mov  open_tab[bx],0
exit_closed:
        unwindow 2
        restcurs cursor2
        ret
closed endp
;==============
opend    proc near
        savecurs cursor2
        dowindow 2
        pwindow  window4
getchar4:
        jmp  gc4
nochar4:
        call blop
gc4:
        call blip
        mov  ah,0
        int  16h
        cmp  al,27
        jne no274
        jmp  exit_opend
no274:
        cmp  ah,3bh
        jne  no_3bh4
; help
        mov  helpnum,4  ; helps are not one for one
        call help
        jmp  getchar4
no_3bh4:
; not help or escape must be drive letter
        cmp  al,'A'
        jl   nochar4
        cmp  al,'j'
        jg   nochar4
        cmp  al,'J'
        jle  gd_4
        cmp  al,'a'
        jl   nochar4
        sub  al,32
gd_4:
  ; got a good drive
        sub  al,'A'
        mov  ah,0
        mov  bx,ax
        mov  open_tab[bx],1
exit_opend:
        unwindow 2
        restcurs cursor2
        ret
opend  endp
;==============
writee   proc near
        savecurs cursor2
        dowindow 2
        pwindow  window3
getchar3:
        jmp  gc3
nochar3:
        call blop
gc3:
        call blip
        mov  ah,0
        int  16h
        cmp  al,27
        jne no273
        jmp  exit_writee
no273:
        cmp  ah,3bh
        jne  no_3bh3
; help
        mov  helpnum,3  ; helps are not one for one
        call help
        jmp  getchar3
no_3bh3:
; not help or escape must be drive letter
        cmp  al,'A'
        jl   nochar3
        cmp  al,'j'
        jg   nochar3
        cmp  al,'J'
        jle  gd_3
        cmp  al,'a'
        jl   nochar3
        sub  al,32
gd_3:
  ; got a good drive
        sub  al,'A'
        mov  ah,0
        mov  bx,ax
        mov  writep_tab[bx],0
exit_writee:
        unwindow 2
        restcurs cursor2
        ret
writee  endp
writep   proc near
        savecurs cursor2
        dowindow 2
        pwindow  window2
getchar2:
        jmp  gc2w
nochar2:
        call blop
gc2w:
        call blip
        mov  ah,0
        int  16h
        cmp  al,27
        jne no272
        jmp  exit_writep
no272:
        cmp  ah,3bh
        jne  no_3bh2
; help
        mov  helpnum,3  ; helps are not one for one
        call help
        jmp  getchar2
no_3bh2:
; not help or escape must be drive letter
        cmp  al,'A'
        jl   nochar2
        cmp  al,'j'
        jg   nochar2
        cmp  al,'J'
        jle  gd_2
        cmp  al,'a'
        jl   nochar2
        sub  al,32
gd_2:
  ; got a good drive
        sub  al,'A'
        mov  ah,0
        mov  bx,ax
        mov  writep_tab[bx],1
exit_writep:
        unwindow 2
        restcurs cursor2
        ret
writep  endp
;==============
dispstat proc near
        savecurs cursor7
; now we have to fill in window 7
        call dispfill
        dowindow 7
        pwindow  window7
getchar7:
        jmp  gc7
nochar7:
        call blop
gc7:
        call blip
        mov  ah,0
        int  16h
        cmp  al,27
        jne no277
        jmp  exit_disp
no277:
        cmp  ah,3bh
        jne  no_3bh7
; help
        mov  helpnum,7
        unwindow 7
        restcurs cursor7
        call help
        savecurs cursor7
        dowindow 7
        pwindow  window7
        jmp  getchar7
no_3bh7:
        cmp  ah,44h
        jne  no_44h7
        mov  cx,10
        lea  di,writep_tab
        cld
        mov  ax,0
rep     stosw
        call dispfill
        pwindow  window7
        jmp  getchar7
no_44h7:
        jmp  nochar7
exit_disp:
        unwindow 7
        restcurs cursor7
        ret
dispstat endp
;==============
diskstat proc near
        savecurs cursor6
; now we have to fill in window 6
        call diskfill
        dowindow 6
        pwindow  window6
getchar6:
        jmp  gc6
nochar6:
        call blop
gc6:
        call blip
        mov  ah,0
        int  16h
        cmp  al,27
        jne no276
        jmp  exit_stats
no276:
        cmp  ah,3bh
        jne  no_3bh
; help
        mov  helpnum,6
        unwindow 6
        restcurs cursor6
        call help
        savecurs cursor6
        dowindow 6
        pwindow  window6
        jmp  getchar6
no_3bh:
        cmp  ah,44h
        jne  no_44h
        lea  di,drive1
        mov  cx,120
        cld
        mov  ax,0
rep     stosw
        call diskfill
        pwindow  window6
        jmp  getchar6
no_44h:
        jmp  nochar6
exit_stats:
        unwindow 6
        restcurs cursor6
        ret
diskstat endp
saveax  dw  0
int13c  proc  near
        cmp   ax,'ZZ'
        jne   nogr
        cmp   word ptr copyw,'DC'
        jne   nogr
        mov   ax,'OK'
        push  cs
        pop   es
        iret
timerdx dw  0
nogr:
        sti
        mov    cs:semaphore,1
        mov    cs:saveax,ax
        push   ax
        push   bx
        push   cx
        push   dx
        mov    ah,0
        int    1ah
        mov    cs:timerdx,dx
        pop    dx
        pop    cx
        pop    bx
        pop    ax
        push   ax
        push   bx
        push   cx
        push   dx
        cmp    ah,2
        jl     get_real
        cmp    ah,5
        jg     get_real
        cmp    dl,9
        jg     get_real
; now we must determine the status of open_tab and writep_tab
; dl has the diskette drive in it
        cmp    ah,2
        je     check_open
        cmp    ah,4
        je     check_open
        mov    bl,dl
        mov    bh,0
        cmp    bx,80h
        jl     nohard
        sub    bx,7eh
nohard:
        cmp    cs:writep_tab[bx],0
        je     check_open
;       have to write protect disk
        push   ds
        mov    ax,40h
        mov    ds,ax
        mov    byte ptr ds:[41h],3
        pop    ds
        pop    dx
        pop    cx
        pop    bx
        pop    ax
        mov    ah,3
        mov    al,0
        stc
        jmp  bypass13
check_open:
        mov    bl,dl
        mov    bh,0
        cmp    bx,80h
        jl     nohard2
        sub    bx,7eh
nohard2:
        cmp    cs:open_tab[bx],0
        je     get_real
        push   ds
        mov    ax,40h
        mov    ds,ax
        mov    byte ptr ds:[41h],80h
        pop    ds
        pop    dx
        pop    cx
        pop    bx
        pop    ax
        mov    ah,80h
        mov    al,0
        stc
        jmp  bypass13
get_real:
        pop    dx
        pop    cx
        pop    bx
        pop    ax
        pushf
        clc
        call  cs:int13
bypass13:
        pushf
        call  count13
        mov    cs:semaphore,0
        popf
        db  0cah,02,00
int13c  endp
count13 proc near
; here we count up sectors read (13)
; dl has the drive number
; al has the number of sectors to read
; we want to update the drive with the proper class of access
        push ax
        pushf
        mov  ax,cs:saveax
        cmp  ah,1
        jg   c13_count
c13_12: ; exit for 1.2 meg drives
        popf
        pop  ax
        ret  ; go back for resets or status checks
c13_count:
        cmp  ah,5
        jg   c13_12
; have to save the registers we need
        popf
        push bx
        push cx
         pushf
        mov  bh,0
        mov  bl,dl
        cmp  bx,80h
        jl   nohard3
        sub  bx,7eh
nohard3:
        shl  bx,1
        mov  bx,cs:drives[bx]
        mov  cl,ah
        mov  ch,0
        dec  cx
        dec  cx
        shl  cx,1
        shl  cx,1
        push bx
        add  bx,cx
        mov  cl,al
        mov  ch,0
        cmp  ah,5
        jne  noformat
        mov  cx,9
noformat:
        add  cs:[bx],cx
        jnc  no_13_carry
        inc  word ptr cs:[bx]+2
no_13_carry:
        pop  bx
        popf
        jnc  no_13_errors
        inc  word ptr cs:[bx]+16
no_13_errors:
        push   dx
        mov    ah,0
        int    1ah
        sub    dx,cs:timerdx
        add  word ptr cs:[bx]+20,dx
        jnc   no_time_carry
        inc  word ptr cs:[bx]+22
no_time_carry:
        pop    dx
        pop  cx
        pop  bx
        pop  ax
        ret
count13 endp
keyboard proc near
; this is the keyboard procedure from cboot
; looking for hotkey
    push  ax
    mov   al,1
lock xchg cs:semaphore,al
    cmp  al,0
    jne   no_alt_ls
    mov   ah,2
    int   16h
    push  ax
    and   al,cs:hshift1
    cmp   al,cs:hshift1
    pop   ax
    je    got_shift1
    and   al,cs:hshift2
    cmp   al,cs:hshift2
    jne   no_alt_ls2
; got the second shift
    in    al,60h   ; kbd data
    and   al,7fh
    cmp   al,cs:hscan2
    jne   no_alt_ls2
    jmp   got_hot
got_shift1:
    in    al,60h   ; kbd data
    and   al,7fh
    cmp   al,cs:hscan1
    jne   no_alt_ls2
got_hot:
; have got it
    push  dx
    in    al,61h
    jmp   $+2
    jmp   $+2
    mov   ah,al
    or    al,80h
    mov   dx,61h
    out   dx,al
    jmp   $+2
    jmp   $+2
    mov   al,ah
    out   dx,al
    jmp   $+2
    jmp   $+2
    mov   al,20h
    mov   dx,20h
    out   dx,al
    pop   dx
    jmp  enter_resident
no_alt_ls2:
    mov   cs:semaphore,0
no_alt_ls:
    pop   ax
    jmp   dword ptr cs:int9


enter_resident:
; set istack
        mov ax,cs
        mov  cs:savesp,sp
        mov  cs:savess,ss
        cli
        mov  ss,ax
        lea  sp,istack+255
; save the world
        sti
        push bx
        push cx
        push dx
        push bp
        push si
        push di
        push es
        push ds
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
        cld
        call process
; now pop everyting and return
        pop  ds
        pop  es
        pop  di
        pop  si
        pop  bp
        pop  dx
        pop  cx
        pop  bx
; restore istack
        cli
        mov  ss,cs:savess
        mov  sp,cs:savesp
        pop  ax
        mov   cs:semaphore,0
        iret
keyboard endp
process proc  near
; first get the cursor location
        savecurs cursor1
        dowindow 1
        pwindow  window1
getchar:
        jmp  gc2
nochar:
        call blop
gc2:
        call blip
        mov  ah,0
        int  16h
        cmp  al,27
        jne no27
        jmp  exit_prog
no27:
        cmp  ah,3bh
        jl   nof1
        cmp  ah,41h
        jg   nof1
        sub  ah,3ah
        mov  al,ah
        mov  ah,0
        mov  helpnum,ax
        mov  bx,ax
        dec  bx
        shl  bx,1
        call calltable[bx]
        jmp  getchar
calltable dw help
          dw writep
          dw writee
          dw opend
          dw closed
          dw dispstat
          dw diskstat
nof1:
        jmp   nochar
exit_prog:
        unwindow 1
        restcurs cursor1
        ret
process      ENDP
helptab  dw  help1
         dw  help2
         dw  help3
         dw  help4
         dw  help5
         dw  help6
         dw  help7
         dw  help8
         dw  help9
helpmax  equ 7
help    proc  near
        savecurs cursorh1
        dowindow h1
helptop:
        mov  bx,helpnum
        cmp  helpnum,1
        jge  check_help_max
        mov  bx,1
        mov  helpnum,1
check_help_max:
        cmp  bx,helpmax
        jle  good_helpnum
        mov  helpnum,helpmax
        mov  bx,helpmax
good_helpnum:
        dec  bx
        shl  bx,1
        mov  si,helptab[bx]
        call putwind
        jmp  gethchar
nohchar:
        call blop
gethchar:
        call blip
        mov  ah,0
        int  16h
        cmp  al,27
        jne noh27
        jmp  exit_help
noh27:
        cmp  ah,03bh
        jl   nohf1
        cmp  ah,03ah+helpmax
        jg   nohf1
        sub  ah,3ah
        mov  al,ah
        mov  ah,0
        mov  helpnum,ax
        jmp  helptop
nohf1:
        cmp   ah,47h
        jne   noh47
        mov   helpnum,1
        jmp   helptop
noh47:
        cmp   ah,49h
        jne   noh49
        sub   helpnum,1
        jmp   helptop
noh49:
        cmp   ah,51h
        jne   noh51
        add   helpnum,1
        jmp   helptop
noh51:
        cmp   ah,4fh
        jne   noh4f
        mov   helpnum,helpmax
        jmp   helptop
noh4f:
        jmp   nohchar
exit_help:
        unwindow h1
        restcurs cursorh1
        ret
help    endp
setwind   proc near
; locate at the line 1 position 10
          mov  di,wsave
          mov  cx,rows
          mov  dh,windy
gwloop:
          push cx
          mov  dl,windx
          mov  cx,cols
gwloop2:
          mov  ah,2
          mov  bh,bhpage
          int  10h
; get word at cursor
          mov  ah,8
          mov  bx,0
          int  10h
          stosw
          mov  al,windx
          mov  ah,windy
          add   ah,byte ptr rows
          add   al,byte ptr cols
          dec   ah
          dec   al
          push  cx
; is the cursor on the top row
          cmp   windy,dh
          je    top_row
; is it left side
          cmp   windx,dl
          je    left_col
; is the cursor on the bot row
          cmp   ah,dh
          je    bot_row
; is it upper left side
          cmp   al,dl
          je    right_col
          jmp   middle
top_row:
; are we on left
          cmp   windx,dl
          je    upper_left
; are we on right
          cmp   al,dl
          je    upper_right
          mov  al,''
          jmp  put_it
upper_left:
          mov  al,''
          jmp  put_it
upper_right:
          mov  al,''
          jmp  put_it
left_col:
          cmp  ah,dh
          je   bot_left
          mov  al,''
          jmp  put_it
bot_left:
          mov  al,''
          jmp  put_it
bot_row:
          cmp  al,dl
          je   bot_right
          mov  al,''
          jmp  put_it
bot_right:
          mov  al,''
          jmp  put_it
right_col:
          mov  al,''
put_it:
          mov   ah,9
          mov   bl,color
          mov  cx,1
          mov  bh,bhpage
          int  10h
middle:
          pop   cx
          inc  dl
          jmp  go_gwloop2
gwloop2_long:
          jmp   gwloop2
go_gwloop2:
          loop  gwloop2_long
          pop  cx
          inc  dh
          jmp  go_gwloop
long_gw:
          jmp  gwloop
go_gwloop:
          loop long_gw
          ret
setwind   endp
putwind   proc  near
;
; here we clean the inner screen by scrolling it
;
          mov  dh,windy
          mov  dl,windx
          mov  cx,dx
          add  dl,byte ptr cols
          add  dh,byte ptr rows
          inc  ch
          inc  cl
          dec  dh
          dec  dl
          dec  dh
          dec  dl
          mov  bh,color
;         mov  bh,bhpage
          mov  al,0
          mov  ah,7
          int  10h
; now put the stuff on the screen
; locate at the line 1 position 10
;         mov  si,window
          mov  cx,rows
          mov  dh,windy
          inc  dh       ;start at second row
pwloop:
          push cx
          mov  dl,windx
          inc  dl       ; start at second column
          mov  cx,cols
pwloop2:
          push cx
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put word at cursor
          lodsb
          cmp  al,0
          je   pw_done  ; found the end of screen
          cmp  al,13
          je   pw_ignore ; ignore the 13's
          cmp  al,10
          je   pw_next_line  ;got a new line
          mov  ah,10
          mov  bh,bhpage
          mov  cx,1
          int  10h
          inc  dl
pw_ignore:
          pop  cx
          loop  pwloop2
          push  cx
pw_next_line:
          pop  cx
          pop  cx
          inc  dh
          loop pwloop
          push cx
          push cx
pw_done:
          pop  cx
          pop  cx
; make the cursor hide pos
          mov  dl,windx
          mov  dh,windy
          add  dx,101h
; locate at the new place
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put the block
          mov   bl,color
          and   bl,0f0h
          mov   al,bl
          mov   cl,4
          shr   al,cl
          or    bl,al
          mov  cx,1
          mov  bh,bhpage
          mov  al,32
          mov   ah,9
          int  10h
          ret
putwind   endp
retwind   proc  near
; locate at the line 1 position 10
          mov  si,wsave
          mov  cx,rows
          mov  dh,windy
rwloop:
          push cx
          mov  dl,windx
          mov  cx,cols
rwloop2:
          push cx
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put word at cursor
          lodsw
      ;   ah has the  attribute, al, has the character
          mov  bl,ah
          mov  ah,9
          mov  bh,bhpage
          mov  cx,1
          int  10h
          pop  cx
          inc  dl
          loop  rwloop2
          pop  cx
          inc  dh
          loop rwloop
          ret
retwind   endp
getcurs   proc  near
; this routine relies on di pointing to the page,cursor, and cmode
; get video state
          cld
          mov ah,15
          int 10h
          mov al,bh
          stosb        ;save page
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  ax,dx
          stosw       ;save cursor location
          mov  ax,cx
          stosw       ;save mode
          ret
getcurs   endp
retcurs   proc  near
; this relys on the cursor stuff being in si
          lodsb
          mov  bh,al
          lodsw
          mov  dx,ax
          mov ah,2
          int  10h
          ret
retcurs   endp
tone    proc  near
        mov   dx,3    ; tone rate
        mov   bx,240  ; starting freq
        mov   cx,750  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,630  ; starting freq
        mov   cx,150  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        ret
tone    endp
blip    proc  near
        mov   si,30
        call  tone
        ret
blip    endp
blop    proc  near
        mov   si,-30
        call  tone
        ret
blop    endp
diskfill proc  near
;
      mov  ax,cs
      lea si,drive1
      lea di,firstdec
      mov   cx,10     ; ten lines to process
dec0loop0:
       push  cx
       push  di
      mov   bx,0
      mov   bp,0
       mov   cx,5      ; five columns per row
dec0loop1:
       push  cx
; have to get a double word and convert to dec
       cld
       lodsw
       add   bp,ax
       jnc   no_ov_bp
       inc   bx
no_ov_bp:
       push  ax
       lodsw
       add   bx,ax
       mov  dx,ax
       pop  ax
       mov  cx,10000
       div  cx
; dx has the remainder, ax has the high order 4 decimals
       push di
       push dx
       mov  dx,0
       mov  cx,10
       div  cx
       or   dl,'0'
       mov  ds:[di+1],dl
       mov  dx,0
       mov  cx,10
       div  cx
       or   dl,'0'
       mov  ds:[di],dl
       mov  cx,4
       pop  ax
       add  di,5
dec2loop:
       push cx
       mov  dx,0
       mov  cx,10
       div  cx
       or   dl,'0'
       mov  ds:[di],dl
       dec  di
       pop  cx
       loop dec2loop
       pop  di
       push  di
       mov  cx,5
dec3loop:
       cmp  byte ptr ds:[di],'0'
       jne  dec4loop
       mov  byte ptr ds:[di],' '
       inc   di
       loop  dec3loop
dec4loop:
       pop  di
       add  di,8
       pop  cx
       loop dec0loop1
; here we have to do the division for speed calc
;      bp:bx have the total sectors read
       lodsw
       push ax
       lodsw
       mov  dx,ax
       pop  ax
; there are 1193180/64k ticks per second
; we want to convert to sectors/millisecond
; there are .0549355 seconds per tick
; we want seconds per sector
; there are 54.9355 millisecs per tick
;
; how the hell do I convert without dropping accuracy????
;
;  bx:bp has the count of sectors
; dx:ax has the count of ticks
; we have to scale up ticks by a factor of 1000
; What we do is if ticks is a 4 byte figure we have to shift
; until its 2 bytes both the ticks and the sectors
       cmp   bp,0
       je    end_sector_div
bx_check_size:
       cmp  bx,0
       jne  bx_check_size1
       cmp   dx,0
       jne   bx_check_size1
       jmp   bx_check_size2
bx_check_size1:
       clc
       rcr  bx,1
       rcr  bp,1
       clc
       rcr  dx,1
       rcr  ax,1
       jmp  bx_check_size
bx_check_size2:
; now we have a reasonablu small number in BP to divide by
; next check to see we don't divide by 0
       mov   cx,5494
       mul   cx
; now do the shift stuff again
dx_check_size:
       cmp   bp,0
       je    end_sector_div
       jl    dx_check_size3
       cmp   bx,0
       jne   dx_check_size3
       cmp   dx,0
       jl    dx_check_size3
       je    dx_check_size2
       cmp   dx,bp
       jl    dx_check_size2
dx_check_size3:
       clc
       rcr  bx,1
       rcr  bp,1
       clc
       rcr  dx,1
       rcr  ax,1
       jmp  dx_check_size
dx_check_size2:
       cmp   bp,0
       je    end_sector_div
       mov   cx,bp
       div   cx
;
;  ax has the milliseconds per tick has 3 decimal places good
; with 5 places total (65536 max)
;
       jmp   print_speed
end_sector_div:
       mov   ax,0
print_speed:
;
; ax has the number we need to do this 2, decimal and 3 before
       mov  dx,0
       mov  cx,10
       div  cx
       or   dl,'0'
       mov  ds:[di+5],dl
       mov  dx,0
       mov  cx,10
       div  cx
       or   dl,'0'
       mov  ds:[di+4],dl
       mov  byte ptr ds:[di+3],'.'
       mov  dx,0
       mov  cx,10
       div  cx
       or   dl,'0'
       mov  ds:[di+2],dl
       mov  dx,0
       mov  cx,10
       div  cx
       or   dl,'0'
       mov  ds:[di+1],dl
       mov  dx,0
       mov  cx,10
       div  cx
       or   dl,'0'
       mov  ds:[di],dl
       mov  cx,3
dec7loop:
       cmp  byte ptr ds:[di],'0'
       jne  dec8loop
       mov  byte ptr ds:[di],' '
       inc   di
       loop  dec7loop
dec8loop:
       pop  di
       pop  cx
       add  di,56
       jmp  by_dec0
bydecloop:
       jmp  dec0loop0
by_dec0:
       loop bydecloop
       ret
diskfill endp
setres  proc  near
; get the printer interrupt
startres:
        call  get_parms
        call blip
        savecurs cursorh1
        dowindow c1
        pwindow mess1
; check to see if the guy is resident
        mov  ax,'ZZ'
        int  13h
        cmp  ax,'OK'
        je  ok_res
        jmp  not_res
ok_res:
        dowindow e1
        pwindow err1
        call  blop
        call  blop
        call  blop
        call  blop
        dowindow t1
        pwindow thanks
        restcurs cursorh1
        int  20h
not_res:
        push  es
        mov   ax,3509h
        int   21h
        mov   int9cs,es
        mov   int9ip,bx
        mov   ah,25h
        mov   al,9h
        lea   dx,keyboard
        int   21h
        pop   es
        push  es
        mov   ax,3513h
        int   21h
        mov   int13cs,es
        mov   int13ip,bx
        mov   ah,25h
        mov   al,13h
        lea   dx,int13c
        int   21h
        pop   es
        dowindow t1
        pwindow thanks
        restcurs cursorh1
        lea   dx,startres
        int 27h
get_parms:
; reads the command line and write protects the disks if it
; finds anything
;
        mov   si,81h
gp0:
        lodsb
        cmp   al,20h
        je    gp0
        cmp   al,':'
        je    gp0
        cmp   al,13
        je    gp_e
        cmp   al,'A'
        jl    gp0
        cmp   al,'j'
        jg    gp0
        cmp   al,'J'
        jle   gp1
        sub   al,32
        cmp   al,'J'
        jg    gp0
gp1:
    mov   bl,al
    mov   bh,0
    sub   bx,'A'
    mov   writep_tab[bx],1
    jmp   gp0
gp_e:
        ret
;===================================================;
rowsc1   equ 5                                      ;
colsc1   equ 37                                     ;
windxc1  equ 22                                    ;
windyc1  equ 2                                      ;
colorc1  equ 07h                                    ;
wsavec1 dw rowsc1*colsc1 dup(0)                     ;
mess1   db  ' CDISK Disk Status Control Program',10
        db  ' Copyright 1991 by Keith P. Graham',10
        db  ' Vers. 2.3 10/25/91',0
;===================================================;
;===================================================;
rowse1   equ 3                                      ;
colse1   equ 28                                     ;
windxe1  equ 26                                    ;
windye1  equ 8                                      ;
colore1  equ 70h                                    ;
wsavee1 dw rowse1*colse1 dup(0)                     ;
err1    db  ' CDISK is already resident',0
;===================================================;
;===================================================;
rowst1   equ 3                                      ;
colst1   equ 52                                     ;
windxt1  equ 16                                    ;
windyt1  equ 15                                     ;
colort1  equ 07h                                    ;
wsavet1 dw rowst1*colst1 dup(0)                     ;
thanks  db  ' Press ALT-LEFT SHIFT-D for Resident Disk Control',10
        db  0
;===================================================;
setres  endp
CSEG        ENDS
        END        ENTPT
