printx macro string
      mov si,string
      call doprint
      endm
print  macro string
      lea si,string
      call doprint
      endm
public epson1,epson2,inepson
extrn epsone1:byte,epsone2:byte,wsaveh:word,epsonem1:word
extrn imbed_mode:byte,opt12:byte,gra_mode:word
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
; data areas
savess    dw 0
savesp    dw 0
saveax    dw 0
stack     db  'Print stack begins'
          dw  64 dup(0)
          db  'Top of stack'
semaphore db  0
errorcode db  0
printer   db  0
phase     db  0
ccount    dw  0
tabline_len  dw  256
high_tab  dw  248
tabline   db  8 dup(0),31 dup(1,7 dup(0))
          db  20 dup(0)
fxops   db  14,15,'#0124589<=>@EFGHMOPT67' ; length  24
len3    db  '!-/3AJNQRSUWijlpsI'       ; length  18
lenmore db  'BCDb%:&KLYZ*?^'           ;length   14
                                       ;         56
escnum  db  27
inepson db 0
nline   dw 2
lswitch db -1
t216      dw  0
epson1    proc     near
          mov    cs:printer,dl
          mov    cs:epsone1,0
          mov    cs:inepson,1
          mov   cs:errorcode,0c0h
          call   clep1
          mov    cs:inepson,0
          mov    cs:epsone1,1
          ret
epson1    endp
epson2    proc     near
          mov    cs:epsone2,0
          ret
epson2    endp
clep1         PROC        NEAR
doit:
; we are into the routine
;
          mov   cs:saveax,ax
          cmp  cs:phase,0
          je   phase0
          jmp  phasegt0
phase0:
; no active stuff going on
          cmp  al,'~'
          je   gottilde
pm1cont:
          cmp  cs:epsonem1,0
          jne  p0cont
          jmp  notabber
p0cont:
          cmp  al,13
          je   gotcr
          cmp  al,10
          je   gotlf
          cmp  al,9
          je   gottab
          cmp  al,27
          je   gotesc
          add  cs:ccount,1
          jmp  notabber
gottilde:
          cmp  cs:imbed_mode,1
          jne  pm1cont
          mov  cs:phase,50
          jmp  leave
gotlf:
          cmp  cs:t216,0
          je   notabber
          call dot216
          jmp  leave
notabber:
          jmp  notnow
gotesc:
          mov  cs:phase,1
leave:
; leave altogether without benefit of printing
          ret
notnow:
          int   17h
          ret
gotcr:
          mov  cs:ccount,0
          jmp  notnow
gottab:
 ; now have to tab over to next line
          mov   ax,cs:ccount
          cmp   cs:tabline_len,ax
          jl    noktabsize
          cmp   cs:high_tab,ax
          jl    noktabsize
          jmp   oktabsize
noktabsize:
          jmp   leave
oktabsize:
; set up stack
          mov   cs:savess,ss
          mov   cs:savesp,sp
          mov   ax,cs
          cli
          mov   ss,ax
          mov   sp,offset cs:stack+124
          sti
          push  bx
          push  cx
          push  dx
          push  si
          push  di
          push  bp
          push  ds
          push  es
; have got to tab over to next character
          mov   ax,cs
          mov   ds,ax
          mov   es,ax
          mov   errorcode,11010000b
          mov   bx,ccount   ; how far are we in line
toptab:
          cmp   tabline[bx],1
          je    nomoretab
          mov   al,20h
          mov   ah,0
          mov   dl,printer
          mov   dh,0
          clc
          int   17h
          test  ah,00111001b
          jz    nexttab
          mov   errorcode,ah
          jmp   leavetab
nexttab:
          mov   errorcode,ah
          add   ccount,1
          inc   bx
          cmp   tabline_len,bx
          jl    leavetab
          jmp   toptab
nomoretab:
leavetab:
          pop   es
          pop   ds
          pop   bp
          pop   di
          pop   si
          pop   dx
          pop   cx
          pop   bx
          cli
          mov   ss,cs:savess
          mov   sp,cs:savesp
          sti
          mov   ax,cs:saveax
          mov   ah,cs:errorcode
          ret
; now do stuff
phasegt0:
          mov   cs:savess,ss
          mov   cs:savesp,sp
          mov   ax,cs
          cli
          mov   ss,ax
          mov   sp,offset cs:stack+124
          sti
          push  bx
          push  cx
          push  dx
          push  si
          push  di
          push  bp
          push  ds
          push  es
          mov   ax,cs
          mov   ds,ax
          mov   es,ax
          mov   ax,cs:saveax
          cmp phase,1
          jne phasegt1
          jmp phase1
phasegt1:
          cmp  phase,2
          je   do_double
          cmp  phase,3
          je   do_triple
          cmp  phase,50
          je   do_imbed
          mov  phase,0
          jmp leavetab
do_imbed:
          mov  phase,0
          call imbed
          jmp leavetab
do_triple:
          call triple
          jmp leavetab
do_double:
          call double
          mov  phase,0
          jmp leavetab
opt0     db  27
lastcode db  0,0
lastcx   dw 0
phase1:
          mov  lastcode,al
          lea  di,fxops
          mov  cx,56
          cld
repne     scasb
          je  got1
; unidentified code
          print opt0
          mov  phase,0
          jmp leavetab
got1:
   ; got a code must determine phase we are in
          mov lastcx,cx
          cmp cx,31
          jg  do_phase_1
          cmp cx,13
          jg  do_phase_2
          jmp do_phase_3
do_phase_1:
          call single
          mov  phase,0
          jmp leavetab
do_phase_2:
          mov  phase,2
          jmp leavetab
do_phase_3:
          mov  phase,3
          jmp leavetab
clep1     endp
tilde_go   db '~ ',0
tilde_on   db '~',0
imbed      proc  near
; this detects the string number and prints a string according to
; the tilde character
           mov   tilde_go+1,al
           cmp   al,'~'
           jne   not_a_tilde
           print  tilde_on
           jmp    leave_tilde
not_a_tilde:
           cmp   al,'0'
           jne   no_t_0
           mov   al,10
           jmp   go_tilde
no_t_0:
           cmp   al,'1'
           jl    no_tilde
           cmp   al,'9'
           jg    no_tilde_num
           sub   al,'1'
           jmp   go_tilde
no_tilde_num:
           cmp   al,'A'
           jl    no_tilde
           cmp   al,'b'
           jg    no_tilde
           cmp   al,'B'
           jg    fix_tilde
           sub   al,'A'
           add   al,11
           jmp   go_tilde
fix_tilde:
           cmp   al,'a'
           jl    no_tilde
           sub   al,'a'
           add   al,11
go_tilde:
           mov   cl,5
           mov   ah,0
           shl   ax,cl
           mov   bx,ax
           print opt12[bx]
           jmp   leave_tilde
no_tilde:
           print  tilde_go
           jmp    leave_tilde
leave_tilde:
           mov    phase,0
           ret
imbed     endp
optx     db '&dD',0
optinit  db  'E',0
;fxops   db  14,15,'#0124589<=>@EFGHMOPT67' ; length  24  32-55
opts1    db  14,0
opts2    db  15,0
opts3    db  0
opts4    db  '&l8D',0
opts5    db  '&l4.667C',0
opts6    db  '&l6D',0
opts7    db  14,0
opts8    db  15,0
stable   dw  opts1
         dw  opts2
         dw  opts3
         dw  opts4
         dw  opts5
         dw  opts6
         dw  opts7
         dw  opts8
single   proc   near
; process the single line command in cx
         jmp   over_single
over_single:
         cmp   cx,42
         jne   noinit
         print optinit
         jmp   esingle
noinit:
         cmp   cx,48
         jl    esingle
         mov   bx,55
         sub   bx,cx
         add   bx,bx
         printx stable[bx]
esingle:
         ret
single   endp
double   proc  near
; al has the current character and lastcx has the count 14-31
         mov   bx,31
         sub   bx,lastcx
         add   bx,bx
         jmp   dtable[bx]
;len3    db  '!-/3AJNQRSUWijlpsI'       ; length  18      14-31
;lenmore db  'BCDb%:&KLYZ*?^'           ;length   14       0-13
dtable   dw    optd0     ; ! select mode ignore
         dw    optd17    ; -  underline
         dw    optd0     ; /
         dw    optd15    ; 3  n/216
         dw    optd14    ; A  n/72
         dw    optd13    ; J  tentative 216
         dw    optd0     ; N  ignore
         dw    optd11    ; Q  set right margin
         dw    optd0     ; R  ignore
         dw    optd0     ; S supescript/subscript ignore
         dw    optd0     ; U ignore
         dw    optd0     ; W enlarged, ignore
         dw    optd0     ; i viewprint ignore
         dw    optd5     ; j reverse feed
         dw    optd4     ; l left margin
         dw    optd0     ; p ignore
         dw    optd0     ; s ignore
         dw    optd0     ; I ignore
optd5:    ; j, tentative reverse feed
; tentative n/216 line spacing
;    the number in al is the line spacing
       mov  ah,0
       mov t216,ax
      mov  p216+3,'-'
       jmp  optd0
; set left margin
optd4p db '&a'
optd4p1 db 0
optd4p2 db 0
optd4p3 db 0,'L',0
optd4:
       mov ah,0
       mov dx,0
       call dodecimal
       mov optd4p1,dl
       mov optd4p2,ah
       mov optd4p3,al
       print optd4p
       jmp optd0
; set right margin
optd11p db '&a'
optd11p1 db 0
optd11p2 db 0
optd11p3 db 0,'M',0
optd11:
       mov ah,0
       mov dx,0
       call dodecimal
       mov optd11p1,dl
       mov optd11p2,ah
       mov optd11p3,al
       print optd11p
       jmp optd0
optd13:
; tentative n/216 line spacing
;    the number in al is the line spacing
       mov  ah,0
       mov t216,ax
      mov  p216+3,'+'
       jmp  optd0
optd14:
 ; same as  3 except n/72 so it is 48/72 = 6/9
     mov  dx,0
     mov  ah,0
     mov  multw,6000 ; this gives us 2 decimals extra
     mul  multw
     jmp  divby9
multw    dw 0
optd15p  db '&l'
optd15p1 db 0
optd15p2 db 0
         db '.'
optd15p3 db 0
optd15p4 db 0,'C',0
optd15:
; n/216 spacing
; sets n/216 line spacing
; in hp we have n/48
; this means we must multiply al by 2/9
;
;    we must set as 2 decimal places
;
     mov  dx,0       ; high word of mult
     mov  ah,0
     mov  multw,2000 ; this gives us 2 decimals extra
     mul  multw
divby9:
;  dx:ax now has the product of n and 200
;    now divide by 9 to get the total line count
     add  ax,45
     mov  multw,90
     div  multw
;    ax has the bytes which are 100 times too much
;    dx has the remainder 0 to 9
noround:
;  ax is now 4800/216 (200/9) the original
      call  dodecimal
;     dx:ax now has the decimal value of the string
      mov  optd15p1,dh
      mov  optd15p2,dl
      mov  optd15p3,ah
      mov  optd15p4,al
      print optd15p
       jmp optd0
; underline!!!!!!
underline  db '&dD',0
cunderline  db '&d@',0
optd17:
       cmp al,0
       je  optd17can
       cmp al,48
       je  optd17can
       print underline
       jmp optd0
optd17can:
; cancel underline
       print cunderline
       jmp optd0
optd0:
; ignore
        mov  phase,0
        ret
         ret
double    endp
;
;      TRIPLE
;
tphase  db  0
triple   proc  near
; this does 3 phase stuff
; relys on tphase to determine condition
; Go until a zero hit:    B,D,b,%,
; Go 3 or 4          :    C
; exactly 5          :    :
; exactly 5 and calc*11:  &
; exactly 5 and calc :    K,L,Y,Z (*=6 and cacl), ^
; exactly 3          :    ?
;
         mov  bl,tphase
         mov  bh,0
         add  bx,bx
         jmp  ttable[bx]
ttable   dw   top0
         dw   top1
         dw   top2
         dw   top3
         dw   top4
         dw   top5
         dw   top6
         dw   top7
         dw   top8
         dw   top9
         dw   top10
         dw   tope
         dw   top12
         dw   top13
top1:
; this is for B (and perhaps others) skip until 0
         cmp al,0
         jne top1e
         jmp tope
top1e:
         ret
top2:
; looking for form length in inches
         mov  dx,0
         mov  ah,0
         mov  multw,6
         mul  multw
         call dodecimal
         mov  ta2p1,dl
         mov  ta2p2,ah
         mov  ta2p3,al
         print ta2p
         jmp  tope
top3:
;        tabs
         cmp al,0
         jne  top3c
         jmp  tope
top3c:
         mov  ah,0
         mov  bx,ax
         cmp  bx,tabline_len
         jl   dotab3
         jmp  tope
dotab3:
         mov  high_tab,bx
         mov  tabline[bx],1
         ret
top4:
         mov  tphase,1
         ret
let51    db  0
let52    db  0
let5     dw  0
twelve   db  0
top5:
; here we are at low letter for character download
         mov  let51,al
         mov  tphase,6
         ret
top6:
         mov  let52,al
         sub  al,let51
         mov  ah,0
         inc  ax
         mul  twelve
         inc  ax
         inc  ax
         inc  ax
         mov  let5,ax
         mov  tphase,7
         ret
top7:
         sub  let5,1
         cmp  let5,0
         jle top7r
         ret
top7r:
         jmp  tope
zmin    equ   17
zmax    equ   40
zcount  dw 0
top8:
; here comes the second byte of count
        mov  graf2,al
;  graf will have the total bytes coming through
;    zero out the fields in question
        mov  blen,0
        mov  grafc,0
        mov  zcount,0
        mov  tphase,9
        ret
 ;
top9:
; here al has the byte to put into the buffer
        mov  di,blen
        mov  byte ptr wsaveh[di],al
; al is saved
        add  blen,1
        add  grafc,1
        mov  bx,grafc
        cmp  graf,bx
        jg   granotdone
        cmp  al,0         ; is last character 0?
        jne  grad2        ; if not goto grad1
        add  zcount,1     ; if it is add 1 to the zero count
        jmp  grad1        ; get done
grad2:
        cmp  zcount,0     ; are there any stored zcounts
        jne  gracont1     ; if there are don't leave yet
grad1:
        jmp  gradone
granotdone:
; check to see if al is a zero
        cmp  al,0
        je   grazero
; check to see if we must force a print sequence
        cmp  zcount,0
        jg  gracont1a
        jmp  gracont2
gracont1a:
; check to see if we are on a 5  byte boundary
        push ax
        mov  multw,5
        mov  ax,blen
        mov  dx,0
        div  multw
        mov  dx,0
        mul  multw
        mov  bx,ax
        pop  ax
        cmp  ax,bx
        je   gracont1
        mov  zcount,0
        jmp  gracont2
gracont1:
; here a character is in al, not zero, but we have more than zmin
; zeros so space them out
        push  ax
        sub  blen,1
        call  dogra1
        pop   ax
        mov  blen,0
        mov  zcount,0
        sub  grafc,1
        jmp   top9
grazero:
        mov  bx,blen
        dec  bx
        cmp bx,zcount
        je  leadspace
        cmp  blen,9
        jl gracont2
leadspace:
        add  zcount,1
gracont2:
; check to see if we have done the buffer maximum
        mov  bx,grafmax
        cmp  blen,bx
        jge  dogra1
; all is done for now
        ret
gradone:
        call  dogra1
        jmp   tope
; here we have read the last byte and its time to print
dogra1:
; this routine calles the graphics printouts
        mov  ax,zcount
        sub  blen,ax
        cmp  blen,0
        jle  graspace
        call egraph
graspace:
        call mright
        mov zcount,0
        mov blen,0
        ret
top10:
; *   graphics dump
;   al has the low byte of the length
      mov  bl,stardata
      mov  bh,0
      add  bx,bx
      jmp  table10[bx]
table10  dw ta8
         dw ta9
         dw ta9
         dw ta10
         dw  ta8
         dw  ta8
         dw  ta9
         dw  ta9
         dw  ta9
         dw  tope
      ret
top12:
; second time through esc ^
         mov  graf2,al
         mov  ax,graf
         shl  ax,1
         mov  graf,ax
; now gra has the count of times to pass
         mov  tphase,13
         ret
top13:
         sub  graf,1
         cmp  graf,0
         jle  end13
         ret
end13:
         jmp  tope
tope:
        mov  tphase,0
        mov  phase,0
        ret
top0:  ;determine tphase
         mov  bx,13
         sub  bx,lastcx
         add  bx,bx
         jmp  tatable[bx]
;lenmore db  'BCDb%:&KLYZ*?^'           ;length   14       0-13
tatable  dw   ta1 ;B
         dw   ta2 ;C
         dw   ta3  ;D
         dw   ta4  ;b
         dw   ta5  ;%
         dw   ta6  ;:
         dw   ta7  ;&
         dw   ta8  ;K
         dw   ta9  ;L
         dw   ta9  ;Y
         dw   ta10 ;Z
         dw   ta12 ;*
         dw   ta13 ;?
         dw   ta14 ;^
ta1:
; this is B  vertical line spacing
         mov  tphase,1
         ret
ta2:
; this is C set form length
         cmp  al,0
         jne  ta2go
         mov  tphase,2
         ret
ta2p     db '&l'
ta2p1    db  0
ta2p2    db  0
ta2p3    db  0,'P',0
ta2go:
         mov  dx,0
         mov  ah,0
         call dodecimal
         mov  ta2p1,dl
         mov  ta2p2,ah
         mov  ta2p3,al
         print ta2p
         jmp  tope
ta3:
; D = horizontal tab
; first reset tabs
         push  ax
         mov   cx,tabline_len
         lea   di,tabline
         cld
         mov   ax,0
repnz    stosb
         mov   high_tab,0
         pop   ax
         mov   tphase,3
         jmp   top3
ta4:
; b vfu position
; go until 0
         mov  tphase,1
         ret
ta5:
;  % graphics charcter generation
; the form is esc % n 0 so we can use tphase 1
         jmp  ta4
ta6:
; this is : for setting ROM characters
;
; strategy is to get the trhee zeros
         mov  tphase,4
         ret
ta7:
; & download characters
   ; the first character here is a zero
         mov  tphase,5
         ret
set_res:
         push  ax
         cld
         mov  ax,res_sel
         add  ax,gra_mode
         mov  cl,12
         mul  cl
         mov  bx,ax
         lea  si,resoltab[bx]
         cld
         lea  di,resol
         movsw
         movsw
         lea  di,lswitch
         movsb
         lea  di,fright
         movsw
         lea  di,bgra1
         movsb
         lea  di,nline
         movsw
         lea  di,resol2
         movsw
         pop  ax
      mov  graf1,al
      mov  tphase,8
      ret
res_sel   dw 0
;            resol,lswitch,fright,bgra1,nline,resol2
resoltab  db '075R',-1,96,0,'0',1,0,'81'
          db '100R',0,72,0,'3',1,0,'82'
          db '150R',-1,48,0,'0',2,0,'85'
          db '300R',-1,24,0,'2',2,0,'78'
ta8:
; K   graphics dump
;   al has the low byte of the length
; use  75 for resolution
      mov   res_sel,0
      jmp   set_res
ta9:
      mov   res_sel,1
      jmp   set_res
; L same as K?
ta10:
; Y same as K?
      mov   res_sel,2
      jmp   set_res
;ta11:
; Z same as K?
;      mov   res_sel,3
;      jmp   set_res
stardata  db 0
ta12:
; * almost same as k
      mov  tphase,10
      mov  stardata,al
      ret
ta13:
;  ?  sets bit image mode
; there is another byte coming
      jmp  tope
ta14:
;  ^  sets 9 pin bit image mode
; similar to esc K, but too much for me
; the way it works is esc ^ n m and then nm*2 bytes to ignore
; we are at the n phase
         mov  graf1,al
         mov  tphase,12
         ret
triple   endp
doprint   proc  near
 ; si has the start of the string
topdop:
          mov   ah,0
          mov   dl,printer
          mov   dh,0
          lodsb
          cmp   al,0
          je    leavedop
          clc
          int   17h
          mov   errorcode,ah
          jmp   topdop
leavedop:
          ret
doprint   endp
tenw     dw  10
dodecimal  proc near
; this routine takes a number in ax and
; converts it to decimal in dx,ax
           mov  dx,0
           div  tenw
; dx has the remainder
           mov  bl,dl
           mov  dx,0
           div  tenw
           mov  bh,dl
           or   bx,3030h
;bx has the 1'2 and ten's digits
           mov  dx,0
           div  tenw
           mov  dh,al
           or   dx,3030h
; dx has the thousands and hundreds in it
           mov  ax,bx
; dx:ax has the decimal number in it
           ret
dodecimal  endp
rgra1   db '*t'
resol  db  '100R',0,0,0,0,0
rgra2   db '*r1A',0,0,0,0,0
rgra3   db '*b'      ;transfer graphics character count
rgc2    db 0
rgc3    db 0
rgc4    db 0,'W',0,0,0,0,0
rgra4   db '*rB',0,0,0
rgra5   db '&a-'
resol2  db  '80V',0,0,0,0,0,0
bgra    db '&a+'
bgra1   db '8V',0,0,0,0,0
eight   dw 8
fright     dw 72
graf  dw 0
graf1 equ byte ptr graf
graf2 equ byte ptr graf+1
grafc dw 0
grafmax  dw  40
linemax  dw 640
blen     dw  0
pass     db  0
egraph   proc   near
; this routine prints out the graphics in the buffer based on
; the number of characters which is indicated in blen
        print rgra1
        print rgra2
        mov   cx,7
        lea   di,wsaveh
        add   di,blen
        cld
        mov   ax,0
rep     stosb
        mov  ax,blen
; calculate the number of characters to send
        add  ax,7
        mov  dx,0
        div  eight
        mov  dx,0
        call dodecimal
        mov     rgc2,dl
        mov     rgc3,ah
        mov     rgc4,al
        mov  cx,8
; do the following 8 times (once for each line)
graloop0:
        push  cx
        mov   cx,nline
egraphloop:
        push  cx
        mov   pass,cl
        call  egraphx
        pop   cx
        neg   lswitch
        mov   al,bgra1
        add   al,lswitch
        mov   bgra1,al
        cmp   bgra1,'0'
        je    nobgra
         print bgra
nobgra:
        loop  egraphloop
          pop  cx
;
;
         loop  graloop0
          print rgra4
          print rgra5
          mov  ax,blen
          mov  bx,zcount
          push bx
          mov  zcount,ax
          call mright
          pop  bx
          mov  zcount,bx
         ret
egraph   endp
egraphx  proc  near
        print rgra3
; start by dividing by 8
        mov  ax,blen
        add  ax,7
        div  eight
        mov  cx,ax
;
; no cx has the number of 8 bit segments to paruse
        lea   si,wsaveh
        mov   di,si
graloop1:
        push  cx
        mov   ah,0
        mov   cx,8
graloop2:
        cld
        lodsb
        clc
        shl   ax,1
        cmp   pass,1
        jne   nostore
        clc
        stosb
nostore:
        loop  graloop2
          mov   al,ah
graagain:
          call  sright
graloop3:
          pop  cx
          loop graloop1
; this ends the print loop
          ret
egraphx   endp
graright  db '&a+0288H',0
mright   proc   near
; this procedure moves to the right zcount dots
        mov  ax,zcount
        cmp  ax,0
        jg   mrcont
        ret
mrcont:
; must calculate this with great accuracy so it must be
; done in 2 parts
;
        mov  dx,0
        mov  ax,fright
        mul  zcount
        div  tenw
        cmp  dl,5
        jl   mnoround
        inc  ax
mnoround:
        call dodecimal
        mov  graright+4,dh
        mov  graright+5,dl
        mov  graright+6,ah
        mov  graright+7,al
        print graright
         ret
mright   endp
sright   proc   near
; print character in al
          mov   ah,0
          mov   dl,printer
          mov   dh,0
          int   17h
          mov   errorcode,ah
        ret
sright   endp
p216     db   '&a+000V',0
dot216   proc  near
; this procedure prints the 216 line spacing indicated by an esc J
          mov   cs:savess,ss
          mov   cs:savesp,sp
          mov   ax,cs
          cli
          mov   ss,ax
          mov   sp,offset cs:stack+124
          sti
          push  bx
          push  cx
          push  dx
          push  si
          push  di
          push  bp
          push  ds
          push  es
          mov   ax,cs
          mov   ds,ax
          mov   es,ax
          mov   ax,cs:t216
          mov   cs:t216,0
; here we are
; n/216 spacing
; sets n/216 line spacing
; in hp we have n/720
; this means we must multiply al by 10/3
;
;    we must set as 1 decimal places so its 100/3
;
     mov  dx,0       ; high word of mult
     mov  ah,0
     mov  multw,100  ; this gives us 1 decimal extra
     mul  multw
div3t:
;    now divide by 3 to get the total line count
     add  ax,15
     mov  multw,30
     div  multw
;    ax has the bytes which are 100 times too much
;    dx has the remainder 0 to 9
;  ax is now 7200/216 (100/3) the original
      call  dodecimal
;     dx:ax now has the decimal value of the string
      mov  p216+4,dl
      mov  p216+5,ah
      mov  p216+6,al
      print p216
          pop   es
          pop   ds
          pop   bp
          pop   di
          pop   si
          pop   dx
          pop   cx
          pop   bx
          cli
          mov   ss,cs:savess
          mov   sp,cs:savesp
          sti
          mov   ax,cs:saveax
          mov   ah,cs:errorcode
         ret
dot216   endp
cseg      ends
          end
