print macro string
lea dx,string
mov ah,9
int  21h
endm
; this is a program which displays cmos data
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org   100h
entry:
jmp  main
mess1    db 'CM1 copyright 1988 by Keith P. Graham',13,10,'$'
disp     db '            CMOS DATA DISPLAY',13,10,10
         db ' Time: '
cmtime   db '00:00:00    Date: '
cmdate   db '00/00/00',13,10,10
         db ' Diskette A: '
diska    db '0     Diskette B: '
diskb    db '0',13,10
         db ' Fixed disk 1: '
diskc    db '0   Fixed disk 2: '
diskd    db '0',13,10
         db ' Number of floppies '
fcount   db '0,'
         db ' Primary display '
pdisp    db '0,',13,10
         db ' Math Coprocessor '
copr     db '0',13,10
         db ' Checksum: '
checksumh dw '00','  '
checksuml dw '00'
         db 13,10,10
         db '$'
main      proc     near
         call  get_time
         call  get_date
         call  get_diskette
         call  get_fdisk
         call  get_equip
         call  get_chk
         print  disp
          int  20h
get_chk:
         mov  al,2eh
         call  get_cmbyte
         call  hex_it
         mov   checksumh,ax
         mov  al,2fh
         call  get_cmbyte
         call  hex_it
         mov   checksuml,ax
         ret
get_equip:
; get equipment info
         mov  al,14h
         call  get_cmbyte
; mask out count of bytes
         push  ax
         and   al,3
         or    al,30h
         inc   al
         mov   fcount,al
         pop   ax
         shr  al,1
         shr  al,1
         push  ax
         and   al,3
         or    al,30h
         mov   pdisp,al
         pop   ax
         shr  al,1
         shr  al,1
         shr  al,1
         shr  al,1
         and   al,1
         or    al,30h
         mov   copr,al
         ret
get_fdisk:
; gets the fixed disk byte
         mov  al,12h
         call  get_cmbyte
; convert to hex
         call  hex_it
         mov   diskc,al
         mov   diskd,ah
         ret
get_diskette:
; gets the diskette byte
         mov  al,16
         call  get_cmbyte
         call  hex_it
         mov   diska,al
         mov   diskb,ah
         ret
get_date:
; get date
         mov  al,7
         call  get_cmbyte
         call unpack
         mov  word ptr cmdate+3,ax
;  get_month
         mov  al,8
         call  get_cmbyte
         call unpack
         mov  word ptr cmdate,ax
;  get_year
         mov  al,9
         call  get_cmbyte
         call unpack
         mov  word ptr cmdate+6,ax
        ret
get_time:
;     get seconds
         mov  al,0
         call  get_cmbyte
;  al returns with the byte from cmos
;
         call unpack
         mov  word ptr cmtime+6,ax
;get minutes
         mov  al,2
         call  get_cmbyte
         call unpack
         mov  word ptr cmtime+3,ax
         mov  al,4
; get hours:
         call  get_cmbyte
         call unpack
         mov  word ptr cmtime,ax
     ret
get_cmbyte:
         out  70h,al
         nop
         nop
         in   al,71h
         ret
hex_it:
         mov  ah,al
         mov  cl,4
         shr  al,cl
         and  ah,0fh
         cmp  ah,9
         or   ax,3030h
         cmp  ah,39h
         jle  ok_ah
         add  ah,7
ok_ah:
         cmp  al,39h
         jle  ok_al
         add  al,7
ok_al:
         ret
unpack:
         mov  ah,al
         mov  cl,4
         shr  al,cl
         and  ah,0fh
         or   ax,3030h
         ret
main      endp
cseg      ends
          end      entry
