savess    dw 0
savesp    dw 0
command_line db 135 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute, first word is env
    dw command_line
tailds    dw  0
    dw 5ch ; fcb in psp
fcb1    dw  0
    dw 6ch ; fcb in psp
fcb2    dw  0
xerr   db 13,10,10,'Failure to execute command',13,10,'$'
lstack dw 256 dup(0)
;
exec_command:
; this routine will be able to execute a command in command_line
; set up a local stack
;
;
;
;  prepare for the exec function
;
;  call  shrink_mem
; find the comspec
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
   mov    ax,ds:[2ch]
   mov    parmblock,ax
;
   mov    es,word ptr  ds:[2ch]
   mov    di,0
   mov    cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
   jnc   come_back
; here is where we return
   cli
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
    mov   al,20h
    out   20h,al
    sti   ; enable interrupts
   print xerr
    stc
    ret
come_back:
   cli
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
    mov   al,20h
    out   20h,al
    sti   ; enable interrupts
    ret
shrink_mem:
; shrink memory
   push  cs
   lea   bx,last_byte    ; last byte of program
   add   bx,15    ; trick to round up
   mov   cl,4
   shr   bx,cl    ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah    ; shrink
   int   21h
   pop   es
;
    ret
;
;
;
