;
packbitsx:
public packbitsx
; si and di are set, cx has the length of line to unpack
               mov     bx,di   ; the string counter
	       MOV     dx,0  ; the counter
; get first byte of line here to prime pump
               lodsb
               mov     ah,al
; this is the loop for the 73 bytes of the line
mac_loop2:
;
;
; this loop is to pass through the 72 bytes looking for a
; string to compress
;
               dec     cx
               cmp     cx,0   ;have we done 72?
               jle     end_mac_loop1
; get the byte  ah has the last byte
;
	       LODSB
               cmp     dx,127
               jl      check_mac_rep
               jmp     no_mac_rep
; check to see if its a repeater
check_mac_rep:
               cmp     ah,al
               je      got_repeat
; here it is not a repeat, but do we have a repeat in the works?
               cmp     dx,0
               je      no_repeat
no_mac_rep:
; here we have a repeat in the works and must store it
	       PUSH    AX
               mov     al,dl
	       NEG     AL
	       STOSB
	       MOV     AL,ah
               xor     al,0ffh
	       STOSB
	       POP     AX
	       MOV     dx,0
	       MOV     ah,AL
               mov     bx,di
; we have finished out the repeat, now do the non_repeat
; the guy in ah is now a new guy, but er have to decide
; if he is the start of a new repeat or not
               jmp     mac_loop2
got_repeat:
; here we set up repeater stuff
; check to see if we are in an old string
; al=ah, so we are safe to assume we have a repeat
;
               inc     dx
	       MOV     ah,al
               mov     bx,di
               jmp     mac_loop2
no_repeat:
; here there is a non repeat in al
; ah has the last repeater
               xchg    ah,al
; find out if we have to initialize the count guy
               cmp     bx,di  ; are we at the first guy?
               jne     by_zero
; the first byte of a string of no repeats is the count
	       PUSH    AX
	       mov     AL,-1
	       STOSB
	       POP     AX
by_zero:
               xor     al,0ffh
	       STOSB
               inc     byte ptr es:[bx]
               jmp     mac_loop2  ; go back and get another
end_mac_loop1:
; check to see if there is anything in the works to wory about
               cmp     dx,0
               je      no_repeat1
; here we have a repeat in the works and must store it
               mov     al,dl
	       NEG     AL
	       STOSB
	       MOV     AL,ah
               xor     al,0ffh
	       STOSB
               mov     dx,0
               jmp     no_repeat2
no_repeat1:
; there must be a string in ah
               cmp     bx,di  ; are we at the first guy?
               jne     by_zero2
; the first byte of a string of no repeats is the count
	       mov     AL,-1
	       STOSB
by_zero2:
               mov     al,ah
               xor     al,0ffh
	       STOSB
               inc     byte ptr es:[bx]
no_repeat2:
; returns with si and di set and a line compressed from si to di
               ret
