print macro string
local no_printit
cmp  cs:qswitch,0
jne  no_printit
lea  dx,string
mov  ah,9
int 21h
no_printit:
endm
printe macro string
    push cs
    pop  es
    lea  di,string
    mov  bx,di
    mov  dx,di
    mov  al,'$'
    cld
    mov  cx,400
repne  scasb
    sub  di,bx
    mov  cx,di
    dec  cx
    mov  ah,40h
    mov  bx,2
    int  21h
endm
bsize   equ   2000h
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org   100h
start: jmp  main
hi  db 13,10,'STRIPT text file stripper',13,10
    db 'Copyright 1988 by Keith P. Graham',13,10,'$'
pstats db 12,13,10,10,10,'		STRIPT STATS',13,10,10,10
      db '	TOTAL WORDS:        '
prword db '00000',13,10,10
      db '	TOTAL SENTENCES:    '
prsent db '00000',13,10,10
      db '	TOTAL TEXT LINES:   '
prline db '00000',13,10,10
      db '	TOTAL PARAGRAPHS:   '
prpara db '00000',13,10,10
      db '	LETTER/WORD:        '
prletw db '000.00',13,10,10
      db '	WORD/SENTENCE:      '
prwdsn db '000.00',13,10,10
      db '	SENTENCE/PARAGRAPH: '
prsnpr db '000.00',13,10,12,'$'
wcount DW 0  ; word count
ccount DW 0  ; character count
scount DW 0  ; sentence count
gcount DW 0  ; paragraph count
lcount DW 0  ; line count
pcount dw 0  ; page count
acount dw 100 ; lines on current page
page_no dw 0 ; current page number
lperpage dw 55 ; lines per page
qswitch  db 0   ; quiet mode
pswitch  db 0   ; prettify
filein  db 80 dup(0)
fileout db 80 dup(0)
handlei dw 0
handleo dw 0
buffer  dw 0
buffer2 dw 0
emess1  db 13,10,'Error opening files',13,10,'$'
emess2  db 13,10,'Error reading file',13,10,'$'
emess3  db 13,10,'Error writing file',13,10,'$'
err1    db 13,10,'Memory Allocation Error',13,10,'$'
mess1   db 13,10,'Reading data from Standard Input',13,10,'$'
mess2   db 13,10,'Writing data to Standard Output',13,10,'$'
ppageno db 'Page No. '
ppage   db '000',13,10,10,'        '
;
check_page proc near
; checks page count for pretty printing
     push ax
     mov  ax,cs:acount
     cmp  cs:lperpage,ax
     pop  ax
     jle  top_page
     stosw
     ret
top_page:
; print the top of a page
     push si
     push cx
     push dx
     push ds
     push cs
     pop  ds
     cld
; increment the page number
     mov  acount,0
     inc  page_no
     mov  al,12
     stosb
; convert the page number to decimal
     mov  ax,page_no
     mov  cx,100
     mov  dx,0
     div  cx
     xchg dx,ax
     mov  cl,10
     div  cl
     or   ax,3030h
     or   dl,30h
     mov  ppage,dl
     mov  word ptr ppage+1,ax
     cmp  ppage,'0'
     jne  no_ppage0
     mov  ppage,' '
     cmp  ppage+1,'0'
     jne  no_ppage0
     mov  ppage+1,' '
no_ppage0:
; 8 byte left margin
     mov  al,20h
     mov  cx,8
rep  stosb
     mov  cx,50
     lea  si,filein
fploop:
     lodsb
     cmp  al,0
     je   efp
     dec  cx
     stosb
     jmp  fploop
efp:
     mov  al,20h
rep  stosb
     lea  si,ppageno
     mov  cx,15
rep  movsb
     pop  ds
     pop  dx
     pop  cx
     pop  si
     mov  ax,2020h
     ret
check_page endp
stats proc near
; this prints out the statistics at the end of the job
      push  cs
      pop   es
      lea   di,prword
      mov   ax,wcount
      call  bin2dec
      lea   di,prsent
      mov   ax,scount
      call  bin2dec
      lea   di,prpara
      mov   ax,gcount
      call  bin2dec
      lea   di,prline
      mov   ax,lcount
      call  bin2dec
; let per word
      mov   ax,ccount
      mov   cx,100
      mul   cx
      div   wcount
      lea   di,prletw
      call  bin2dec
      mov   ax,word ptr prletw+3
      mov   prletw+3,'.'
      mov   word ptr prletw+4,ax
; word per sent
      mov   ax,wcount
      mov   cx,100
      mul   cx
      div   scount
      lea   di,prwdsn
      call  bin2dec
      mov   ax,word ptr prwdsn+3
      mov   prwdsn+3,'.'
      mov   word ptr prwdsn+4,ax
; sent per para
      mov   ax,scount
      mov   cx,100
      mul   cx
      div   gcount
      lea   di,prsnpr
      call  bin2dec
      mov   ax,word ptr prsnpr+3
      mov   prsnpr+3,'.'
      mov   word ptr prsnpr+4,ax
      print pstats
      ret
bin2dec:
      mov  dx,0
      mov  cx,10000
      div  cx
      push dx
      mov  dx,0
      mov  cl,10
      div  cl
      or   al,30h
      cld
      stosb
      pop  ax
      mov  dx,0
      mov  cx,100
      div  cx
      mov  cl,10
      div  cl
      or   ax,3030h
      stosw
      mov  ax,dx
      mov  cl,10
      div  cl
      or   ax,3030h
      stosw
      ret
stats endp
strip proc near
      call  read_file
      cmp   ax,0
      jne   strip_it
      ret
strip_it:
      mov   cx,ax
      push  ds
      push  es
      mov   es,cs:buffer2
      mov   ds,cs:buffer
      cmp   cs:pswitch,0
      je    by_firstp
      call  check_page
      push  cx
      mov  al,20h
      mov  cx,8
      cld
rep   stosb
      pop cx
by_firstp:
      cld
; this loop will:
;     remove double spaces
;     make every line except double spaced line 56 bytes or more
      mov  bx,0  ; current guys in this line
      mov  dx,0  ; count of crlf's
      mov  ah,20h
strip_loop:
;  strip stuff
      cmp  cx,0
      jg   cont_sl
      push  ax
      push  bx
      push  dx
      call  write_file
      call  read_file
      pop   dx
      pop   bx
      mov   cx,ax
      cmp   ax,0
      pop   ax
      je    end_sl
      jmp   cont_sl
end_sl:
; finished with the stuff, have to close down, but is there
; a paragraph in the works
      cmp   dx,0
      jne   no_end_paragraph
      inc   cs:gcount
no_end_paragraph:
      pop   es
      pop   ds
      ret
cont_sl:
      dec  cx
      cld
      lodsb
strip_loop1:
; have a byte in al
      cmp   al,9   ; tab character
      jne   no_tab
      mov   al,20h
no_tab:
      cmp   al,20h
      je    handle_space
      cmp   al,12  ; page eject
      jne   no_12
      mov   al,10
no_12:
      cmp   al,10
      jne   no_ten
      jmp   strip_loop
no_ten:
      cmp   al,13
      je    handle_13
      cmp   al,'.'
      jne   not_dot
      inc   cs:scount
      dec   cs:ccount
not_dot:
      inc   cs:ccount
      inc   bx
      stosb
      mov   ah,al
      mov   dx,0
      jmp   strip_loop
handle_space:
      cmp   ah,20h
      jne   store_space
      jmp   strip_loop
store_space:
      mov   ah,al
      inc   cs:wcount
      cmp   bx,56
      jg    make_new_line
      stosb
      inc   bx
      mov   dx,0
      jmp   strip_loop
handle_13:
; dx has the count of previous lines without a character
      cmp   dx,0
      je    no_need_for_line
      mov   dx,0
      mov   ax,0a0dh
      stosw
      inc   cs:gcount
      inc   cs:acount
      cmp   cs:pswitch,0
      je    make_new_line
      call  check_page
      inc   cs:acount
      jmp   make_new_line
no_need_for_line:
      inc   cs:wcount
      mov   dx,1
      cmp   ah,20h
      je    no_e_space
      mov   ax,2020h
      stosb
no_e_space:
      jmp   strip_loop
make_new_line:
      inc   cs:lcount
      mov   dx,0
      mov   ax,0a0dh
      stosw
      inc   cs:acount
      cmp   cs:pswitch,0
      je    no_dspace
      call  check_page
      mov   ax,2020h
      stosw
      stosw
      stosw
      stosw
      inc   cs:acount
no_dspace:
      mov   ah,20h
      mov    bx,0
      jmp   strip_loop
strip endp
read_file proc near
; read stuff into buffer
      mov   ah,3fh
      mov   bx,cs:handlei
      mov   dx,0
      mov   cx,bsize
      push  ds
      mov   ds,cs:buffer
      int   21h
      pop    ds
      jc    bad_read
      mov   si,0
      ret
bad_read:
     mov    ax,cs
     mov    ds,ax
     mov    es,ax
     printe emess2
     int    20h
read_file endp
write_file proc near
; write stuff from buffer
; amount to write is in cx
      cmp   cs:handleo,0
      jne   do_rf
no_writef:
      clc
      ret
do_rf:
      cmp   di,0
      je    no_writef
      mov   cx,di
      mov   ah,40h
      mov   bx,cs:handleo
      mov   dx,0
      push  ds
      mov   ds,cs:buffer2
      int   21h
      pop    ds
      jc    bad_write
      mov   di,0
      ret
bad_write:
     mov    ax,cs
     mov    ds,ax
     mov    es,ax
     printe emess3
     int    20h
write_file endp
main      proc     near
          printe hi
          call  shrink
          call  buffalloc
          call  parse
          call  open_in
          call  open_out
          call  strip
          call  close
          call  stats
          int  20h
main      endp
open_in  proc near
      cmp  filein,0
      jne  open_i1
      mov  handlei,0
      printe mess1
      ret
open_i1:
      lea  dx,filein
      mov  ax,3d00h  ;open input
      mov  cx,0   ;read only
      int   21h
      jnc   good_open_i
      printe emess1
      int   20h
good_open_i:
      mov   handlei,ax
      ret
open_in  endp
open_out  proc near
      cmp  fileout,0
      jne  cont_oo
      mov  handleo,1
      printe mess2
      ret
cont_oo:
      lea  dx,fileout
      mov  ah,3ch  ;create
      mov  cx,0
      int   21h
      jnc   good_open_o
      printe emess1
      int   20h
good_open_o:
      mov   handleo,ax
      ret
open_out  endp
close proc near
     cmp   filein,0
     jne   close_i
     ret
close_i:
     mov   ah,3eh
     mov   bx,handlei
     int   21h
     cmp   fileout,0
     jne   close_o
     ret
close_o:
     mov   ah,3eh
     mov   bx,handleo
     int   21h
     ret
close endp
parse proc near
; process
; check for a switch
   mov  cl,byte ptr ds:[80h]
   mov  ch,0
   mov  di,81h
look_switch:
   cmp  cx,0
   jle  no_switch
   mov  al,'/'
   cld
repne scasb
   jne  no_switch
   mov  al,byte ptr es:[di]
   cmp  al,'P'
   je   switchp
   cmp  al,'p'
   je   switchp
   cmp  al,'Q'
   je   switchq
   cmp  al,'q'
   je   switchq
   jmp  do_switch
switchp:
   mov  pswitch,al
   jmp  do_switch
switchq:
   mov  qswitch,al
do_switch:
   dec  di
   mov  ax,2020h
   stosw
   jmp  look_switch
no_switch:
; parse input file name
   lea  di,filein
   mov  si,81h
p1:
   lodsb
   cmp  al,20h
   je   p1
   cmp  al,13
   je   p6
p2:
   stosb
   lodsb
   cmp   al,13
   je    p6
   cmp   al,20h
   je   p3
   jmp   p2
p3:
   lea  di,fileout
p4:
   lodsb
   cmp  al,20h
   je   p4
   cmp  al,13
   je   p6
p5:
   stosb
   lodsb
   cmp   al,13
   je    p6
   cmp   al,20h
   je   p6
   jmp   p5
p6:
    ret
parse endp
buffalloc proc  near
; GET SOME SPACE FOR THE files
        mov     ah,48h
        mov     bx,bsize/16
        int     21h
        cmp     bx,bsize/16
        je      goodget1
        printe  err1
        int     20h
goodget1:
        mov      buffer,ax
        mov     ah,48h
        mov     bx,bsize/8  ; twice as big for target
        int     21h
        cmp     bx,bsize/8
        je      goodget2
        printe  err1
        int     20h
goodget2:
        mov      buffer2,ax
        ret
buffalloc endp
LASTBYTE db 8 dup(0)
shrink	PROC	NEAR
; shrink
        lea    bx,lastbyte
        add    bx,15
        mov    cl,4
        shr    bx,cl
        mov    ah,4ah
        int    21h
; get stack space
        mov    ah,48h
        mov    bx,64   ;64*16 = 1024 bytes
        int    21h
; get return
        pop    bx
; set stack
        cli
        mov    sp,1020
        mov    ss,ax
        sti
        push   bx
        ret
shrink	ENDP
cseg      ends
          end      start
