dseg segment para public 'DATA'
ffield   struc
ftype     db ?
flen      db ?
fdec      db ?
fx        db ?
fy        db ?
fattrib   db ?
fattribd  db ?
ffil      db ?
foff      dw 0  ; field offset of where data goes
;ftemplate db ?  took out template for time being
ffield  ends
; field types
exit_phase  dw 0
public exit_phase
insrt_switch db 1   ; 1 is off to start
neg_sw     db 0
exponent   dw 0
phase     dw  0
lastbx    dw  14
linesi    dw  0
funclist  db      01  ;escp
          db      47h ;home
          db      48h ;up
          db      49h ;pgup
          db      4bh ;left
          db      4dh ;right
          db      4fh ;end
          db      50h ;down
          db      51h ;pgdn
          db      0fh ;tab
          db      0eh ;backspace
          db      53h ;del
          db      52h ;insrt
          db      3bh ;func
          db      3ch ;func
          db      3dh ;func
          db      3eh ;func
          db      3fh ;func
          db      40h ;func
          db      41h ;func
          db      42h ;func
          db      43h ;func
          db      44h ;func
          db      1ch ;return
funcllen  dw      $-funclist
dseg ends
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:dseg,es:dseg
main      proc     near
forms:
public forms
extrn reset_segs:near
 call reset_segs
;
;  ah has the attribute if we clear screen
;  al has the field to get if we want to get just 1 field
;  al has a 0ffh if we want to get all fields
;  al is 0 if we just want to display
;  bx has the field to start phase cronology from
;
; here we set up a general call to forms
; this is the main line of the display
;   clear the screen
          mov   linesi,si
          mov   phase,bx
          cmp   ah,0
          je    no_cls
          call  cls
no_cls:
          mov   cx,ds:[si]
          cmp   al,0ffh
          je    get_all
          cmp   al,0
          je    display_all
; get just 1 field
          mov   bl,al
          mov   bh,0
          shl   bx,1
          mov   si,linesi
          mov   si,ds:[si+bx+2]
          push  si
          mov   bx,lastbx
          call  form
          pop   si
          push  bx
          call  disp_formn
          pop   bx
          ret
;
display_all:
          inc   si
          inc   si
          call  dispscreen
          ret
get_all:
          mov   lastbx,14
          inc   si
          inc   si
          push  ax
          call  dispscreen
          pop   ax
; this is the loop for moving around fields
phaseloop:
          mov   si,linesi
          mov   bx,phase
          cmp   bx,0
          jge   not_low
          mov   bx,word ptr ds:[si]
          dec   bx
not_low:
          cmp   bx,word ptr ds:[si]
          jl    not_high
          mov   bx,0
not_high:
          mov   phase,bx
          shl   bx,1
          mov   si,word ptr ds:[si+bx+2]
          push  si
          mov   bx,lastbx
          call  form
          pop   si
          push  bx
          cmp   ftype[si],'D'
          je    not_disp0
          call  disp_formn
not_disp0:
          pop   bx
          mov   lastbx,bx
          jmp   cs:funcjmp1[bx]
dispscreen:
          cld
          lodsw
          push  si
          push  cx
          mov   si,ax
          call  disp_formn
          pop   cx
          pop   si
          loop  dispscreen
          ret
; here are the form funcjmps
;
escp1:
func1:
         push  bx
         mov   bx,phase
         mov   exit_phase,bx
         pop   bx
          ret      ;back to caller
home1:
          mov      phase,0
          mov      lastbx,14
          jmp      phaseloop
up1:
          dec      phase
          jmp      phaseloop
pgup1:
          ret      ;back to caller
left1:
          dec      phase
          jmp      phaseloop
right1:
          inc      phase
          jmp      phaseloop
jend1:
          mov      si,linesi
          mov      ax,ds:[si]
          dec      ax
          mov      phase,ax
          mov      lastbx,4
          jmp      phaseloop
down1:
          inc      phase
          jmp      phaseloop
pgdn1:
          ret      ;back to caller
jtab1:
          inc      phase
          jmp      phaseloop
backspace1:
          dec      phase
          jmp      phaseloop
del1:
          jmp      phaseloop
insrt1:
       xor  insrt_switch,1
          jmp      phaseloop
return1:
          inc      phase
          jmp      phaseloop
; here are the field funcjmps
escp:
func:
home:
up:
pgup:
jend:
down:
pgdn:
jtab:
return:
; all of these things cause a return
         ret
;
delete_char:
; move a character out of a string
       push  si
       push  di
; bp has the offset into the string, di has the start of the buffer
       mov   cl,flen[si]
       add   di,bp
       mov   si,di
       inc   si
       mov   ch,0
       sub   cx,bp
rep    movsb
;
       pop   di
       pop   si
       call  disp_form
       ret
left:
       dec  dx
       dec  bp
       cmp  bp,0
       jge  get_a_charx
       jmp  return
del:
       call  delete_char
get_a_charx:
       jmp  get_a_char
right:
       inc  dx
       inc  bp
       mov  ax,bp
       cmp     flen[si],al
       jg    get_a_charx
       mov   bx,10
       jmp  return
backspace:
       dec  dx
       dec  bp
       cmp  bp,0
       jge  ok_bs
       jmp  return
ok_bs:
       jmp   del
insrt:
       xor  insrt_switch,1
       jmp   get_a_char
;
; this is the jump line
funcjmp   dw      escp
          dw      home
          dw      up
          dw      pgup
          dw      left
          dw      right
          dw      jend
          dw      down
          dw      pgdn
          dw      jtab
          dw      backspace
          dw      del
          dw      insrt
          dw      func
          dw      func
          dw      func
          dw      func
          dw      func
          dw      func
          dw      func
          dw      func
          dw      func
          dw      func
          dw      return
funcjlen  dw      $-funcjmp
;  funcjump1 is the same as func jump except that it moves throug fields
funcjmp1  dw      escp1
          dw      home1
          dw      up1
          dw      pgup1
          dw      left1
          dw      right1
          dw      jend1
          dw      down1
          dw      pgdn1
          dw      jtab1
          dw      backspace1
          dw      del1
          dw      insrt1
          dw      func1
          dw      func1
          dw      func1
          dw      func1
          dw      func1
          dw      func1
          dw      func1
          dw      func1
          dw      func1
          dw      func1
          dw      return1
;
form:
; si has the address of the field to get
; di has the buffer where the answer goes
; first locate at the beginning of the field
; initially display the field
          cmp   ftype[si],'D'
          jne   not_disp
          ret
not_disp:
          call  disp_form
; relocate the cursor
          mov     dx,word ptr fx[si]
; dx has the row and column for display
          mov     bp,0   ; how far into the field
get_a_char:
          mov     ah,2
          mov     bx,0
          int     10h
; set the stage for an offset
          call   get_func ; get a function
          jc      no_func
          jmp     cs:funcjmp[bx]
no_func:
; this is a letter
       cmp  ftype[si],'N'
        jne  good_num
        cmp  ah,'.'
        je   do_dot
        cmp  ah,'+'
        je   do_plus
        cmp  ah,'-'
        je   do_neg
        cmp  ah,'0'
        jl   bad_num
        cmp  ah,'9'
        jg   bad_num
        jmp  good_num
bad_num:
        call blop
        jmp get_a_char
do_dot:
; must search out any other dots and fix them
do_neg:
; must put a minus sign in
do_plus:
; must toggle off a minus sign
good_num:
          call   put_char
          jmp    right
put_char:
; insrterts a character intot the buffer
; and dispalys the character
          cmp    insrt_switch,1
          jne    insrt_char
in_char:
; this replaces a character
          mov    bx,bp
          mov    al,ah
          mov    byte ptr ds:[di+bx],al
          mov     bl,fattrib[si]
          cmp    insrt_switch,1
          jne    redisp_char
          mov     cx,1
          mov     ah,9
          mov     bh,0
          int     10h
          ret
redisp_char:
       call  disp_form
          ret
insrt_char:
; opposite of delete a character
; move a character out of a string
       push  ax
       push  si
       push  di
; bp has the iffset into the string, di has the start of the buffer
       mov   cl,flen[si]
       add   di,bp
       mov   si,di
       inc   di
       mov   ch,0
       sub   cx,bp
       add   si,cx
       add   di,cx
       std
       inc   cx
rep    movsb
       cld
;
no_move:
       pop   di
       pop   si
       mov   cl,ffil[si]
       mov   bl,flen[si]
       mov   bh,0
       mov   byte ptr ds:[di+bx],cl
       pop   ax
       jmp   in_char
;
disp_formn:
          push    ax
          push    bx
          push    dx
          push    si
          mov     bl,fattribd[si]
          jmp    do_disp_form
disp_form:
; this displays the whole field
; terminates on 13 or 0 or length of field
          push    ax
          push    bx
          push    dx
          push    si
          mov     bl,fattrib[si]
do_disp_form:
       cld
       mov     di,foff[si]
          push    di
          mov     cl,flen[si]
          mov     ch,0
          mov     dx,word ptr fx[si]
          mov     si,di
df_loop:
          push    cx
          push    bx
          mov     ah,2
          mov     bx,0
          int     10h
          pop     bx
          inc     dx
          lodsb
          cmp     al,0
          jne     no_end_d
          pop     cx
          jmp     end_d_loop
no_end_d:
          mov     cx,1
          mov     ah,9
          mov     bh,0
          int     10h
          pop     cx
          loop    df_loop
end_d_loop:
          pop     di
          pop     si
          pop     dx
          pop     bx
          pop     ax
          ret
get_func:
; gets a key and translates it into a function
          push    di
          call    getkey
          xchg    al,ah
          lea     di,funclist
          cld
          mov     cx,funcllen
repne     scasb
          je      got_func
          mov     bx,0ffh
          pop     di
          stc
          ret
got_func:
          sub    cx,funcllen
          neg    cx
          dec    cx
          mov    bx,cx
          shl    bx,1
          pop    di
          clc
          ret
getkey:
; int 16 to get a keystroke
          mov    ah,0
          int     16h
          cmp     ax,250bh
          je      quit_it
          ret
quit_it:
          int     20h
cls:
; clear the screen
        push  ax
        mov   bh,ah
        mov   cx,0
        mov   dx,184fh  ; whole window
        mov   al,0
        mov   ah,7
        int   10h
        pop   ax
        ret
main      endp
blip        PROC  NEAR
            PUSH  SI
            MOV   SI,30
            CALL  tone
            POP   SI
            RET
blip        ENDP
blop        PROC  NEAR
            PUSH  SI
            MOV   SI,-30
            CALL  tone
            POP   SI
            RET
blop        ENDP
tone        PROC  NEAR
            PUSH  AX
            PUSH  BX
            PUSH  CX
            PUSH  DX
            MOV   DX,3        ; tone rate
            MOV   BX,240      ; starting freq
            MOV   CX,750      ; ending frequency
            CMP   SI,0
            JG    do_blip
; here we do blop
            MOV   BX,630      ; starting freq
            MOV   CX,150      ; ending frequency
do_blip:
; turn on tone
i0:
            PUSH  CX
            PUSH  BX
            IN    AL,61h
            OR    AL,3
            OUT   61h,AL
; loop parameters
            MOV   CX,BX
; set frequency
            MOV   DX,12h
            MOV   AX,34deh
            DIV   CX
            MOV   CX,AX
; set tone
            MOV   AL,CL
            OUT   42h,AL
            MOV   AL,CH
            OUT   42h,AL
i2:         LOOP  i2
            POP   BX
            POP   CX
            CMP   BX,CX
            JE    ip3
            ADD   BX,SI
            JMP   i0
ip3:
;turn off tone
            IN    AL,61h
            AND   AL,11111100b
            OUT   61h,AL
            POP   DX
            POP   CX
            POP   BX
            POP   AX
            RET
tone        ENDP
cseg      ends
          end
