registered equ 0
yuri equ 1
print macro string
mov  ah,9
mov  dx,offset string
int  21h
endm
cseg segment para public 'CODE'
  assume cs:CSEG,ds:CSEG,es:CSEG,ss:CSEG
  org 100h
top:
jmp start
sav_int08 dd 0;
ticks  dw 0
tickmax dw 0
screen_no  dw 0

int08_proc:
   pushf
   call cs:sav_int08
   push  ax
   mov   ax,cs:ticks
   inc   ax
   cmp   ax,cs:tickmax
   jge   do_ticks
   mov   cs:ticks,ax
   pop   ax
   jmp   next_08
do_ticks:
   mov   cs:ticks,0
   push  bx
   push  cx
   push  dx
   push  ds
   push  es
   mov   ax,'KG'
   mov   bx,'LA'
   mov   dx,cs:screen_no
   int   2fh
   pop   es
   pop   ds
   pop   dx
   pop   cx
   pop   bx
   pop   ax
next_08:
   iret
start:
; check the command line and say hello
     print hello
     mov   dx,offset error1
; scan for the first non space in command line
     mov   cl,byte ptr ds:[80h]
     mov  ch,0
     mov  si,81h
     cmp  cx,0
     jle  bad_line
line_scan:
     cld
     lodsb
     cmp   al,13
     je    bad_line
     cmp   al,'1'
     jl    line_loop
     cmp   al,'4'
     jg    line_loop
     jmp   got_line
line_loop:
     loop  line_scan
     jmp   bad_line
got_line:
     dec   al
     and   ax,0fh
     mov   screen_no,ax
; continue to see if there is a number of ticks
     mov   bx,0
     mov   dx,0
     mov   ax,0
     mov   tickmax,18
     jmp   tloop_bot
tloop:
     lodsb
     cmp   al,13
     je    t13
     mov   ah,0
     cmp   al,30h
     jl    tloop_bot
     cmp   al,39h
     jg    tloop_bot
     and   al,0fh
     xchg  ax,bx
     push  cx
     mov   cl,10
     mul   cl
     pop   cx
     add   bx,ax
tloop_bot:
     loop  tloop
t13:
     cmp   bx,0
     je    no_tick
     mov   tickmax,bx
no_tick:
; check to see if we are in DOS
     mov   ax,1600h
     int   2fh
     and   al,7fh
     mov  dx,offset error2
     cmp   al,0
     je    bad_line
; this sets the control break, also sets int08ical error
;
; int08_err first
;
            push  ds
            MOV   AX,3508h
            INT   21h
            MOV   word ptr sav_int08,BX  ;SAVE OFFSET
            MOV   word ptr sav_int08+2,ES      ;SAVE SEGMENT
            mov   DX,offset int08_proc
            MOV   AX,2508h
            INT   21h
            pop   ds
            mov   dx,offset start
            int  27h
bad_line:
     mov   ah,9
     int   21h
     int   20h
hello db 13,10,'XRAYWIN.COM V1.1 - Windows 386enh DOS Portion XRAY Screen Capture',13,10
if registered
      db ' *********** UNREGISTERED VERSION ***********',13,10
endif
if yuri
      db 'Copyright 1994 by Integrated Business Image Solutions, Inc.',13,10
else
      db 'Copyright 1994 by Keith P. Graham',13,10
       db 'BBS (914) 623-0039',13,10,10,'$'
endif
      db 13,10,'$'
error1 db 13,10,'ERROR in XRAYWIN.COM Command line!',13,10
      db 'You Must specify a screen number from 1 to 4',13,10
      db 'Example:',13,10
      db 'XRAYWIN 3',13,10,'$'
error2  db 'This program MUST be run in a DOS window',13,10,'$'
cseg ends
END top
